
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.dotcom.DotcomConfig"%>
<%--
* Component: cases
*
* Description:
*  Interface for uploading a study (to the given HUB), extracting it and importing to the worklist
*
* Parameters (multipart):
*
*   cFile         The content of the new DICOM object
*
* Last Updated     : $Author$
* Update Date Time : $Date$
* RCS File Name    : $RCSfile$
* RCS Revision     : $Revision$
* Locked by        : $Locker$
* Symbolic name    : $Name$
* State            : $State$
*
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.types.flag.IMTypeur"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	MultipartRequest mp = new MultipartRequest(request, IMEnvBase.getEnv("TMP"));

	String parFile     = mp.getParameter("cFile");
	//tmp file name will be in it
	
	String[] parStudyUIDs = mp.getParameterValues("cGr"); // StudyUID");
	String targetHUB     = mp.getParameter("cTargetHUB");

	//ez itten azt jelenti, hogy minden serverre el fogja kuldeni a multipart-ot, de ezzel nem tudunk mit tenni...

	Helper.DEBUG( "uploadImportStudy jsp called, parFile:" + parFile + " targetHUB:" + targetHUB + "; session ID: " + sess.getSessionId() + "; userid: " + sess.getUser().getUserId() );

	if( targetHUB != null && !"".equals( targetHUB ) && !targetHUB.equals( DotcomConfig.selfId() ) ) {
		//redirect, multi params are not needed, they will be included in writeMultipartBodyTo
		String device = DotcomConfig.getConfig().getServerNameTowards( targetHUB );
		if( device != null ) {
			String idBase = RedirectToolbox.getURL( device, sess.getClientAddress().getHostAddress(), null );
			if( idBase != null && !"".equals( idBase ) ) {
				StringBuilder sb = new StringBuilder( idBase );
				sb.append( "/cases/uploadImportStudy.jsp" );
				Helper.DEBUG( "uploadImportStudy redirected to:" + sb.toString() );
				response.sendRedirect( sb.toString() );
				return;
			}
		}
	}

	
	if (!mp.isMultiPart()) {
		Helper.DEBUG( "Not Multipart request" );
		%>FAILED<%
		return;
	}
	else {
		String tmpDirName = IMEnvBase.getEnv( "TMP" ) + "/importstudies." + System.currentTimeMillis();

		try {
			Helper.extractFilesFromZip( parFile, tmpDirName, false );
			DicomDirToolbox.startImporting( sess, parStudyUIDs, tmpDirName, true );
//			Helper.removeDirectoryRecursively( tmpDirName );
		}
		catch( Throwable th ) {
			Helper.ERRORLOG( "Exception in media import extracting (from " + parFile + " to " + tmpDirName + ") :" + Helper.throwable2String( th ) );
		}

		Helper.DEBUG( "return value:'FILE:" + parFile + "'" );
		
		out.print( "FILE:" + parFile );
		return;
	}
%>