<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: checkintegrity
 *
 * Description:
 *   Checks the integrity of a given study
 *
 * Params:
 *   cStudy   -  Study Instance UID of the study to be checked
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@
	page import="imagemed.checkintegrity.*,imagemed.jsputil.*,imagemed.imsession.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out );

	if ( !IfaceToolbox.isRegOK( is, true ) ) {
		IfaceToolbox.printError( is, "Has no registration info for this IP." );
		return;
	}

	is.createIMRequest( false );


	String parStudy = request.getParameter( "cStudy" );
	boolean isDoCorrection = "true".equals( request.getParameter( "cCorrection" ) );

	if ( parStudy == null ) {
		IfaceToolbox.printError( is, "Missing parameter: cStudy." );
		return;
	}

	ErrorList errors = new ErrorList( out, isDoCorrection );
	StudyIntegrity integrityChecker = new StudyIntegrity( parStudy, errors, null );

	try {
		integrityChecker.check();

		// Check study, display DEBUG, and try to correct detected errors in correction mode
		errors.handleErrors( out );

		int numError = errors.size();
		if ( numError == 0 ) {
			IfaceToolbox.printOK( is );
		}
		else {
			IfaceToolbox.printError( is, "Error occured while checking integrity." );
		}
	}
	catch ( Throwable th ) {
		IfaceToolbox.printError( is, "Exception caught during integrity check:" + th.toString() );
		th.printStackTrace( new java.io.PrintWriter( out ) );
	}
%>
--%>