<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: imadmin
 *
 * Description:
 *   Devices' settings
 *
 * Parameters:
 *
 *  Difficult
 *
-- %>
<%@page import="imagemed.layout.LayoutRoot"%>
<%@page import="imagemed.layout.OperatingMode"%>
<%@page import="com.erad.pacs.common.interfaces.action.DcAction"%>
<%@page import="com.erad.pacs.common.interfaces.result.SQLResult"%>
<%@page import="com.erad.pacs.common.interfaces.table.TopCell"%>
<%@page import="com.erad.pacs.common.interfaces.table.FieldManager"%>
<%@page import="imagemed.layout.LayoutPart"%>
<%@page import="imagemed.http.IMRequest"%>
<%@
	page import="java.util.*, java.sql.*, java.io.*,
			imagemed.exception.*, imagemed.jsputil.*, imagemed.types.date.*,
			imagemed.util.*, imagemed.imsession.*, imagemed.dotcom.*, imagemed.taskd.*,
			com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			imagemed.layout.datasource.*, imagemed.layout.validator.*, imagemed.layout.datasource.pointer.*,
			imagemed.scheduler.SchedulerInterface, imagemed.util.*, java.text.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%-- --- Helper Function(s) --- -- %><%!

	String targetTable = IMEnvBase.getEnv( "TARGETTBL" );
	String deviceServiceTable = IMEnvBase.getEnv( "DEVSERVTBL" );
	String categoryTable = IMEnvBase.getEnv( "DEVICECATTBL" );
	String catIDDBName = IMBaseFieldManagerImpl.staticGetDbName( "DCID" );
	String catNameDBName = IMBaseFieldManagerImpl.staticGetDbName( "DCNA" );
	String catParentDBName = IMBaseFieldManagerImpl.staticGetDbName( "DCPA" );%><%
	IMSession is = new IMSession( request, response, out );
	Syslog slog = new Syslog( "dicom", 0 , IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
	if ( !is.regOK() ) {
		slog.syslog( Syslog.LOG_DEBUG, "ERROR ADMIN unknown is not registered user" );
		return;
	}

	Defs casesDefs = new Defs( is, null );
	if ( is.regID == null ) {
		slog.syslog( Syslog.LOG_DEBUG, "ERROR ADMIN " + casesDefs.getUser() + " regID is null" );
		return;
	}
	boolean isRestricted = is.regRights.indexOf( "@" ) == -1;

	out.println( "<!--" + Helper.replace( Helper.request2String2( request ), "-->", "--><!--" ) + "-->" );

// ********** Input Parameters *********
	MultipartRequest mp = new MultipartRequest( is, IMEnvBase.getEnv( "TMP" ) );
	boolean isMP = mp.isMultiPart();

	IMRequest reqPar = is.imRequest;
	String context = reqPar.m_context;

	String parId       = mp.getParameter( "p_id" );
	String parHost     = mp.getParameter( "p_host" );
	String parPort     = mp.getParameter( "p_port" );
	String parProtocol = mp.getParameter( "p_protocol" );
	String parCategory = mp.getParameter( "p_category" );
	String parType     = mp.getParameter( "p_type" );
	String parOp       = mp.getParameter( "p_op" );
	String parPsc      = mp.getParameter( "p_psc" );
	String parCatID    = request.getParameter( "cDCID" );
	String parBack     = request.getParameter( "cBack" );

	String parTimeout = mp.getParameter( "p_toval" );
	String parTimeoutHd = mp.getParameter( "p_toval_hd" );

	String thisPage = "/imadmin/dicom.jsp";

	if ( parOp == null ) {
		if ( context == null || context.length() == 0 ) {
	context = reqPar.backupContext();
	// we did not have a context, redirect the page now.

	is.out.println( "<script language=\"JavaScript\">" );
	is.out.println( "document.location=\"" + thisPage + "?cContext=" + context + "\"" );
	is.out.println( "</script>" );
	return;
		}
		else {
	// just save the context
	reqPar.passAsFile( context );
		}
	}


// ********** Init *********

	DotcomDevice selfDevice = null;
	try {
		selfDevice = DotcomConfig.selfDevice();
	}
	catch ( IMException imEx ) {
	}

	boolean isDbOnly = ( selfDevice == null ? false : selfDevice.isDbOnly() );

	
	String reportWorkflowCfg = IMEnvBase.getEnv( "IFACE_REPORT_CONFIG_FILE" );
	String orderWorkflowCfg  = IMEnvBase.getEnv( "IFACE_ORDER_CONFIG_FILE" );
	String envDICOM_AET = IMEnvBase.getEnv( "DICOM_AE_TITLE" );
	Statement sql = IMEnv.getDB().createStatement();
	ResultSet rsDev;
	
	boolean pbscpCfg = false;
	boolean chHL7Cfg = false;
	boolean taskdCfg = false;
	
	if ( parId == null )
		parId = "";
	if ( parHost == null )
		parHost = "";
	if ( parPort == null )
		parPort = "104";
	if ( parProtocol == null )
		parProtocol = "T";
	if ( parCategory == null )
		parCategory = DicomToolbox.DEFAULTDEVICECATEGORY_WAN;
	if ( parType == null ) {
		if ( parId.length() == 0 ) {
	parType = DicomToolbox.getDeviceTypePropertyAsString( "D" );
		}
		else {
	parType = DicomToolbox.getType( parId );
	if ( parType == null ) {
		parType = DicomToolbox.getDeviceTypePropertyAsString( "D" );
	}
		}
	}
	if ( parOp == null )
		parOp = "";

	if (parTimeout == null)
		parTimeout = "";
	if (parTimeoutHd == null)
		parTimeoutHd = "";


//categories table inits

	DBLayoutDataSource dblds = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.DEVICECATLAYOUT );
	FieldManager fm = EntryLayoutFactory.getDefaultFieldManager( is, LayoutPart.DEVICECATLAYOUT );

	TableDescriptorImpl tdesc = new TableDescriptorImpl( thisPage, true, true, true, false );
	TablePropertiesImpl tprop = new TablePropertiesImpl();

	WorklistTableParamsImpl tparams = new WorklistTableParamsImpl( is, is.getProfileUser(), is.regRights.indexOf( 'A' ) > -1, is.isRegisteredViewer() );
	tparams.setDefaults( thisPage, is );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 20 );
	tdesc.setTableParams( tparams );

	tdesc.setTableProperties( tprop );
	tdesc.setFieldManager( fm );

	List<ActionImpl> act = new ArrayList<ActionImpl>();
	String idPart = "&cDCID=$$DCID$$";

	String editCategory = LocalizedMessage.getSimpleMessage( "ALT_TEXT_EDIT_CATEGORY" );
	String delCategory = LocalizedMessage.getSimpleMessage( "ALT_TEXT_DELETE_CATEGORY" );
	
	act.add( new LinkAction( tdesc, "DCID", "javascript:redirPage_b(\"dicom.jsp?p_op=Edit" + idPart + "\")",
	"<script language=\"JavaScript\">getImage(\'edit\', 18, 20, \' alt=\"" + editCategory + "\" title=\"" + editCategory + "\"\');</script>",
	editCategory ) );

	act.add( new LinkAction( tdesc, "DCID", "javascript:redirPage_b(\"dicom.jsp?p_op=DeleteCategory" + idPart + "\")",
	"<script language=\"JavaScript\">getImage(\'delete\', 18, 20, \' alt=\"" + delCategory + "\" title=\"" + delCategory + "\"\');</script>",
	delCategory ) );

	
	DualPropsConfigReader resourcesCfg = new DualPropsConfigReader( IMEnvBase.getEnv( "CONF" ) + "/resources.cfg", IMEnvBase.getEnv( "TASKD_HOME" ) + "/resources.cfg" );
	IMProperties resourceProps = resourcesCfg.getProperties();
	String netMax = resourceProps.getProperty( "System.NET" );
	
	ColumnImpl col = new ColumnImpl( new SimpleHeader( LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_MAX_CONN" ) + ": " + ( netMax == null ? LocalizedMessage.getSimpleMessage( "GENERIC_NOT_DEFINED" ) : netMax ) ), new ActionCell( "DCID", new ActionImpl[]{ new MultiAction( tprop, act.toArray( new ActionImpl[ 0 ] ) ) } ), "DCID" );

	tdesc.addExtraColumn( "_FIRST",col );


	List<TopCell> topCell = new ArrayList<TopCell>();

	TitleTopCell title = new TitleTopCell( tprop, LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_CATEGORIES" ) );
	title.clearWidth();

	topCell.add( title );

	topCell.add( new ListsTopCell( ListDescriptorImpl.LIST_DEVICECAT, tdesc, is.getProfileUser(), true) );
	topCell.add( new SeparatorTopCell( tprop, 4 ) );

	topCell.add( new SimpleTopCell( tprop,
		JSHelper.getJsButtonSLink( is, "javascript:redirPage_b('dicom.jsp?p_op=New')", "newButton", 0, 0, LocalizedMessage.getSimpleMessage( "ALT_TEXT_ADD_NEW_CAT") ) ) );
	topCell.add( new SeparatorTopCell( tprop, 4 ) );

	topCell.add( new FieldsTopCell( tdesc, null, true ) );
	topCell.add( new FiltersTopCell( tdesc, null, false, new String[ 0 ], true ) );
	topCell.add( new SortsTopCell( tdesc, null, false, true ) );

	topCell.add( new PageTopCell( tprop, tparams ) );

	tdesc.setTopCells( topCell );

	SQLResult result = new SQLResultImpl( tdesc, new String[] { "DCID" } );
	tdesc.setResult( result );

	TableImpl table = new TableImpl( tdesc );
%><HTML>
<HEAD><TITLE><%=LocalizedMessage.getSimpleMessage( "tabDevices" )%></TITLE>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly( is );
	TabToolbox.writeIMpopup( is.out );
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
%>
	<SCRIPT LANGUAGE="JavaScript">
		var pageContext="<%=context%>"

		function IMpopup(link,title) {
			window.open(link,title,
			'menubar=no,location=no,resizable=yes,scrollbars=yes,status=yes,width=600,height=300');
		}

		function doSubmit(frm, mod) {
			while (frm.p_op.value != mod) {
				frm.p_op.value=mod;
			}
			frm.submit();
		}

		function doTestPing(frm) {
			p_id = frm.p_id.value;
			p_host = frm.p_host.value;
			p_port = frm.p_port.value;
			p_protocol = frm.p_protocol.value;
			p_type = frm.p_type.value;
			link = "echo.jsp?cType="+p_type+"&cProtocol="+p_protocol+"&cPort="+p_port+"&cHost="+p_host+"&cId="+p_id;
			IMpopup(link, "ping");
		}
	</SCRIPT>
<%

	table.printScript( tparams,is );

%>
</HEAD>
<BODY>
<%
	TabToolbox.makeTabs( is, is.tabbean, "imadmin/dicom.jsp", "White" );

	if ( selfDevice == null ) {
		MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_DOTCOM_CONFIG_ERROR" ), "60%" );
		mb.setMessage( "<BR><font size=+1 color=\"red\">" + LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_DOTCOM_CONFIG_MISSING_CORRUPTED" ) + "</font><BR><BR>" );
		out.println( "<BR><CENTER>" );
		mb.print( is.out );
		out.println( "<CENTER><BR>" );
	}

// ********** Save Printer Config *********

	if ( parOp.equals( "Change" ) ) {
		DicomToolbox.setDicomPrinterCfg( mp.getParameter( "pr_cfg" ) );
		
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "deviceprintercfg" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_PRINTER_CFG, "true" );
		logEntry.log( slog, Syslog.LOG_INFO );

//		slog.syslog( Syslog.LOG_INFO, "INFO ADMIN deviceprintercfg " + casesDefs.getUser() + " - - - - - - - - - - - - - true - " );
	}

// ********** Enable ***********
	
	String lockFileMsg = LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_CANNOT_DELETE_LOCK_FILE" );
	String deleteErrorMsg = LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DELETE_ERROR_TITLE" );

	if ( parOp.equals( "Enable Entry" ) ) {
		if ( !IMNetScript.attachPeer( parId ) || is.regRights.indexOf( "@" ) == -1 ) {
	throw new IMGeneralException( lockFileMsg, "imadmin/dicom.jsp", deleteErrorMsg, "/imadmin/dicom.jsp" );
		}
	}

// ********** Enable / Disable ***********
	if ( parOp.equals( "Enable/Disable Entry" ) ) {
		if ( (is.regRights.indexOf( "@" ) == -1) && (is.regRights.indexOf( "A" ) == -1) ) {
	throw new IMGeneralException( lockFileMsg, "imadmin/dicom.jsp", deleteErrorMsg, "/imadmin/dicom.jsp" );
		}
		else {
	try {
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "deviceenable" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );

		long timeout = Long.parseLong( parTimeout ) * Long.parseLong( parTimeoutHd );
		if ( timeout > 5 * 24 * 60 ) {
	timeout = 5 * 24 * 60;
		}
		if (timeout <=0 ) {
	if ( IMNetScript.isPeerDown( parId ) && !IMNetScript.attachPeer( parId ) ) {
		throw new IMGeneralException( lockFileMsg, "imadmin/dicom.jsp", deleteErrorMsg, "/imadmin/dicom.jsp" );
	}
	else {
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, casesDefs.getUser() + " enabled the device " + parId );
		logEntry.log( slog, Syslog.LOG_INFO );
	}
		}
		else {
	if ( IMNetScript.isPeerDown( parId ) ) {
		IMNetScript.attachPeer( parId );
	}
	IMNetScript.detachPeer( parId, timeout );
	logEntry.setAction( "devicedisable" );
	logEntry.setField( OperLogEntry.FIELD.MESSAGE, casesDefs.getUser() + " disabled the device " + parId + " for " + ( timeout / 60 ) + " hours" );
	logEntry.log( slog, Syslog.LOG_INFO );
		}
	}
	catch ( Throwable th ) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_INVALID_TIMEOUT_VALUE" ), "imadmin/dicom.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_DISABLE_ERROR" ), "/imadmin/dicom.jsp" );
	}
		}
	}

// ********** Deleting *********
	if ( parOp.equals( "Delete Entry" ) ) {
		
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "devicedelete" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_ID, parId );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_HOST, parHost );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_PORT, parPort );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_PROTOCOL, parProtocol );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_CATEGORY, parCategory );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_TYPE, parType );
		
		if ( ( ("P".equals( parType )) || ("C".equals( parType )) || ("B".equals( parType )) || ("S".equals( parType )) ) && is.regRights.indexOf( "@" ) == -1 ) {
	logEntry.setField( OperLogEntry.FIELD.DEVICE_ERROR_MESSAGE, "no right" );
	logEntry.log( slog, Syslog.LOG_ERR );

//			slog.syslog( Syslog.LOG_ERR, "ERROR ADMIN devicedelete " + casesDefs.getUser() + " " + Syslog.logValue(parId) +" "+ Syslog.logValue(parHost) +" "+ Syslog.logValue(parPort) +" "+ Syslog.logValue(parProtocol) +" "+ Syslog.logValue( parCategory ) + " " + Syslog.logValue( parType ) + " - - - - - - - " + Syslog.logValue( "no right" ) );
	throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_NO_RIGHTS_REMOVE_PARENT_CHILD_DEVICES" ), "imadmin/dicom.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_REMOVE_ERROR" ), "/imadmin/dicom.jsp" );
		}
		int todo = DicomToolbox.removeDevice( parId );

		logEntry.log( slog, Syslog.LOG_INFO );

		// update actions, if any
		String[] actnames = is.imRequest.getVals( "p_actName" );
		String[] actusers = is.imRequest.getVals( "p_actUser" );
		String[] actlists = is.imRequest.getVals( "p_actList" );
		
		Helper.DEBUG( "names:" + Helper.toString( actnames ) );
		Helper.DEBUG( "users:" + Helper.toString( actusers ) );
		Helper.DEBUG( "lists:" + Helper.toString( actlists ) );
		
		if( actnames != null && actusers != null && actlists != null ) {
	for( int i = 0; i < actnames.length && i < actusers.length && i < actlists.length; i++ ) {
		DcActionImpl action = null;
		if( "Forward".equals( actnames[ i ] ) ) {
	action = new DcForwardImpl();
		}
		
		if( action != null ) {
	action.setList( actusers[ i ], actlists[ i ] );
	action.removeTarget( parId );
		}
	}
		}
		
		
//		slog.syslog( Syslog.LOG_INFO, "INFO ADMIN devicedelete " + casesDefs.getUser() + " " + Syslog.logValue( parId ) +" "+ Syslog.logValue(parHost) +" "+ Syslog.logValue(parPort) +" "+ Syslog.logValue(parProtocol) +" "+ Syslog.logValue(parCategory) +" "+ Syslog.logValue( parType ) +" - - - - - - - -" );
		
		if ( todo == 0 ) {
%>
			<script language="JavaScript">
				self.document.location="dicom.jsp";
			</script>
<%
	}
		else {
	out.println( DicomToolbox.getTodoConfirmForm( is, LocalizedMessage.getSimpleMessage( "GENERIC_CONFIRM_POST_DELETING_TASK" ), todo ) );
%></BODY></HTML><%
	return;
		}
	}

// ********** Addind *********

	if ( parOp.equals( "Add" ) ) {
		// checkData makes only syntactical checking
		String err = DicomToolbox.checkData( parId, parHost, parPort, "", "", "", "", "" );
		if ( ! "".equals( err ) ) {
	throw new IMGeneralException( err, "imadmin/dicom.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_DICOM_DEVICE_SETTING" ), null );
		}

		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "deviceadd" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_ID, parId );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_HOST, parHost );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_PORT, parPort );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_PROTOCOL, parProtocol );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_CATEGORY, parCategory );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_TYPE, parType );

		if ( isRestricted && ( ("C".equals( parType )) || ("P".equals( parType )) || ("B".equals( parType )) || ("S".equals( parType )) || ("H".equals( parType )) ) ) {
	logEntry.setField( OperLogEntry.FIELD.DEVICE_ERROR_MESSAGE, "no right" );
	logEntry.log( slog, Syslog.LOG_ERR );

//			slog.syslog( Syslog.LOG_ERR, "ERROR ADMIN deviceadd " + casesDefs.getUser() +" "+ Syslog.logValue(parId) +" "+ Syslog.logValue(parHost) +" "+ Syslog.logValue(parPort) +" "+ Syslog.logValue(parProtocol) +" "+ Syslog.logValue( parCategory ) +" "+ Syslog.logValue( parType ) +" - - - - - - - "+ Syslog.logValue( "no right" ) );
	throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_NO_RIGHTS_ADD_PARENT_CHILD_DEVICES" ), "imadmin/dicom.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_DEVICE_ADDING" ), "/imadmin/dicom.jsp" );
		}
/*		
		if (isDbOnly && (! isRestricted) && "P".equals(parType)){
	slog.syslog(Syslog.LOG_ERR, "ERROR ADMIN deviceadd "+ casesDefs.getUser() +" "+ Syslog.logValue(parId) +" "+ Syslog.logValue(parHost) +" "+ Syslog.logValue(parPort) +" "+ Syslog.logValue(parProtocol) +" "+ Syslog.logValue(parCategory) +" "+ Syslog.logValue(parType) +" - - - - - - - "+ Syslog.logValue("add parent devices"));
	throw new IMGeneralException("You could not add parent devices", "imadmin/dicom.jsp", "DICOM device adding Error", "/imadmin/dicom.jsp");	
		}
*/
		DicomToolbox.addDevice( is, parId, parHost, parPort, parType, parProtocol, parCategory );
	
		logEntry.log( slog, Syslog.LOG_INFO );

//			slog.syslog( Syslog.LOG_INFO, "INFO ADMIN deviceadd " + casesDefs.getUser() +" "+ Syslog.logValue(parId) +" "+ Syslog.logValue(parHost) +" "+ Syslog.logValue(parPort) +" "+ Syslog.logValue( parProtocol ) +" "+ Syslog.logValue( parCategory ) +" "+ Syslog.logValue( parType ) +" - - - - - - - -" );
%>
	<script language="JavaScript">
		self.document.location="editDevice.jsp?p_id=<%=parId%>&p_new=yes";
	</script>
<%
	return;
	}

// ********** DICOM Services table processing *********

	SystemConfig cfg = new SystemConfig();
	boolean isPsc = cfg.getPromiscuousMode() == DeviceConfig.DcBool.TRUE;

	IMProperties mwlCf = new IMProperties();
	mwlCf.recRead( IMEnvBase.getEnv( "DICOM_VAR" ) + "/mwl.cfg" );
	mwlCf.remove( "PEER" );
	mwlCf.remove( "PORT" );
	mwlCf.remove( "AE_TITLE" );
	String mwlFrom = mwlCf.getProperty( "FROM_DAYS", "-1" );
	String mwlTo = mwlCf.getProperty( "TO_DAYS", "1" );

	if ( "dcmServ".equals( parOp ) ) {
		isPsc = ( "true".equals( parPsc ) );
		cfg.setPromiscuousMode( isPsc ? DeviceConfig.DcBool.TRUE : DeviceConfig.DcBool.FALSE );
		pbscpCfg = true;

		mwlFrom = mp.getParameter( "p_MWLfrom" );
		mwlTo = mp.getParameter( "p_MWLto" );
		mwlCf.setProperty( "FROM_DAYS", mwlFrom );
		mwlCf.setProperty( "TO_DAYS", mwlTo );
		mwlCf.recWrite( IMEnvBase.getEnv( "DICOM_VAR" ) + "/mwl.cfg" );
		
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "deviceservices" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_SERVICES_MWL_FROM, mwlFrom );
		logEntry.setField( OperLogEntry.FIELD.DEVICE_SERVICES_MWL_TO, mwlTo );
		logEntry.log( slog, Syslog.LOG_INFO );

//		slog.syslog( Syslog.LOG_INFO, "INFO ADMIN Modality Worklist check changed "+ casesDefs.getUser() + ": mwlFrom: " +Syslog.logValue( mwlFrom )+ " mwlTo: " + Syslog.logValue( mwlTo ) );
	}

	String noRightsOperationMsg = LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_NO_RIGHTS_OPERATION" );
	String hackingErrorMsg = LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_HACKING_ERROR" );

// ********** HL7 Message table processing *********
	if ( "HL7msg".equals( parOp ) ) {
		throw new IMGeneralException( "No longer exists", "imadmin/dicom.jsp", "Unsupported operation", "/imadmin/dicom.jsp" );
	}

// ********** Report Workflow table processing *********
	if ( "wfRep".equals(parOp) ) {
		if (isRestricted) {
	throw new IMGeneralException( noRightsOperationMsg, "imadmin/dicom.jsp", hackingErrorMsg, "/imadmin/dicom.jsp");
		}
		String changes = DicomToolbox.processWFTable( DicomToolbox.REPORT, is );
		Helper.writeTextFile( reportWorkflowCfg, DicomToolbox.getIfaceConfig(DicomToolbox.REPORT) );
		
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "reportflow" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.CHANGES, changes );
		logEntry.log( slog, Syslog.LOG_INFO );

//		slog.syslog(Syslog.LOG_INFO, "INFO ADMIN Report Workflow table saved"+ casesDefs.getUser());
		out.println( DicomToolbox.getTodoConfirmForm( is, LocalizedMessage.getSimpleMessage( "GENERIC_CONFIRM_POST_EDITING_TASK" ), DicomToolbox.RECOLLECTDOTCOM ) );
%></BODY></HTML><%
	return;
	}

// ********** Order Workflow table processing *********
	if ( "wfOrd".equals(parOp) ) {
		if (isRestricted) {
	throw new IMGeneralException( noRightsOperationMsg, "imadmin/dicom.jsp", hackingErrorMsg, "/imadmin/dicom.jsp");
		}
		String changes = DicomToolbox.processWFTable( DicomToolbox.ORDER, is );
		Helper.writeTextFile( orderWorkflowCfg, DicomToolbox.getIfaceConfig(DicomToolbox.ORDER) );
		
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "orderflow" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.CHANGES, changes );
		logEntry.log( slog, Syslog.LOG_INFO );

//		slog.syslog(Syslog.LOG_INFO, "INFO ADMIN Order Workflow table saved"+ casesDefs.getUser());
		out.println( DicomToolbox.getTodoConfirmForm( is, LocalizedMessage.getSimpleMessage( "GENERIC_CONFIRM_POST_EDITING_TASK" ),  DicomToolbox.RECOLLECTDOTCOM ) );
%></BODY></HTML><%
	return;
	}

// ********** Refresh IP may change HL7 Config *********
	if ( mp.getParameter("refreshIP")!=null ) {
		Helper.writeTextFile( reportWorkflowCfg, DicomToolbox.getIfaceConfig('r') );
		Helper.writeTextFile( orderWorkflowCfg, DicomToolbox.getIfaceConfig('o') );
	}
//!!!Hot fix!

// ********** (confirmed) Restart components *********

	String[] compRestart = mp.getParameterValues("p_restart");
	if ( null != compRestart && 0 < compRestart.length ) {
		Helper.DEBUG( "comprestart len:" + compRestart.length );
		for ( int i = 0; i < compRestart.length; i++ ) {
	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, Syslog.logValue("componentrestart") );
	logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
	logEntry.setField( OperLogEntry.FIELD.COMPONENT_RESTART, compRestart[ i ] );

	try {
		DicomSrvToolbox.restart( compRestart[i] );
		logEntry.log( slog, Syslog.LOG_INFO );

//				slog.syslog(Syslog.LOG_INFO, "INFO ADMIN componentrestart (0) "+ casesDefs.getUser() +" "+ Syslog.logValue(compRestart[i]));
	}
	catch ( Throwable th ) {
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, "FAILED: " + th.getMessage() );
		logEntry.log( slog, Syslog.LOG_ERR );
		
//				slog.syslog(Syslog.LOG_ERR, "ERROR ADMIN componentrestart "+ casesDefs.getUser() +" error ");
		throw new IMGeneralException( th.getMessage(), "imadmin/dicom.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_DICOM_SERVER_RESTART" ), null );
	}
		}
	}

	String colWidth = "60";
	String uagent = is.userAgent;
	if (uagent != null && uagent.toLowerCase().indexOf("msie") != -1)
		colWidth = "90";

	String parUser = null; // for defs.jspi

// ********** HL7 Config Checking *********

	if ( "HL7cfgCheck".equals(parOp) ) {
		throw new IMGeneralException( "No longer exists", "imadmin/dicom.jsp", "Unsupported operation", "/imadmin/dicom.jsp" );
	}

// ********** Deleting/confirm *********
	if (parOp.equals("Delete")) {
%><BR><CENTER>
<FORM METHOD="POST" NAME=confirmForm action="/imadmin/dicom.jsp">
<%
	MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_CONFIRM_DELETE" ), "60%" );

		Format[] msgDelDeviceFormat = new Format[] { null };
		Object[] msgDelDeviceObject = new Object[] { Helper.htmlEncode( parId ) };
		String msgDelDevice = "";
		
		List<DcAction> actions = DicomToolbox.getFwdActionsWithTarget( parId );
		if( actions != null && actions.size() > 0 ) {
	boolean found = false;
	for( int i = 0; i < actions.size(); i++ ) {
		DcAction action = actions.get( i );
		if( action.isOnlyTarget( parId ) ) {
	if( !found ) {
		msgDelDevice += "<span class=FontErrorLight>" + LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_DEVICE_DELETE_WARNING" ) + "</span>";
	}
	Object[] msgDelActionObject = new Object[] { action.getName(), action.getUserID(), action.getListName() };
	msgDelDevice += LocalizedMessage.getCompoundMessage( "IMADMIN_DICOM_DEVICE_DELETE_WARNING_LISTS", msgDelDeviceFormat, msgDelActionObject, true );
	found = true;					
		}
%>				
				<INPUT TYPE=HIDDEN NAME="p_actName" VALUE="<%=Helper.htmlEncode( action.getName() )%>">
				<INPUT TYPE=HIDDEN NAME="p_actUser" VALUE="<%=Helper.htmlEncode( action.getUserID() )%>">
				<INPUT TYPE=HIDDEN NAME="p_actList" VALUE="<%=Helper.htmlEncode( action.getListName() )%>">
<%
	}
	if( found ) {
		msgDelDevice += "<BR>";
	}
		}
		
		// at fogjuk adni: user, list, action
		// ahol csak ez van, torolni, mashol kiszedni a targetek kozul
		
		msgDelDevice += LocalizedMessage.getCompoundMessage( "IMADMIN_DICOM_DELETE_DEVICE_MSG", msgDelDeviceFormat, msgDelDeviceObject, true);
		
		mb.setMessage( "<BR><H3>" + msgDelDevice + "</H3><BR><BR>" );
		mb.addButton( new Button( "javascript:doSubmit(self.document.confirmForm,'Delete Entry');", "BUTTON_DELETE", "BUTTON_DELETE_DEVICE_TITLE") );
		mb.addButton( new Button( "javascript:self.history.back();", "BUTTON_CANCEL", "BUTTON_CANCEL_TITLE" ) );
		mb.print( is.out );
%>
</CENTER>
<INPUT TYPE=HIDDEN NAME="p_id" VALUE="<%=Helper.htmlEncode( parId )%>">
<INPUT TYPE=HIDDEN NAME="p_type" VALUE="<%=Helper.htmlEncode( parType)%>">
<INPUT TYPE=HIDDEN NAME="p_op">
</FORM>
</BODY></HTML>
<%
	return;
	}

// ********** Disable/confirm *********
	if (parOp.equals("Enable/Disable")) {
%>
<BR>
<FORM METHOD="POST" NAME=confirmForm action="/imadmin/dicom.jsp">
<TABLE ALIGN=CENTER BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH=60%>
<TR class=HeaderRow><%=Helper.headerCell3D("  " + LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_SET_TIMEOUT" ) )%></TR>
<TR><TD class=BgLight align=center>
<BR>
<%
	Format[] msgTimeoutFormat = new Format[] { null };
	Object[] msgTimeoutObject = new Object[] { parId };
	String timeoutMsg = LocalizedMessage.getCompoundMessage( "IMADMIN_DICOM_SET_TIMEOUT_DEVICE", msgTimeoutFormat, msgTimeoutObject, true);
	out.print( timeoutMsg );
%> :  
<BR><BR>
<INPUT TYPE=HIDDEN NAME="p_id" VALUE="<%=parId%>">
<INPUT TYPE=HIDDEN NAME="p_type" VALUE="<%=parType%>">
<INPUT TYPE=HIDDEN NAME="p_op">
<INPUT NAME="p_toval" VALUE=2>
<SELECT NAME="p_toval_hd" >
<OPTION VALUE="1440">
	<%
		String termDAY = LocalizedMessage.getSimpleMessage( "termDAY" );
			out.print( termDAY.substring(0,1).toUpperCase() + termDAY.substring(1).toLowerCase() );
	%>
</OPTION>
<OPTION VALUE="60">
	<%
		String termHOUR = LocalizedMessage.getSimpleMessage( "termHOUR" );
			out.print( termHOUR.substring(0,1).toUpperCase() + termHOUR.substring(1).toLowerCase() );
	%>
</OPTION>
</SELECT>
<BR><BR>
<%=LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_MAXIMUM_TIMEOUT_MSG" )%>
</TD></TR>
<TR><TD class=BgShadow align=right>
<a href="javascript:doSubmit(self.document.confirmForm,'Enable/Disable Entry');"
onMouseOver="window.status='Enable/Disable Device'; return true">
	<%=JSHelper.getJsLocalizedButton( "BUTTON_OK", "BUTTON_NULL", false )%>
</a>

<a href="javascript:self.history.back();" onMouseOver="window.status='Cancel'; return true">
	<%=JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false )%>
</a>
</TD></TR>
</TABLE>
</FORM>
</BODY></HTML>
<%
	return;
	}

//************** Deleting Category
	else if ("DeleteCategorySure".equals( parOp ) ) {
		Statement st = IMEnv.getDB().createStatement();

		// get name for log
		String catName = "";
		ResultSet rs = st.executeQuery("select * from " + categoryTable + " where " + catIDDBName + "='" + parCatID + "'" );
		if( rs.next() ) {
	catName = rs.getString( catNameDBName );		
		}
		
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "devicecategorydelete" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, casesDefs.getUser() + " deleted the device category " + catName );  
		logEntry.log( slog, Syslog.LOG_INFO );

		//change other categories and devices' parent to null instead of this
		st.executeUpdate( "update " + categoryTable + " set " + catParentDBName + "=-1" +
	" where " + catParentDBName + "='" + parCatID + "'" );

		//it just to be sure, because if there's a device with this category, we don't allow deleting
		st.executeUpdate( "update " + targetTable + " set CATEGORYID=-1" +
	" where CATEGORYID='" + parCatID + "'" );
		
		st.executeUpdate( "delete from " + categoryTable + " where " + catIDDBName + "='" + parCatID + "'" );
	
		TaskToolbox.generateDeviceResourcesFile();
		
		out.println(DicomToolbox.getTodoConfirmForm( is, LocalizedMessage.getSimpleMessage( "GENERIC_CONFIRM_POST_DELETING_TASK" ), DicomToolbox.TASKDRESTART ) );
		return;
	}

	else if ("DeleteCategory".equals( parOp ) ) {
		Statement st = IMEnv.getDB().createStatement();
		String catName = "";
		
		ResultSet rs = st.executeQuery("select * from " + categoryTable + " where " + catIDDBName + "='" + parCatID + "'" );
		if( rs.next() ) {
	catName = rs.getString( catNameDBName );		
		}
		
		//if there's a device with this category, we don't allow deleting
		ResultSet rs2 = st.executeQuery( "select * from " + targetTable + " where CATEGORYID='" + parCatID + "'" );
%>
<BR>
<FORM METHOD="POST" NAME=confirmForm action="/imadmin/dicom.jsp">
<TABLE ALIGN=CENTER BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH=60%>
<%
	if( rs2.next() ) {
%>		
<TR class=HeaderRow><%=Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_PROBLEM_DELETE" ) )%></TR>

<TR><TD class="BgLight" align=center>
<BR><%=LocalizedMessage.getCompoundMessage( "IMADMIN_DICOM_DEVICES_ASSISGNED_CATEGORY", new Format[] { null }, new Object[] { catName }, true)%>
<BR><BR>
<a href="<%=parBack%>"><%=JSHelper.getJsLocalizedButton( "BUTTON_BACK", "BUTTON_NULL", false )%></a>
</TD></TR>
<%
	}
		else {
%>
<TR class=HeaderRow><%=Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_CONFIRM_DELETE" ) )%></TR>

<TR><TD class="BgLight" align=center>
<BR><%=LocalizedMessage.getCompoundMessage( "IMADMIN_DICOM_DELETE_CONFIRMATION", new Format[] { null }, new Object[] { catName }, true)%>
<BR><BR>
<INPUT TYPE=HIDDEN NAME="cDCID" VALUE="<%=parCatID%>">
<INPUT TYPE=HIDDEN NAME="cBack" VALUE="<%=parBack%>">
<INPUT TYPE=HIDDEN NAME="p_op">
</TD></TR>
<TR><TD class=BgShadow align=right>
<a href="javascript:doSubmit(self.document.confirmForm,'DeleteCategorySure');"
onMouseOver="window.status='Delete Category'; return true">
<%=JSHelper.getJsLocalizedButton( "BUTTON_DELETE", "BUTTON_NULL", false )%>
</a>

<a href="<%=parBack%>"><%=JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false )%></a>
</TD></TR>
<%
	}
%>
</TABLE>
</FORM>
</BODY></HTML>
<%
	return;
	}

	// new/edit category
	else if ( "New".equals(parOp) || "Edit".equals(parOp) ) {
		SchedulerInterface.putLabel( is, "IMADMIN_DICOM_DEVICE_CATEGORY", parOp );

		DBLDSEntry entry = null;
		String entryName = request.getParameter("cEntryName");
		if (entryName != null) {
	entry = DBLDSEntry.readFile(is, entryName, dblds);
	dblds.setEntry(entry);
	entry.initFromRequest(is.imRequest);
		}
		else {
	entry = new DBLDSEntry(dblds);
	dblds.setEntry(entry);
	  		if (!"New".equals(parOp)) {
	  			entry.initFromExisting(parCatID);
		  	}
		  	else {
	  			// create a default empty one
	  			entry.addRecord(dblds.getTable(), null); // root record
		  	}
		}
  		dblds.setRepeatPointer(dblds.getTable(), 0);
%>
    <FORM action="<%=thisPage%>" method=post name="saveForm" id="saveForm">
			<INPUT type="hidden" name="cBack" value="<%=request.getParameter("cBack")%>">
			<input type=hidden name=p_op value="Save">
<%
	if ( "New".equals(parOp) ||	"Yes".equals( request.getParameter("isNew") ) ) {
%>
			<input type=hidden name=isNew value="Yes">
<%
	}

		OperatingMode mode = LayoutPart.EDITING;
		LayoutRoot root = imagemed.layout.cache.LayoutCache.getSystemLayout(is, LayoutPart.DEVICECATLAYOUT);
		String html = root.getHtml("  "+("View".equals(parOp)?"":"  "), mode, dblds);

		out.println(html);
		String savedName = LDSEntry.writeFile(is, entry);
%>
		<input type=hidden name=cEntryName value="<%=savedName%>">
</FORM>
</body>
</html>
<%
	return;
	}

	//save category
	else if ( "Save".equals( parOp ) ) {
		//
		boolean isNew = "Yes".equals( request.getParameter("isNew") );
		
		DBLDSEntry entry = DBLDSEntry.readFile(is, request.getParameter("cEntryName"), dblds);
		dblds.setEntry(entry);
		entry.initFromRequest(is.imRequest);
		
		if (!Validator.doValidation(is, LayoutPart.DEVICECATLAYOUT, dblds, null, null )) {
	// form with errors or warnings displayed...
	return;
		}

		
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, isNew ? "devicecategorycreate" : "devicecategoryedit" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, casesDefs.getUser() + ( isNew ? " created " : " edited " ) + "the device category " + dblds.getValue( new FieldPointer( IMEnvBase.getEnv( "DEVICECATTBL" ), "DCNA" ) ) );  
		logEntry.log( slog, Syslog.LOG_INFO );

		boolean todoNeeded = false;
		
		Set<FieldInstancePointer> changedFIPs = entry.commit();
		for ( Iterator<FieldInstancePointer> i = changedFIPs.iterator(); i.hasNext(); ) {
	FieldInstancePointer fip = i.next();
	String colid = fip.m_sfieldID;
//			Helper.DEBUG( "Changed colid:" + colid );
	if( "DCPA".equals( colid ) || "DCRN".equals( colid ) ) {
		todoNeeded = true;
		break;
	}
		}

		if( todoNeeded ) {
	TaskToolbox.generateDeviceResourcesFile();
	out.println(DicomToolbox.getTodoConfirmForm( is, LocalizedMessage.getSimpleMessage( "GENERIC_CONFIRM_POST_EDITING_TASK" ), DicomToolbox.TASKDRESTART ) );
	return;
		}

		if (parBack != null && parBack.length() > 0) {
%><script language="JavaScript">
			document.location="<%=parBack%>";
</script><%
	//  		response.sendRedirect(parBack);
 			return;
		}
	}


// ********** Restarting/confirm *********

	if ( pbscpCfg )
		cfg.save();

	if ( taskdCfg ) {
		TaskToolbox.generateDeviceResourcesFile();
	}

	if ( pbscpCfg ||taskdCfg ) {
		String compList = "";
		String parList = "<INPUT TYPE=HIDDEN NAME='p_op'>\n";
		if (pbscpCfg) {
	compList = compList + " PBSCP";
	parList =  parList + "<INPUT type=hidden name='p_restart' value='dicom'>\n";
		}
		if (taskdCfg) {
	compList = compList + " TASKD";
	parList = parList + "<INPUT type=hidden name='p_restart' value='taskd'>\n";
		}
%>
<BR><CENTER>
<FORM METHOD="POST" NAME=confirmForm action="/imadmin/dicom.jsp">

<TABLE border=1 cellpadding=0 cellspacing=0 width="50%">
<TR><TD class=BgShadow align=center valign=middle colspan=1 height=18>
  <TABLE border=0 cellpadding=0 cellspacing=0 width="100%">
    <TR><TD class=FieldBlockT></TD></TR>
    <TR><TD class=FieldBlockC style="text-align: left" nowrap>
      <FONT size=2><%=LocalizedMessage.getSimpleMessage( "CONFIRMATION" )%></font>
    </TD></TR>
    <TR><TD class=FieldBlockB></TD></TR>
  </TABLE>
</TD></TR><TR><TD class=BgLight align="center">
  <BR>
  <%=LocalizedMessage.getCompoundMessage( "IMADMIN_DICOM_CONFIG_CHANGED_RESTART", new Format[] { null, null }, new Object[] { compList, parList }, true)%>
</TD></TR><TR><TD nowrap align=right CLASS=BgShadow><BR>
  <A href="javascript:doSubmit(self.document.confirmForm,'restart');">
  		<%=JSHelper.getJsLocalizedButton( "BUTTON_OK", "BUTTON_NULL", false )%>
  </A>
    &nbsp;&nbsp;
  <A href="/imadmin/dicom.jsp">
  		<%=JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false )%>
  	</A>
    &nbsp;&nbsp;
</TD></TR><TR>
  <TD class=FieldBlock></td>
</tr></table>

</FORM></CENTER>
</BODY></HTML>
<%
	return;
	}

//********** Saving Coercion *********
	if( parOp != null && parOp.startsWith("CoercionSave") ) {
		String parContent = is.request.getParameter("content");
		String mapID = parOp.substring( "CoercionSave".length() );
		
		String display = "Trailing";
		if ( "pre".equals( mapID ) ) {
	display = "Preceding";
		}
		else if ( "viewer".equals( mapID ) ) {
			display = "Viewer";
		}
		
		boolean parPropagate = "true".equals( mp.getParameter( "cPropagate" ) );

		int todo = DicomToolbox.writeMappingGlobal( mapID , parContent, display, is, parPropagate );
		
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "devicecoercion" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, casesDefs.getUser() + " changed the " + display + " coercion" );  
		logEntry.log( slog, Syslog.LOG_INFO );

		if ( (todo == DicomToolbox.NOTHING) || (todo == DicomToolbox.CHANGECOERCION ) ) {
%>
	<script language="JavaScript">
		self.document.location="dicom.jsp";
	</script>
<%
	}
		else {
	out.println(DicomToolbox.getTodoConfirmForm(is, LocalizedMessage.getSimpleMessage( "GENERIC_CONFIRM_POST_EDITING_TASK" ), todo));
		}
		return;

	}
	

//********** restarting on demand *********

	if ( parOp.equals( "todo" ) ) {
		int todo = 0;
		for (Enumeration<?> e = request.getParameterNames(); e.hasMoreElements();) {
	String next = (String) e.nextElement();
	if (!next.startsWith("p_todo_")) {
		continue;
	}
	todo |= Integer.parseInt(request.getParameter(next));
		}
		if ( todo > 0 ) {
	DicomToolbox.doTasks(is, todo);
		}
%>
	<script language="JavaScript">
		self.document.location="dicom.jsp";
	</script>
<%
	return;
	} // todo

	
  //*** Check License
	int nFlags = 0xFFFFFFFF;
	try {
		nFlags = Integer.parseInt(is.sessionVariables.getProperty("CTFlags"));
	}
	catch ( Throwable t ) {
	};
	boolean licHR = ( nFlags & 1 )!=0 ;
	boolean licQR = ( nFlags & 2 )!=0 ;
	StringBuffer forms = new StringBuffer( 1024 );
%>

<CENTER>
<%-- ********** Show table ********* -- %>
<FORM METHOD="POST" NAME="dcmForm">
<INPUT TYPE=HIDDEN NAME="p_op">
<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>
<tr>
<td class=BgShadow colspan=10><BR>&nbsp;&nbsp;<font size="4"><%=LocalizedMessage.getSimpleMessage( "tabDevices" )%></font><BR>&nbsp;</td></tr>
<%="<TR class=HeaderRow>"+
  Helper.headerCell3D("","left",4)+
  Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_ID" ))+
  Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_IP_HOST" ))+
  Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_PORT" ))+
  Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_PROTOCOL" ))+
  Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_TYPE" ))+
  Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_CATEGORY" )) + "</TR>"%>
  
<TR class=BgShadow>
<TD colspan=4><nobr>
  <A HREF="javascript:doSubmit(self.document.dcmForm,'Add');"
  onMouseOver="window.status='Add Device'; return true">
  		<%=JSHelper.getJsLocalizedButton( "BUTTON_ADD", "ALT_TEXT_ADD_DEVICE", false )%>
  </a>
<a href="javascript:doTestPing(self.document.dcmForm);"
onMouseOver="window.status='Test Device'; return true">
		<%=JSHelper.getJsLocalizedButton( "BUTTON_PING", "BUTTON_PING_TITLE", false )%>
</a>
</nobr></TD>
<TD>
<INPUT TYPE=TEXT NAME=p_id VALUE='<%=parId%>' SIZE=16 MAXLENGTH=24>
</TD>
<TD><INPUT TYPE=TEXT NAME=p_host VALUE="<%=parHost%>" SIZE=24 MAXLENGTH=32></TD>
<TD><INPUT TYPE=TEXT NAME=p_port VALUE="<%=parPort%>" SIZE=5 MAXLENGTH=5></TD>
<TD><SELECT NAME=p_protocol>
  <OPTION VALUE=T <%=parProtocol.charAt(0)=='T' ? " SELECTED" : ""%>>TCP
  <OPTION VALUE=S <%=parProtocol.charAt(0)=='S' ? " SELECTED" : ""%>>TLS
</SELECT></TD>
<TD>
<SELECT NAME=p_type>
<%
	//[B]ackup Target, Backup [S]ource, [C]hild, [D]icom, [H]L7, [P]arent, [V]iewer, [W]orkStation
	List<String> deviceTypesList = new ArrayList<String>(DicomToolbox.DEVICETYPES.stringPropertyNames());
	Collections.sort(deviceTypesList);
	for(String propertyName: deviceTypesList){
   		char t = DicomToolbox.getDeviceTypePropertyAsChar(propertyName);
   		if(t == '\0'){
   			continue;
   		}
		if (!licHR && t == 'H') {
	// HL7 device but no HL7 license
	continue;
		}
		if (t == 'W') {
	// Workstation type is obsolete, kept only for devices already configured as Workstation
	continue;
		}
		if ((is.regRights.indexOf("@") == -1) && ((t == 'C') || (t == 'P') || (t == 'B') || (t == 'S') || (t == 'H') )) {
	// adding Child/Parent, HL7, 'Backup Source'/'Backup Target' devices requires support right
	continue;
		}
		if (t == 'P' && selfDevice != null && selfDevice.getParent() != null) {
	// There is already a Parent device, do not offer Parent
	continue;
		}
%> 
	<OPTION VALUE="<%=t%>"<%=DicomToolbox.getDeviceTypePropertyAsChar(parType) ==t ? " selected" : ""%>> <%=propertyName%>
<%
	}
%>
</SELECT>
</TD>
<TD>
<SELECT NAME=p_category>
<%
	try ( Statement st = IMEnv.getDB().createStatement() ) {
	ResultSet rsCat = st.executeQuery( "select * from " + categoryTable + " order by " + catIDDBName );
	while ( rsCat.next() ) {
		String catID = rsCat.getString( catIDDBName );
		String catName = rsCat.getString( catNameDBName );
%>
		<OPTION VALUE="<%=catID%>"<%="1".equals( catID ) ? " selected" : ""%>><%=catName%></OPTION>
<%
			}
	}
		%>
</SELECT>
</TD>
</TR>
<%
	int row=0;
rsDev = sql.executeQuery( "select * from "+targetTable+" order by ID" );
while (rsDev.next()) {
	String id       = rsDev.getString("ID");
	String host     = rsDev.getString("HOST");
	String hostname = rsDev.getString("HOSTNAME");
	String protocol = rsDev.getString("PROTOCOL");
	String category = rsDev.getString("CATEGORYID");
	String port     = rsDev.getString("PORT");
	String ae       = rsDev.getString("AE");
	String type     = rsDev.getString("TYPE");
	String imagePart = "";
	if ("external".equals(IMEnv.getConfigProperty(IMEnv.ARCHIVE_CONF, "Archive"))) {
		boolean isExternalStore = id.equals(IMEnv.getConfigProperty(IMEnv.ARCHIVE_CONF, "ExternalStore"));
		boolean isExternalRetrieve = id.equals(IMEnv.getConfigProperty(IMEnv.ARCHIVE_CONF, "ExternalRetrieve"));
		if (isExternalStore) {
	if (isExternalRetrieve) {
		imagePart = "&nbsp;&nbsp;<img src=\"art/leftRightArrow.gif\" border=0>";
	}
	else {
		imagePart = "&nbsp;&nbsp;<img src=\"art/rightArrow.gif\" border=0>";
	}
		}
		else if (isExternalRetrieve) {
	imagePart = "&nbsp;&nbsp;<img src=\"art/leftArrow.gif\" border=0>";
		}
	}
	String typeLong="";
	typeLong = DicomToolbox.getDeviceTypePropertyAsString(type);

	String[] passNames  = {"p_id", "p_host", "p_port", "p_protocol", "p_category", "p_ae", "p_type"};
	String[] passValues = {   id , hostname,    port ,     protocol,  category,     ae ,    type };
%>
<TR class=BgShadow>
<TD align=center>

<%
	forms.append("<FORM METHOD=\"POST\" NAME=\"rowForm_"+row+"\" style=\"display: none;\">\n"+
	"<INPUT TYPE=HIDDEN NAME=\"p_op\">\n"+Helper.passAsForm(passNames,passValues)+"\n</FORM>\n");
	if (IMNetScript.isPeerDown(id)) {
	String date=Helper.longToDateTime(IMNetScript.getPeerDownExpireTime(id));
	date=date.substring(0,8)+"_"+date.substring(8,14);
	date=(new IMTypeDA_TM()).displayText(date);

	if ( (is.regRights.indexOf("@") == -1) && (is.regRights.indexOf("A") == -1)) {
%>	
<IMG SRC="/cases/art/semLocked.gif" ALT="Device disabled until <%=date%>" BORDER=none onMouseOver="window.status='Device disabled until <%=date%>'; return true">
		<%}
				else {
		%>
<A HREF="javascript:doSubmit(self.document.rowForm_<%=row%>,'Enable/Disable');" onMouseOver="window.status='Enable/Disable'; return true">
<IMG SRC="/cases/art/semLocked.gif" ALT="Device disabled until <%=date%>" BORDER=none ></A>	
		<%}
				}
			else {
	if ( (is.regRights.indexOf("@") == -1) && (is.regRights.indexOf("A") == -1) ) {
			%>	
<IMG SRC="/cases/art/semUnlocked.gif" ALT="Device Enabled" BORDER=none >
		<%}
		else {%>
<A HREF="javascript:doSubmit(self.document.rowForm_<%=row%>,'Enable/Disable');" onMouseOver="window.status='Enable/Disable'; return true">
<IMG SRC="/cases/art/semUnlocked.gif" ALT="Device Enabled" BORDER=none ></A>	
		<%}
}%>
</TD>

<TD align=center>
<%if (isRestricted && (("C".equals(type)) || ("P".equals(type)) || ("B".equals( type )) || ("S".equals( type )) || ("H".equals( type )) )) {%>
	&nbsp;
<%}
	else {%>
<A HREF="javascript:doSubmit(self.document.rowForm_<%=row%>,'Delete');"
	onMouseOver="window.status='Delete Device'; return true">
	<IMG SRC="/cases/art/delete.gif" ALT="Delete Device" BORDER=none></a>
<%}%>
</TD>
<TD align=center>
<A HREF="editDevice.jsp?p_id=<%=id%>"
onMouseOver="window.status='Edit Device'; return true">
<IMG SRC="/cases/art/edit.gif" ALT="Edit Device" BORDER=none></a>
</TD>
<TD align=center>
<A HREF="echo.jsp?p_id=<%=Helper.URLEncodeUTF8(id)%>"
onMouseOver="window.status='Send ECHO to Device'; return true">
<IMG SRC="/cases/art/ping.gif" ALT="Send Echo to Device" BORDER=none></a>
</TD>
<TD class=BgLight>&nbsp;<%=Helper.htmlEncode(id)+imagePart%></TD>
<TD class=BgLight>&nbsp;<%=Helper.htmlEncode(hostname)%></TD>
<TD class=BgLight>&nbsp;<%=Helper.htmlEncode(port)%></TD>
<TD class=BgLight>&nbsp;<%=protocol.charAt(0)=='T' ? "TCP" : "TLS"%></TD>
<TD class=BgLight>&nbsp;<%=Helper.htmlEncode(typeLong)%></TD>
<%
	try ( Statement st2 = IMEnv.getDB().createStatement() ) {
	ResultSet rsCat = st2.executeQuery( "select * from " + categoryTable + " where " + catIDDBName + "='" + category + "'" );
	String catName = "None";
	while ( rsCat.next() ) {  //will be 1
		catName = rsCat.getString( catNameDBName );
	
		if( catName == null ) {
	catName = "None";
		}
	}
%>	
	<TD class=BgLight>&nbsp;<%=Helper.htmlEncode(catName)%></TD>
<%
	}
%>
</TR>
<%
	row++;
}
%>
<TR><TD class=BgShadow colspan=10>
	<BR>
	&nbsp;&nbsp;
	<A HREF="/imadmin/resolve.jsp">   <B><U><%=LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_REFRESH_IP" )%></U></B>  </a>
	&nbsp;&nbsp;
	<A HREF="/imadmin/getdotcomconfig.jsp">   <B><U><%=LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_RECOLLECT_DOTCOM" )%></U></B>  </a>

<%
	if(is.regRights.indexOf("@") != -1 || is.regRights.indexOf("A") != -1) {
%>
&nbsp;&nbsp;
	<A HREF="/imadmin/validate.jsp">   <B><U><%=LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_VALIDATE_DOTCOM" )%></U></B>  </a>

<%
	String cmd[] = new String[2];
cmd[0] = "which";
cmd[1] = "dot";

RunCommandResult number = Helper.runCommandEx(cmd, null);

if (number.getExitCode() == 0) {

%>	

&nbsp;&nbsp;
	<A HREF="javascript:IMpopup('/dotcom/dotcomgraph.jsp')"><B><U><%=LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_SHOW_DOTCOM_HIERARCHY" )%></U></B></A>
&nbsp;&nbsp;
	<A HREF="javascript:IMpopup('/dotcom/neatograph.jsp')"><B><U><%=LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_SHOW_FULLSITE_STRUCTURE" )%></U></B></A>
<%
	}
}
%>

	<BR><BR>
</TD></TR>
</TABLE>
	</FORM>
	<%=forms.toString()%>
<BR>
<CENTER>
<%
	table.printTableTop(is);
  table.print(is);
%>
</CENTER>
<%=ListSaveForm.getListSaveForm( ListDescriptorImpl.LIST_DEVICECAT, is, tdesc)%>



<%-- ********** Services ********* -- %>
<br>
<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0 width="100%" class=BgShadow>
<FORM NAME='dcmServices' METHOD='POST'>
<TR><TD class=BgShadow><br>&nbsp;&nbsp;<font size="4"><%= LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_SERVICES" ) %></font><br>&nbsp;</TD></TR>

<%= "<TR class=HeaderRow>" + Helper.headerCell3D(LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_SERVICES_GENERAL" ), "center", DicomToolbox.DICOMService.values().length + 10 ) +"</TR>" %>
<TR><TD align="center">
<BR>
<% 
	StringBuffer input1 = new StringBuffer();
	StringBuffer input2 = new StringBuffer();
	input1.append("<INPUT TYPE=\"TEXT\" NAME=\"p_MWLfrom\" VALUE=\"" + mwlFrom + "\" SIZE=\"3\" MAXLENGTH=\"3\">");
	input2.append("<INPUT TYPE=\"TEXT\" NAME=\"p_MWLto\" VALUE=\"" + mwlTo + "\" SIZE=\"3\" MAXLENGTH=\"3\">");
%>
	<%=	LocalizedMessage.getCompoundMessage( "IMADMIN_DICOM_SERVICES_MW_CHECK", new Format[] { null , null }, new Object[] { input1.toString(), input2.toString() }, true) %>
<BR><BR>
</TD></TR><TR><TD>
<INPUT TYPE="HIDDEN" NAME="p_op">
	<CENTER>
	<B><%= LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_PROMISCUOUS_MODE" ) %></B>&nbsp;&nbsp;
<%
	if (SystemConfig.isPromiscuousModeDisabled()) {
%>
	<B><%= LocalizedMessage.getSimpleMessage( "termOFF" ) %></B>
<%
	}
	else {
%>
	<INPUT TYPE="CHECKBOX" NAME="p_psc" VALUE="true"<%= isPsc ? " CHECKED" : "" %>>
<%
	}
%>
	<BR>
	<A HREF="javascript:doSubmit(self.document.dcmServices,'dcmServ');"
	onMouseOver="window.status='Save General settings of DICOM services'; return true">
		<%= JSHelper.getJsLocalizedButton( "BUTTON_SAVE", "ALT_SAVE_GENERAL_SETTINGS_DICOM_SERVICES", false ) %>
	</a>
	</CENTER>
</TD></TR>
</FORM>
</TABLE>

<%

	if (licHR) {//beginningOf HIS/RIS specific settings

%><%-- ********** HL7 ********* -- %>
<br>
HL7 no longer exists
<br>

<%-- ********** Report ********* -- %>

<%=DicomToolbox.getReportWorkflowForm(is)%>

<%-- ********** Order ********* -- %>

<br>
<%=DicomToolbox.getOrderWorkflowForm(is)%>

<%

} //endOf HIS/RIS specific settings

%><%-- ********** Show printer config ********* -- %>

<BR>
<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0 width="100%" class=BgShadow>
<TR>
<TD><br>&nbsp;&nbsp;<font size="4"><%= LocalizedMessage.getSimpleMessage( "IMADMIN_DICOM_PRINTER_CONFIG" ) %></font><br>&nbsp;
</td></tr>
<tr><td>
<%
	File cfgFile = new File (IMEnvBase.getEnv("DCMTK_VAR") + "/printer.cfg");
	if (!cfgFile.exists())
		cfgFile = new File (IMEnvBase.getEnv("CASES_HOME") + "/printer.cfg");

	String cfgString = Helper.readTextFile(cfgFile.getPath());
%>
<center>
<FORM METHOD="POST" NAME="cfgForm">
<INPUT TYPE=HIDDEN NAME="p_op">
<TEXTAREA name="pr_cfg" WRAP="off" COLS="<%=colWidth%>" ROWS="20">
<%= Helper.htmlEncode(cfgString) %></TEXTAREA>
<BR>
</center></td></tr>
<tr><td><P align="right">
<A HREF="javascript:doSubmit(self.document.cfgForm,'Change');"
onMouseOver="window.status='Change Printer Configuration File'; return true">
	<%= JSHelper.getJsLocalizedButton( "BUTTON_SAVE", "ALT_CHANGE_PRINTER_CONFIG_FILE", false ) %>
</a>
<p>
</FORM>
</TD></TR></TABLE>
</CENTER>


<%-- ********** Data coercion comes here ********** -- %>

<FORM METHOD="POST" NAME="coerPreForm" ACTION="dicom.jsp">
	<INPUT TYPE=HIDDEN NAME="p_op">
<%
	is.out.println(DicomToolbox.getMappingForm("pre", "coerPreForm", true ) );
%>
</FORM>

<FORM METHOD="POST" NAME="coerPostForm" ACTION="dicom.jsp">
	<INPUT TYPE=HIDDEN NAME="p_op">
<%
	is.out.println(DicomToolbox.getMappingForm("post", "coerPostForm", true ) );
%>
</FORM>

<FORM METHOD="POST" NAME="coerViewerForm" ACTION="dicom.jsp">
	<INPUT TYPE=HIDDEN NAME="p_op">
<%
	is.out.println(DicomToolbox.getMappingForm(is, "viewer", "coerViewerForm", true ) );
%>
</FORM>

</BODY>
</HTML>
--%>