#!/bin/sh
#
# Component: prior
#
# Description:
#  OBSOLETE [7.0]
#  Starts retrieving prior studies for a given study
#
# Usage:
#   autoretrieve.sh <study>
#
#    study :   Study instance UID of the study to retrieve priors for
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

LOGGER=/usr/bin/logger
TAG=autoretrieve

study=$1

run_() # override run_ method
{
	[ -z "$study" ] && return 125

	$TASKD_HOME/runjavacmd -c "0 dotcom.AutoRetrieve -s \"$study\"" -p "$JAVA_SERVER_PORT"
	exit $?
}

cleanup_()
{
	$TASKD_HOME/runjavacmd -c "cleanup dotcom.AutoRetrieve -s \"$study\"" -p "$JAVA_SERVER_PORT"
}

print_()
{
	$TASKD_HOME/runjavacmd -c "print dotcom.AutoRetrieve -s \"$study\"" -p "$JAVA_SERVER_PORT"
}


# ################## #
#     START TASK     #
#                    #
# !!!!!!!!!!!!!!!!!! #
#                    #
#  !!  OBSOLETE  !!  #
#                    #
# ################## #

start=$2

if [ "$start" = "start" ] ; then
	echo "Calling autoretrieve.sh this way is obsolete. Create an autoretrieve.sh task instead" >&2 
	
	exit 1
fi

