<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: archive
 *
 * Description:
 *    WEB interface to get a study from the archive.
 *
 * Parameters:
 *
 *  @param study      Study Instance UID of the study to be retrieved from the Archive
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@
	page import="java.util.*,java.sql.*,
			imagemed.util.*,imagemed.jsputil.*,imagemed.exception.*,imagemed.imsession.*,imagemed.dotcom.Dotcom,imagemed.dcprocessing.StudyForwarder"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession(request, response, out);
	Properties parentPrp = null;
	try {
		parentPrp = DotcomToolbox.checkClient(is, "P", false);
	}
	catch (Throwable th) {
		String msg = th.getMessage();
		is.out.println((th == null ? "ERROR=Authorization required" : "ERROR=" + msg));
		return;
	}

	String parStudy = request.getParameter("study");
	if (parStudy == null || parentPrp == null) {
		is.out.println("ERROR=Missing Parameter");
		return;
	}

	imagemed.taskd.IMScriptContext context = imagemed.taskd.IMScriptContext.readJobContextFrom( request );	
	
	try {
		StoreState storestate = new StoreState(parStudy);
		storestate.load();

		if ("yes".equals(storestate.getAttribute("StudyOwner"))) {
			// Start study forward to parent
			StudyForwarder.forwardStudy(context, parStudy, parentPrp.getProperty("ID"), null, false, null);
			is.out.println("OK");
			return;
		}

		String ownerDevice = storestate.getAttribute("OwnerDevice");
		if (ownerDevice == null)
			throw new IMException("Neither StudyOwner nor OwnerDevice filled for study " + parStudy);

		Dotcom.proxyURL(is, ownerDevice, "/archive/fwd2parent.jsp", true, true);
	}
	catch (IMException imEx) {
		is.out.println("ERROR=" + imEx.getMessage());
	}
	catch (Throwable th) {
		is.out.println("ERROR=" + th.toString());
	}

	if (true) {
		// prevents putting extra new lines by tomcat
		return;
	}
%>
--%>