var imIFrames = new Array();

function loadImFrame( containerID, param, hash, forceReload ) {
	imIFrames[ containerID ].loadFrame( param, hash, forceReload );
};

function unCacheImFramePage( containerID, param ) {
	imIFrames[ containerID ].unCache( param );
};

function IMIframe( containerID, URLBase, shouldCache ) {
	imIFrames[ containerID ] = this;
	this.URLBase = URLBase;
	this.cache = new Array();
	this.shouldCache = shouldCache;
	this.currentFrame = null;
	this.rootElement = document.getElementById( containerID );
	this.rootElement.style.position = "relative";

	this.createFrame = function( param ) {
		if ( this.cache[ param ] != null ) {
			return this.cache[ param ];
		}
		var res = document.createElement( 'iframe' );
		res.frameBorder = "0";
		res.className = "imIframe";
		res.frameID = param;
		
		res.style.display="none";
		res.style.visibility="hidden";
		res.style.opacity=0;
		this.rootElement.appendChild( res );
		
		res.setAttribute( "src2", this.URLBase + param );
		res.setAttribute( "src", "/cases/darkTransitPage.jsp" );
		
		res.onload=function(){
			if (this.getAttribute("src" ) == this.getAttribute( "src2" ) ) {
				try {
					this.removeEventListener( "onload" );
				}
				catch (e) {
					this.onload = function(){ return; };
				}
				return;
			}
			this.style.visibility="visible";
			this.style.display="inline";
			this.style.opacity=1;
			this.setAttribute( "src", this.getAttribute( "src2" ) );
			};
		if ( this.shouldCache ) {
			this.cache[ param ] = res;
		}
		return res;
	};

	this.clearCache = function() {
		this.cache = new Array();
	}

	this.unCache = function( param ) {
		delete this.cache[ param ];
	}

	this.loadFrame = function( param, hash, forceReload ) {
		if ( this.currentFrame != null ) {
			if ( this.currentFrame.frameID == param && !forceReload ) {
				if ( hash ) {
					this.currentFrame.contentWindow.document.location.hash = hash;
				}
				// nothing to do
				return;
			}
			// detach
			this.currentFrame.style.display = "none";
		}
		this.currentFrame = this.createFrame( param );
		this.currentFrame.style.display = "";
		if ( hash ) {
			this.currentFrame.contentWindow.document.location.hash = hash;
		}
	};
}