// add possibility to include other .js files
function include( jsFile ) {
	document.write( '<script type="text/javascript" src="' + jsFile + '"></scr' + 'ipt>' );
}
// /scr + ipt is because of IE7

include( '/cases/js/imPopup.js' );

function jq( myid ) {
	return "#" + myid.replace(/[!"#$%&'()*+,.\/:;<=>?@[\\\]^`{|}~]/g, "\\$&");
    // return "#" + myid.replace( /(:|\.|\[|\]|,|&)/g, "\\$1" );
}

function getInternetExplorerVersion() {
	var rv = -1;
	if ( navigator.appName == 'Microsoft Internet Explorer' ) {
		var ua = navigator.userAgent;
		var re = new RegExp( "MSIE ([0-9]{1,}[\.0-9]{0,})" );
		if ( re.exec( ua ) != null )
			rv = parseFloat( RegExp.$1 );
	}
	else if ( navigator.appName == 'Netscape' ) {
		var ua = navigator.userAgent;
		var re = new RegExp( "Trident/.*rv:([0-9]{1,}[\.0-9]{0,})" );
		if ( re.exec( ua ) != null )
			rv = parseFloat( RegExp.$1 );
	}
	return rv;
};

// other stuff...
var ua = navigator.userAgent.toLowerCase();
var isIE = getInternetExplorerVersion() > -1;// ( ( ua.indexOf( "msie" ) != -1 ) && ( ua.indexOf( "opera" ) == -1 ) && ( ua.indexOf( "webtv" ) == -1 ) ) ? true : false;

var isFirefox = ua.indexOf( "firefox" ) != -1 ? true : false;

var isWebkit = ua.indexOf( "applewebkit" ) != -1;

// priority -> array of functions
// lower priority will be executed sooner
var loadEventMaps;

function execLoadEvents() {
	for (var priority = 0; priority < loadEventMaps.length; priority++) {
		for (var i = 0; i < loadEventMaps[ priority ].length; i++) {
			loadEventMaps[ priority ][ i ]();
		}
	}
};

function addLoadEvent( func, priority ) {
	if ( loadEventMaps == undefined ) {
		// init
		loadEventMaps = new Array();
		if ( typeof window.onload == 'function' ) {
			addLoadEvent( window.onload );
		}
		window.onload = execLoadEvents;
	}
	if ( !priority ) {
		priority = 0;
	}
	while ( priority + 1 > loadEventMaps.length ) {
		loadEventMaps.push( new Array() );
	}
	loadEventMaps[ priority ].push( func );
};

function callViewer( func, args ) {
	try {
		if ( isWebkit && app && typeof app.sendMessage == 'function' ) {
			app.sendMessage( func, args );
			return true;
		}
		else if ( isIE && window.external ) {
			// ugly hack to call methods of window.external with an array of parameters
			switch (args.length) {
			case 0:
				return window.external[ func ]();
			case 1:
				return window.external[ func ]( args[ 0 ] );
			case 2:
				return window.external[ func ]( args[ 0 ], args[ 1 ] );
			case 3:
				return window.external[ func ]( args[ 0 ], args[ 1 ], args[ 2 ] );
			}
			// window.external[ func ].apply( args );
			return false;
		}
		else {
			alert( 'callViewer failed: ' + typeof window.external[ func ] );
		}
	}
	catch ( e ) {
		alert( 'callViewer died: ' + e );
	}
	return false;
};

function startDrag( e, href ) {
	if ( !e ) {
		e = window.event;
	}
	e.dataTransfer.setData( "Text", href );
};

function checkWordChar( ch ) {
	if ( ch >= 'a' && ch <= 'z' )
		return true;
	if ( ch >= 'A' && ch <= 'Z' )
		return true;
	if ( ch >= '0' && ch <= '9' )
		return true;
	if ( ch == '_' || ch == '-' || ch == '\'' )
		return true;
	return false;
};

function alignRight( str, len ) {
	spaces = "";
	for (var i = 0; i < len; i++)
		spaces = spaces + " ";
	val = spaces + str;
	return val.substring( val.length - len );
};

function count( fld ) {
	if ( fld.id ) {
		fld = fld.id;
	}
	var str = getText( fld, true ).trim();
	try {
		var ccfld = my_getelementbyid( fld + "cc" );
		setIfChanged( ccfld, ""+str.length );
	}
	catch ( ex ) {}

	var bPrevWC = false;
	var wc = 0;
	for (var i = 0; i < str.length; i++) {
		var bWC = checkWordChar( str.charAt( i ) );
		if ( !bPrevWC && bWC ) {
			wc++;
		}
		bPrevWC = bWC;
	}
	try {
		var wcfld = my_getelementbyid( fld + "wc" );
		setIfChanged( wcfld, ""+wc );
	}
	catch ( ex ) {}
};

function setIfChanged(element, inner) {
	if ( element.innerHTML != inner ) {
		element.innerHTML = inner;
	}
}

function valueChanged() {
	bChanged = true;
};

function countAll( frm ) {
	count( frm.cText, frm );
	count( frm.cImpression, frm );
};

function doChange( type, target ) {
	bChanged = true;
};

function doEditChange( fld, wcfld, ccfld ) {
	count( fld, wcfld, ccfld );
	bChanged = true;
};

function goBackAndRelease( frm ) {
	self.location = frm.cBack.value;
};

function cancel( frm, backURL ) {
	frm.cBack.value = backURL;
	goBackAndRelease( frm );
};

function checkSubmit( frm, mod ) {
	var bSubmit = false;
	if ( bChanged ) {
		bSubmit = window.confirm( "You made changes in the report.\nWould you like to save changes?" );
	}

	if ( bSubmit ) {
		doSubmit( frm, mod );
	}
	else {
		goBackAndRelease( frm );
	}
};

// valueSelectorPopupTables related methods

function my_getelementbyid( id ) {
	if ( document.getElementById ) {
		return document.getElementById( id );
	}
	else if ( document.all ) {
		return document.all[ id ];
	}
	else if ( document.layers ) {
		return document.layers[ id ];
	}
	else {
		alert( "Browser not compatible" ); // TODO
	}
};

function applySelectedValue( inputID, inputVal, dispValues ) {
	dispNode = my_getelementbyid( "_FFDP_" + inputID );
	if ( dispNode ) {
		dispNode.value = dispValues;
	}
	my_getelementbyid( "qe__FFP_" + inputID ).value = inputVal;
};

// ----- input type specific value getter/setter methods begin -----

var shouldDEBUG = false;
var debugDIV;

function showDEBUG() {
	if ( debugDIV.style.display == "none" ) {
		debugDIV.style.display = "";
	}
	else {
		debugDIV.style.display = "none";
	}
}

function clearDEBUG() {
	debugDIV.innerHTML = "";
}

var DEBUG_TAB = "";
var DEBUG_TAB_INC = "&nbsp; &nbsp; ";
function inc_debug_tab() {
	DEBUG_TAB += DEBUG_TAB_INC;
};

function dec_debug_tab() {
	DEBUG_TAB = DEBUG_TAB.substr( DEBUG_TAB_INC.length );
};

function DEBUG( msg ) {
	if ( shouldDEBUG != true ) {
		return;
	}
	if ( !debugDIV ) {
		debugDIV = document.createElement( 'div' );
		debugDIV.style.backgroundColor = "#fff9c8";
		debugDIV.style.display = "none";
		document.body.appendChild( debugDIV );
		debugDIV.innerHTML = "<hr>";
	}
	if ( msg ) {
		debugDIV.innerHTML += DEBUG_TAB + htmlEncode( msg ) + "<br>";
	}
};

function getTagValue( id, defValue ) {
	try {
		return my_getelementbyid( id ).value;
	}
	catch ( nocare ) {}
	return defValue;
};

function setTagValue( id, value ) {
	try {
		my_getelementbyid( id ).value = value;
		return true;
	}
	catch ( nocare ) {}
	return false;
};

var lastFocusedElementID = null;

function setFocusHandler( fieldName ) {
	try {
		var newFocus = function() {
			setFocusedElement( this );
		};
		var nodes = getNodes( fieldName );
		for (var i = 0; i < nodes.length; i++) {
			var node = nodes[ i ];
			var oldfocus = node.onfocus;
			if ( typeof oldfocus != 'function' ) {
				node.onfocus = newFocus;
			}
			else {
				node.onfocus = function() {
					oldfocus();
					newFocus();
				};
			}
		}
	}
	catch ( e ) {
		// alert( "setFocusHandler: " + fieldName + " caused" + e );
	}
};

/**
 * this function focuses a html element preserving the scrolling position of the page
 */
function focusWithoutScrolling( element, forced ) {
	if ( document.activeElement == element && !forced ) {
		return;
	}
	var x0 = getScrollPositionX();
	var y0 = getScrollPositionY();
	element.focus();
	var x1 = getScrollPositionX();
	var y1 = getScrollPositionY();
	window.scrollBy( x0 - x1, y0 - y1 );
	// setScrollPosition( x, y );
}

function setFocusedElement( element ) {
	// let's try the easy way
	if ( INPUTS[ element.id ] ) {
		lastFocusedElementID = element.id;
	}
	else {
		// let's check who this node belongs to.
		for (var i = 0; i < INPUTS.length; i++) {
			var nodes = getNodes( INPUTS[ i ] );
			if ( nodes.indexOf( element ) != -1 ) {
				lastFocusedElementID = INPUTS[ i ];
				return;
			}
		}
	}
};

function getTextualInputTypes() {
	return "simple;simpleQE;rte;PN;TM;DA;DATM";
};

function getFocusedInputType() {
	if ( !lastFocusedElementID ) {
		return "";
	}
	var lastNodes = getNodes( lastFocusedElementID );
	if ( lastNodes.indexOf( document.activeElement ) != -1 ) {
		return TYPES[ lastFocusedElementID ];
	}
	return "";
};

function getFocusedFieldName() {
	try {
		return lastFocusedElementID;
	}
	catch ( e ) {}
	return null;
};

function getSelectionStart( fieldName ) {
	DEBUG( "called getSelectionStart(" + fieldName + ")" );
	var element = my_getelementbyid( fieldName );
	if ( !element ) {
		return null;
	}
	return getElementSelectionStart( element );
};

function isNLChar( text, pos ) {
	return text.charAt( pos ) == '\r' || text.charAt( pos ) == '\n';
};

function getElementSelectionStart( element ) {
	DEBUG( "called getElementSelectionStart(" + element + ")" );
	return getElementSelection( element )[ 0 ];
};

var rangeNLMoveCount = 1;

if ( isIE ) {
	addLoadEvent( function() {
		var div = document.createElement( "div" );
		document.body.appendChild( div );
		try {
			div.contentEditable = true;
			div.innerHTML = "<br>x";
			var rng = document.selection.createRange();
			rng.moveToElementText( div );
			var cnt = 0;
			while ( rng.compareEndPoints( "StartToEnd", rng ) != 0 ) {
				cnt++;
				rng.moveStart( "character", 1 );
			}
			rangeNLMoveCount = cnt - 1;
		}
		catch ( e ) {}
		finally {
			document.body.removeChild( div );
		}
	} );
}

function getRangePositionRteIE( element, range ) {
	var fullText = getText( element );
	var preRange = document.selection.createRange();
	preRange.moveToElementText( element );

	preRange.setEndPoint( 'EndToStart', range );
	var begin = getTextIE( preRange ).length;
	// check for trimmed linebreak at endpoints (\r\n\r\n)
	if ( preRange.htmlText.toLowerCase().endsWith( '</p>' ) && begin + 4 <= fullText.length ) {// && domRange.startContainer.nodeName != 'P' ) {
		preRange.moveEnd( 'character', 1 );
		if ( getTextIE( preRange ).length - begin > 2 ) {
			begin += 4;
		}
	}

	preRange.setEndPoint( 'EndToEnd', range );
	var end = getTextIE( preRange ).length;

	// check for trimmed linebreak at endpoints (\r\n\r\n)
	if ( preRange.htmlText.toLowerCase().endsWith( '</p>' ) && end + 4 <= fullText.length ) { // && domRange.endContainer.nodeName != 'P'
		preRange.moveEnd( 'character', 1 );
		if ( getTextIE( preRange ).length - end > 2 ) {
			end += 4;
		}
	}

	return [ begin, end ];

};

// set default config if not defined already (for CBT #1610)
if ( typeof dontUseHTML5SelectionMode === 'undefined' ) {
	dontUseHTML5SelectionMode = true;
}
if ( typeof dontUseClipboardForReplaceSelection === 'undefined' ) {
	dontUseClipboardForReplaceSelection = true;
}
if ( typeof useSmartStylePreservation === 'undefined' ) {
	useSmartStylePreservation = true;
}

function getElementSelection( element ) {
	DEBUG( "called getElementSelection(" + element + ")" );
	if ( isIE ) {
		// The current selection
		var fullText = getText( element );
		focusWithoutScrolling( element );
		if ( typeof element.selectionStart != 'undefined' ) {
			// textarea, ie11
			return [ element.selectionStart, element.selectionEnd ];
		}
		if ( useHTML5SelectionMode() ) {
			// the html5 way
			var sel = window.getSelection();
			var range = sel.getRangeAt( 0 );
			var begin = getTextDom( element, false, "", new RangeBoundary( range.startContainer, range.startOffset ) ).length;
			var end = getTextDom( element, false, "", new RangeBoundary( range.endContainer, range.endOffset ) ).length;
			DEBUG( "getElementSelection returns [" + begin + ", " + end + " ]" );
			return [ begin, end ];
		}
		if ( isRte( element ) ) {
			var range = document.selection.createRange();

			if ( document.createRange ) {
				return getRangePositionRteIE( element, range );
			}

			// focusWithoutScrolling( element );
			var fullRange = document.selection.createRange();
			fullRange.moveToElementText( element );
			var pos = 0;
			while ( fullRange.compareEndPoints( "StartToStart", range ) < 0 ) {
				pos++;
				fullRange.moveStart( "character", 1 );
				if ( isNLChar( fullText, pos - 1 ) && rangeNLMoveCount < 2 ) {
					// older IE moves past linebreaks in a single one character step
					// while ie10 requires two steps
					pos++;
				}
			}
			if ( pos > fullText.length ) {
				pos = fullText.length;
			}
			var begin = pos;
			while ( fullRange.compareEndPoints( "StartToEnd", range ) < 0 ) {
				pos++;
				fullRange.moveStart( "character", 1 );
				if ( isNLChar( fullText, pos - 1 ) && rangeNLMoveCount < 2 ) {
					pos++;
				}
			}
			if ( pos > fullText.length ) {
				pos = fullText.length;
			}
			DEBUG( "getElementSelection returns [" + begin + ", " + pos + " ]" );
			return [ begin, pos ];
		}
		var range = document.selection.createRange();
		// if ( range.text.length == 0 ) {
		// range.moveStart( 'character', -fullText.length );
		// return [ range.text.length, range.text.length ];
		// }
		// alert( "range=" + dumpObj( range ) );
		var fullRange = document.selection.createRange();
		fullRange.moveToElementText( element );
		// alert( "fullrange=" + dumpObj( fullRange ) );
		var pos = 0;
		while ( fullRange.compareEndPoints( "StartToStart", range ) < 0 ) {
			pos++;
			fullRange.moveStart( "character", 1 );
			if ( isNLChar( fullText, pos - 1 ) ) {
				pos++;
			}
		}
		var begin = pos;
		while ( fullRange.compareEndPoints( "StartToEnd", range ) < 0 ) {
			pos++;
			fullRange.moveStart( "character", 1 );
			if ( isNLChar( fullText, pos - 1 ) ) {
				pos++;
			}
		}
		return [ begin, pos ];
	}
	if ( isRte( element ) && isWebkit ) {
		focusWithoutScrolling( element );
		var sel = window.getSelection();
		var len = sel.toString().length;
		var range = sel.getRangeAt( 0 );
		var preCaretRange = range.cloneRange();
		preCaretRange.selectNodeContents( element );
		preCaretRange.setEnd( range.startContainer, range.startOffset );
		sel.removeAllRanges();
		sel.addRange( preCaretRange );
		var begin = sel.toString().length;
		sel.removeAllRanges();
		sel.addRange( range );
		return [ begin, begin + len ];
	}
	return [ element.selectionStart, element.selectionEnd ];
};

function isRte( obj ) {
	if ( obj.id ) {
		return "rte" == TYPES[ obj.id ];
	}
	return "rte" == TYPES[ obj ];
};

function getSelectionEnd( fieldName ) {
	DEBUG( "called getSelectionEnd(" + fieldName + ")" );
	var element = my_getelementbyid( fieldName );
	if ( !element ) {
		alert( "getSelectionEnd:element " + fieldName + " not found." );
		return null;
	}
	return getElementSelectionEnd( element );
};

function getFieldSelection( fieldName ) {
	DEBUG( "called getFieldSelection(" + fieldName + ")" );
	var element = my_getelementbyid( fieldName );
	if ( !element ) {
		alert( "getSelection:element " + fieldName + " not found." );
		return null;
	}
	return getElementSelection( element );
};

function getElementSelectionEnd( element ) {
	DEBUG( "called getElementSelectionEnd(" + element + ")" );
	return getElementSelection( element )[ 1 ];
};

var doClearMarkers = true;
var fieldMarkerBegin = "[[";
var fieldMarkerEnd = "]]";

function focusPrevMarker() {
	focusMarker( false, false );
};

function focusNextMarker() {
	focusMarker( false, true );
};

function markersEven( text ) {
	var balance = 0;
	var txt = text;
	var p = txt.indexOf( fieldMarkerBegin );
	while ( p > -1 ) {
		balance++;
		txt = txt.substr( p + fieldMarkerBegin.length );
		p = txt.indexOf( fieldMarkerBegin );
	}
	txt = text;
	p = txt.indexOf( fieldMarkerEnd );
	while ( p > -1 ) {
		balance--;
		txt = txt.substr( p + fieldMarkerEnd.length );
		p = txt.indexOf( fieldMarkerEnd );
	}
	return balance == 0;
};

function findTextIn( textRange, pattern, forward) {
	if ( textRange.text.indexOf( pattern ) > -1 ) {
		return textRange.findText( pattern, forward ? 0 : -1 );
	}
	return false;
}

/**
 * 
 * focuses the next/previous field marker ("[[...]]") on a canned report template
 * 
 * @param element element in which we search for the marker
 * @param isNext whether the next or the previous one is wanted
 * @return true if a prev/next marker was found and selected
 */
function focusMarker( element, isNext, doWrap ) {
	if ( !element ) {
		element = document.getElementById( getFocusedFieldName() );
	}
	if ( !element ) {
		return false;
	}
	if ( document.selection ) {
		focusWithoutScrolling( element );
				
		var range = document.selection.createRange();
		var endPoint1 = document.selection.createRange();
		endPoint1.moveToElementText( element );
		if ( !doWrap ) {
			endPoint1.setEndPoint( isNext ? "StartToStart" : "EndToStart", range );
			if ( isNext && range.text.startsWith( fieldMarkerBegin ) && range.text.endsWith( fieldMarkerEnd ) && markersEven( range.text ) ) {
				// a marker is selected, skip it's fieldMarkerBegin to get the next one.
				endPoint1.moveStart( "character", fieldMarkerBegin.length );
			}
		}
		// if ( endPoint1.findText( fieldMarkerBegin, isNext ? 0 : -1 ) ) {
		if ( findTextIn( endPoint1, fieldMarkerBegin, isNext ) ) {
			var endPoint2 = document.selection.createRange();
			endPoint2.moveToElementText( element );
			endPoint2.setEndPoint( "StartToEnd", endPoint1 );
			// while ( endPoint2.findText( fieldMarkerEnd, 0 ) ) {
			while ( findTextIn( endPoint2, fieldMarkerEnd, true ) ) {
				// we select stuff between endPoint1 and endPoint2
				endPoint1.setEndPoint( "EndToEnd", endPoint2 );
				// check whether we have found the matching close
				if ( markersEven( endPoint1.text ) ) {
					endPoint1.select();
					return true;
				}
				// not the matching one, go for the next close
				endPoint2.moveToElementText( element );
				endPoint2.setEndPoint( "StartToEnd", endPoint1 );
			}
		}
	}
	else  {
		// we do it text based
		var currentSel = getElementSelection( element );
		var fullText = getText( element );
		var selText = fullText.substring( currentSel[ 0 ], currentSel[ 1 ] );
		var p = doWrap ? ( isNext ? 0 : fullText.length ) : currentSel[ 0 ];
		if ( !doWrap && selText.startsWith( fieldMarkerBegin ) && markersEven( selText ) ) {
			// if we are standing on a selected field, we would find it again, so skip one marker ahead/back
			if (isNext) {
				p += fieldMarkerBegin.length;
			}
			else {
				if (p >= fieldMarkerBegin.length) {
					p -= fieldMarkerBegin.length;
				}
				else {
					if ( !doWrap ) {
						return focusMarker( element, isNext, true );
					}
					return false;
				}
			}
		}
		var begin = isNext ? fullText.indexOf( fieldMarkerBegin, p ) : fullText.lastIndexOf( fieldMarkerBegin, p );
		if ( begin > -1 ) {
			var end = begin + fieldMarkerBegin.length + fieldMarkerEnd.length;
			while ( end < fullText.length && !markersEven( fullText.substring( begin, end ) ) ) {
				end++;
			}
			if ( markersEven( fullText.substring( begin, end ) ) ) {
				setElementSelection( element, begin, end );
				return true;
			}
		}
	}
	if ( !doWrap ) {
		return focusMarker( element, isNext, true );
	}
	return false;
};

function clearMarker( element ) {
	if ( !element ) {
		element = document.getElementById( getFocusedFieldName() );
	}
	if ( !element ) {
		return false;
	}

	if ( typeof element.selectionStart != 'undefined' ) {
		// textarea style
		var fullText = element.innerHTML; // this is plain text, but trailing newlines are not trimmed like in innerText
		var selText = fullText.substring( element.selectionStart, element.selectionEnd );
		if ( selText.length >= fieldMarkerBegin.length + fieldMarkerEnd.length && selText.startsWith( fieldMarkerBegin ) && markersEven( selText ) ) {
			var pos = element.selectionStart;
			var trimmedText = selText.substring( fieldMarkerBegin.length, selText.length - fieldMarkerEnd.length );
			var newText = fullText.substring( 0 , pos ) + trimmedText + fullText.substring( element.selectionEnd );
			element.innerHTML = newText;
			element.selectionBegin = pos;
			element.selectionEnd = pos;
		}
		return true;
	}
	
	focusWithoutScrolling( element );
	if ( document.selection ) {
		var range = document.selection.createRange();
		var text = range.text;
		if ( text.length >= fieldMarkerBegin.length + fieldMarkerEnd.length && text.startsWith( fieldMarkerBegin ) && text.endsWith( fieldMarkerEnd ) ) {
			range.text = text.substr( fieldMarkerBegin.length, text.length - ( fieldMarkerBegin.length + fieldMarkerEnd.length ) );
		}
	}
	else {
		var currentSel = getElementSelection( element );
		var fullText = getText( element );
		var selText = fullText.substring( currentSel[ 0 ], currentSel[ 1 ] );
		if ( selText.length >= fieldMarkerBegin.length + fieldMarkerEnd.length && selText.startsWith( fieldMarkerBegin ) && markersEven( selText ) ) {

            range = window.getSelection().getRangeAt( 0 );
            range.deleteContents();
            var text = selText.substring( fieldMarkerBegin.length, selText.length - fieldMarkerEnd.length );
            if (text && text !== "") {
            	range.insertNode( document.createTextNode( text ) ); // test on textarea!
            }
			//document.execCommand( "insertText", false, selText.substring( fieldMarkerBegin.length, selText.length - fieldMarkerEnd.length ) );
		}
	}
};

function clearMarkers() {
	if ( !doClearMarkers ) {
		return;
	}
	for (var j = 0; j < INPUTS.length; j++) {
		var field = INPUTS[ j ];
		var element = getNode( field );
		if ( isRte( field ) ) {
			clearMarkersIn( returnRTE( field ) );
		}
		else if ( $( element ).is( "textarea" ) ) {
			clearMarkersIn( element );
		}
	}
};

function clearMarkersIn( element ) {
	if ( !element ) {
		element = document.getElementById( getFocusedFieldName() );
	}
	if ( !element ) {
		return false;
	}
	focusWithoutScrolling( element );
	while ( focusMarker( element, false ) ) {
		clearMarker( element );
	}
};

function dumpObj( obj, skipEmpty ) {
	var dump = "";
	for ( var i in obj) {
		if ( typeof obj[ i ] == 'function' ) {
			continue;
		}
		if ( !skipEmpty || obj[ i ] ) {
			dump += "\n" + i;
			dump += " -> " + obj[ i ];
		}
	}
	return dump;
};

function countTrailingBLs( text ) {
	if ( !text ) {
		return 0;
	}
	var res = 0;
	while ( text.endsWith( '\r\n' ) || text.endsWith( '\r\n ' ) ) {
		res++;
		text = text.substr( 0, text.lastIndexOf( '\r\n' ) );
	}
	return res;
};

function countHeadingBRs( text ) {
	if ( !text ) {
		return 0;
	}
	var res = 0;
	while ( text.startsWith( '\r\n' ) ) {
		res++;
		text = text.substr( 2 );
	}
	return res;
};

function getTextIE( element ) {
	var text = element.innerText;
	if ( typeof text === 'undefined' ) {
		text = element.text;
	}
	var html = element.innerHTML;
	if ( typeof html === 'undefined' ) {
		html = element.htmlText;
	}
	if ( document.getSelection && html.toLowerCase() == "<br>" ) {
		return ""; // ie11 mode represents empty value as <br> CBT #5025
	}
	if ( useHTML5SelectionMode() ) {
		// the html5 way
		return getTextDom( element );
	}
	html = html.replace( /\n/g, "" );
	html = html.replace( /\r/g, "" );
	html = html.replace( /&nbsp;/g, " " );
	html = html.replace( /&lt;/g, "<" );
	html = html.replace( /&gt;/g, ">" );
	html = html.replace( /&amp;/g, "&" );
	html = html.replace( /<br>/gi, "\r\n" );
	var len = html.length + 1; // trim all closing tags from the end.
	while ( len > html.length ) {
		len = html.length;
		html = html.replace( /<\/([^>]+)>$/i, "" );
	}
	html = html.replace( /<\/p>/gi, "\r\n\r\n" );
	html = html.replace( /<\/div>/gi, "\r\n" );
	html = html.replace( /(<([^>]+)>)/ig, "" );

	var nlToAdd = countTrailingBLs( html ) - countTrailingBLs( text );
	for (; nlToAdd > 0; nlToAdd--) {
		text = text + '\r\n';
	}
	// IE9 and up has a bad habit of introducing a linebreak (edit: any number of linebreaks) before the first paragraph if it is embedded in a span
	// this linebreak however is not visible, and also is messing up the selection positioning so we should get rid of it.
	while ( countHeadingBRs( text ) > countHeadingBRs( html ) ) {
		text = text.substr( 2 );
	}
	return text;
}

function getText( element, ignoreWhiteSpace ) {
	var id;
	if ( element.id ) {
		id = element.id;
	}
	else {
		id = element;
		element = my_getelementbyid( id );
	}
	if ( isRte( id ) ) {
		if ( isIE ) {
			element = returnRTE( id );
			if ( ignoreWhiteSpace ) {
				// for updating counters this will do
				return element.innerText;
			}
			return getTextIE( element );
		}
		if ( isWebkit ) {
			var res = returnRTE( id ).innerText;
			if ( res.endsWith( "\n" ) ) {
				// chrome adds an extra %0A to the end when there is one
				res = res.substr( 0, res.length - 1 );
			}
			return res;
		}
		return htmlDecode( returnRTE( id ).innerHTML );
	}
	if ( typeof element.value != "undefined" ) {
		return element.value;
	}
	if ( typeof element.innerText != "undefined" ) {
		return element.innerText;
	}
	if ( typeof element.textContent != "undefined" ) {
		return element.textContent;
	}
	alert( "cannot get inner text of element: " + id + dumpObj( element, true ) );
};

function htmlEncode( html, doNbspFix ) {
	html = html.replace( /&/g, "&amp;" );
	html = html.replace( /</g, "&lt;" );
	html = html.replace( />/g, "&gt;" );
	html = html.replace( /\n/g, "<br>" );
	html = html.replace( /\r/g, "" );
	html = html.replace( /\t/g, "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" );
	if ( doNbspFix ) {
		var p = html.lastIndexOf( "  " );
		while ( p > -1 ) {
			html = html.substr( 0, p ) + "&nbsp;" + html.substr( p + 1 );
			p = html.lastIndexOf( "  " );
		}
	}
	return html;
};

function htmlDecode( html ) {
	html = html.replace( /\n/g, "" );
	html = html.replace( /\r/g, "" );
	html = html.replace( /&nbsp;/g, " " );
	html = html.replace( /&lt;/g, "<" );
	html = html.replace( /&gt;/g, ">" );
	html = html.replace( /&amp;/g, "&" );
	html = html.replace( /<br>/gi, "\r\n" );
	html = html.replace( /<\/p>$/i, "" );
	html = html.replace( /<\/p>/gi, "\r\n" );
	html = html.replace( /<\/div>$/i, "" );
	html = html.replace( /<\/div>/gi, "\r\n" );
	html = html.replace( /(<([^>]+)>)/ig, "" );
	return html;
};

function fixNL( text, pos ) {
	if ( pos > text.length - 1 ) {
		return text.length - 1;
	}
	if ( pos < 0 ) {
		return 0;
	}
	if ( isNLChar( text, pos ) ) {
		// count NL chars preceeding this one. If they are odd, we are in the
		// middle
		// of a CR/LF..
		var i = pos;
		var cnt = 0;
		while ( i-- != -1 && isNLChar( text, i ) ) {
			cnt++;
		}
		if ( cnt % 2 ) {
			pos--;
		}
	}
	return pos;
};

function isLastChild( element ) {
	var parent = element.parentNode;
	if ( parent.lastChild != element ) {
		// might check whether any substantial siblings follow
		return false;
	}
	if ( parent.nodeName == "P" || parent.nodeName == "DIV" || parent.nodeName == "TD" || parent.nodeName == "TR" || parent.nodeName == "TABLE" ) {
		return true;
	}
	return isLastChild( parent );
};

function getLINum( liElement ) {
	if ( liElement.value ) {
		return parseInt( liElement.value );
	}
	else if ( liElement.previousSibling != null ) {
		return getLINum( liElement.previousSibling ) + 1;
	}
	return 1;
};

var gtptSet = new Array();

function getTweakedPlainText( rte ) {
	return getTextDom( returnRTE( rte ), true );
};

function getTextDom( element, useTweaks, precTxt, endBoundary, descended ) {
	gtptSet.splice( 0, gtptSet.length );
	return _getTextDom( element, useTweaks, precTxt, endBoundary, descended );
}

function _getTextDom( element, useTweaks, precTxt, endBoundary, descended ) {
	if ( gtptSet.indexOf( element ) != -1 ) {
		return "";
	}
	gtptSet.push( element ); // tag elements to avoid multiple traversing caused by malformed HTML fragments (overlapping tags usually)
	if ( element.style && element.style.display == "none" ) {
		return "";
	}
	if ( !precTxt ) {
		precTxt = "";
	}
	switch (element.nodeType) {
	case 1:
		var res = "";
		if ( precTxt.length > 0 && !precTxt.endsWith( "\r\n" ) && ( element.tagName == "DIV" || element.tagName == "P" || element.tagName == "TR" || element.tagName == "LI" || element.tagName == "UL" || element.tagName == "OL" ) ) {
			res += "\r\n";
		}

		var paragraphBreak = "\r\n\r\n";

		var childrenPrefix = res; // this will be used for children content generation (prefix text generated by LI made embedded DIV add linebreaks)

		if ( useTweaks || element.tagName == "P" ) {
			if ( element.tagName == "LI" ) {
				if ( element.parentNode.tagName == "UL" ) {
					res += "  *   "; // unordered list
				}
				if ( element.parentNode.tagName == "OL" ) {
					res += "  " + getLINum( element ) + ".   "; // ordered list
				}
			}
			else if ( element.tagName == "HR" ) {
				if ( precTxt.length > 0 && !precTxt.endsWith( "\r\n" ) ) {
					res += "\r\n";
				}
				res += "----------------------------------------------\r\n"; // ordered list
			}
			else if ( element.tagName == "P" ) {
				var marginBottom = parseFloat( $( element ).css( "margin-bottom" ) ); // bottom margin
				var em = parseFloat( $( element.parentNode ).css( "font-size" ) ); // parent's line height

				if ( marginBottom < em / 2 ) { // less than half line margin is rounded down
					paragraphBreak = "\r\n";
				}

				// check style class whether a double or single linebreak should follow
				// if ( !element.className || element.className == "erad" ) {
				// paragraphBreak = "\r\n";
				// }
			}
		}

		if ( element.hasChildNodes() ) {
			var chCnt = element.childNodes.length;
			if ( endBoundary && endBoundary.node == element ) {
				chCnt = endBoundary.position;
			}
			for (var i = 0; i < chCnt; i++) {
				var childRes = _getTextDom( element.childNodes.item( i ), useTweaks, precTxt + childrenPrefix, endBoundary, true );
				res += childRes;
				childrenPrefix += childRes;
				if ( endBoundary && endBoundary.found ) {
					return res;
				}
			}
		}
		if ( endBoundary && endBoundary.node == element ) {
			endBoundary.found = true;
			return res;
		}
		// for some element types we add a postfix (linebreaks mostly)
		if ( descended && !isLastChild( element ) || element.tagName == "BR" ) {
			if ( element.tagName == "P" ) {
				res += paragraphBreak;
			}
			else if ( element.tagName == "DIV" || element.tagName == "TR" || element.tagName == "BR" ) {
				res += "\r\n";
			}
			else if ( !res.endsWith( "\r\n" ) && ( element.tagName == "LI" || element.tagName == "UL" || element.tagName == "OL" ) ) {
				res += "\r\n";
			}
		}
		return res;
	case 3:
		var res = element.data;
		if ( endBoundary && endBoundary.node == element ) {
			endBoundary.found = true;
			res = res.substr( 0, endBoundary.position );
		}
		return text2disp( res, element.data );
	default:
		return "";
	}
};

function text2disp( text, fullText ) {
	if ( !fullText ) {
		fullText = text;
	}
	var res = text.replace( /\r/g, "" );
	res = res.replace( /\n/g, " " );
	res = res.replace( /\t/g, " " );
	res = res.replace( / +/g, " " );

	if ( res == " " && ( fullText == text || text2disp( fullText, fullText ) == "" ) ) {
		return "";
	}
	res = res.replace( /\xA0/g, " " );
	return res;
};

/**
 * node: reference node position: integer containing offset if node is a text node, boolean meaning (true -> position before node, false -> position after node) otherwise
 */
function RangeBoundary( node, position ) {

	this.node = node;

	this.position = position;

	this.applyTo = function( range, asBegin ) {
		if ( this.node.nodeType == 3 || ( isIE && this.position == 0 ) ) { // text node
			if ( asBegin ) {
				range.setStart( this.node, this.position );
			}
			else {
				range.setEnd( this.node, this.position );
			}
		}
		else {
			if ( isIE ) {
				// element Node, not before first child
				if ( asBegin ) {
					range.setStartAfter( this.node.childNodes[ this.position - 1 ] );
				}
				else {
					range.setEndAfter( this.node.childNodes[ this.position - 1 ] );
				}
				return;
			}
			if ( asBegin ) {
				if ( this.position ) {
					range.setStartBefore( this.node );
				}
				else {
					range.setStartAfter( this.node );
				}
			}
			else {
				if ( this.position ) {
					range.setEndBefore( this.node );
				}
				else {
					range.setEndAfter( this.node );
				}
			}
		}
	};
};

function textPosition2NodeOffsetRec( node, index ) {
	var sel = window.getSelection();
	var range = sel.getRangeAt( 0 );
	if ( node.nodeType == 3 ) {
		// this is a textnode which may contain the position
		range.setEnd( node, 0 );
		sel.removeAllRanges();
		sel.addRange( range );
		var selLen = sel.toString().length;
		if ( selLen >= index ) {
			return new RangeBoundary( node, 0 );
		}
		if ( selLen + node.data.length >= index ) {
			return new RangeBoundary( node, index - selLen );
		}
		return null;
	}
	range.setEndBefore( node );
	sel.removeAllRanges();
	sel.addRange( range );
	var selLen = sel.toString().length;
	if ( selLen >= index ) {
		return new RangeBoundary( node, true );
	}
	range.setEndAfter( node );
	sel.removeAllRanges();
	sel.addRange( range );
	var selLen = sel.toString().length;
	if ( selLen == index ) {
		return new RangeBoundary( node, false );
	}
	if ( selLen > index ) { // the position is inside this node
		for (var i = 0; i < node.childNodes.length; i++) {
			var res = textPosition2NodeOffsetRec( node.childNodes[ i ], index );
			if ( res != null ) {
				return res;
			}
		}
	}
	return null;
};

function textPosition2NodeOffsetHTML5( element, node, index ) {
	// the selection should be somewhere inside the node
	if ( element == node ) {
		// first of all traverse through text nodes as we prefer to return positions in them
		var textNode;
		var walk = document.createTreeWalker( element, NodeFilter.SHOW_TEXT, null, false );
		while ( textNode = walk.nextNode() ) {
			if ( getTextDom( element, false, "", new RangeBoundary( textNode, 0 ) ).length <= index && getTextDom( element, false, "", new RangeBoundary( textNode, textNode.data.length ) ).length >= index ) {
				return textPosition2NodeOffsetHTML5( element, textNode, index );
			}
		}
	}
	switch (node.nodeType) {
	case 1:
		if ( getTextDom( element, false, "", new RangeBoundary( node, 0 ) ).length >= index ) {
			// before the first child we are there
			return new RangeBoundary( node, 0 );
		}
		for (var i = 0; i < node.childNodes.length; i++) {
			var postPos = getTextDom( element, false, "", new RangeBoundary( node, i + 1 ) ).length;
			if ( postPos == index ) {
				return new RangeBoundary( node, i + 1 );
			}
			else if ( postPos > index ) {
				return textPosition2NodeOffsetHTML5( element, node.childNodes[ i ], index );
			}
		}
		// should not happen... return the end position anyway
		return new RangeBoundary( node, node.childNodes.length + 1 );
	case 3:
		var txtLen = index - getTextDom( element, false, "", new RangeBoundary( node, 0 ) ).length; // this is how long the selected substring should be displayed
		var offset = 0;
		// we look for the followign position because of collapsing whitespaces:
		// "a b" is displayed as "a b", position 1 should be after a which is the same as before the first space
		// position 2 should point to the end of the whitespace sequence which is not after the first whitespace(2), but after the whole sequence which means before b (4)
		while ( text2disp( node.data.substr( 0, offset ), node.data ).length <= txtLen && offset <= node.data.length ) {
			offset++;
		}
		return new RangeBoundary( node, offset - 1 );
	default:
		return null;
	}

};

function textPosition2NodeOffset( node, index ) {
	if ( isIE ) {
		return textPosition2NodeOffsetHTML5( node, node, index );
	}
	var sel = window.getSelection();
	var rngBackup = false;
	if ( sel.rangeCount > 0 ) {
		rngBackup = sel.getRangeAt( 0 );
	}
	sel.removeAllRanges();
	var range = document.createRange();
	range.selectNodeContents( node );
	range.collapse( true );
	sel.addRange( range );
	var res = null;
	for (var i = 0; i < node.childNodes.length; i++) {
		res = textPosition2NodeOffsetRec( node.childNodes[ i ], index );
		if ( res != null ) {
			break;
		}
	}
	sel.removeAllRanges();
	if ( rngBackup ) {
		sel.addRange( rngBackup );
	}
	return res;
};

function useHTML5SelectionMode() {
	if ( document.selection ) {
		if ( !document.getSelection ) {
			return false;
		}
		return !dontUseHTML5SelectionMode;
	}
	return true;
}

function setElementSelection( element, begin, end ) {
	inc_debug_tab();
	try {
		var cur = getElementSelection( element );
		if ( cur[ 0 ] == begin && cur[ 1 ] == end ) {
			if ( isRte( element ) && useHTML5SelectionMode() && document.selection) {
				document.selection.createRange().select();
			}
			return;
		}
		if ( isRte( element ) && useHTML5SelectionMode() ) {
			// the html5 way
			// treat speial cases as we seem to have occasional issues around the edges...
			var length = getText( element ).length;
			if ( begin > end || begin < 0 || end > length ) {
				// definitely should not happen
				// alert( "Invalid call to setElementSelection: begin=" + begin + ", end=" + end + ", element length=" + length );
				return;
			}

			var range = document.createRange();
			range.selectNodeContents( element );
			if ( begin == 0 ) {
				// already there :)
			}
			else if ( begin == length ) {
				// positioning to the end
				range.collapse( false );
			}
			else {
				var beginRB = textPosition2NodeOffset( element, begin );
				try {
					beginRB.applyTo( range, true );
				}
				catch ( e ) {
					alert( "failing call to setElementSelection: begin=" + begin + ", end=" + end + ", element length=" + length );
					alert( "setting range to " + beginRB.node + " (childCount=" + beginRB.node.childNodes.length + "), " + beginRB.position + " failed: " + e )
				}
			}
			if ( end == begin ) {
				// caret, just collapse the end to the begin
				range.collapse( true );
			}
			else if ( end == length ) {
				// already there :)
			}
			else {
				var endRB = textPosition2NodeOffset( element, end );
				endRB.applyTo( range, false );
			}
			var sel = window.getSelection();
			sel.removeAllRanges();
			sel.addRange( range );
			// also need to scroll the selection into view... I don't know how to do this with html5 tools only... so...
			if (document.selection) {
				document.selection.createRange().select();
			}
			return;
		}
		var fullText = getText( element );
		if ( end > fullText.length ) {
			end = fullText.length;
		}
		if ( begin > end ) {
			begin = end;
		}
		var moveEnd = end;
		var moveBegin = begin;
		var moveMinEnd = end;
		var moveMinBegin = begin;
		// \r\n should be counted as 1 or two characters
		if ( rangeNLMoveCount < 2 ) {
			for (var i = 0; i < end; i++) {
				if ( fullText.charAt( i ) == '\r' ) {
					moveEnd--;
					moveMinEnd--;
					if ( i < begin ) {
						moveBegin--;
						moveMinBegin--;
					}
				}
				if ( fullText.charAt( i ) == '\n' ) {
					moveMinEnd--;
					if ( i < begin ) {
						moveMinBegin--;
					}
				}
			}
		}
		if ( isRte( element ) ) {
			if ( isIE ) {
				focusWithoutScrolling( returnRTE( element.id ) );
				if ( begin === end && ( begin >= fullText.length || begin === 0 ) ) {
					// focus to begin/end
					var newRange = document.selection.createRange();
					newRange.moveToElementText( element );
					newRange.collapse( begin === 0 );
					newRange.select();
					return;
				}
				var newRange = document.selection.createRange();
				newRange.moveToElementText( element );
				newRange.collapse( true );
				if ( document.createRange ) {
					newRange.move( 'character', moveMinBegin );
					// we are at the target, minus the newlines, we will step forward from here until we arrive
					var lastRngSel = getRangePositionRteIE( element, newRange );
					var forceOver = end > begin ? 1 : 0; // if not an empty selection, enforce begin to move ahead adn then step back
					while ( lastRngSel[ 0 ] < begin + forceOver ) {
						newRange.move( 'character', 1 );
						var newRngSel = getRangePositionRteIE( element, newRange );
						var step = 2;
						while ( newRngSel[ 0 ] == lastRngSel[ 0 ] ) {
							// fucking stupid IE
							newRange.move( 'character', step++ );
							newRngSel = getRangePositionRteIE( element, newRange )
						}
						lastRngSel = newRngSel;
					}
					lastRngSel = getRangePositionRteIE( element, newRange );
					while ( lastRngSel[ 0 ] > begin ) {
						newRange.move( 'character', -1 );
						var newRngSel = getRangePositionRteIE( element, newRange );
						var step = -2;
						while ( newRngSel[ 0 ] == lastRngSel[ 0 ] ) {
							// fucking stupid IE
							newRange.move( 'character', step );
							newRngSel = getRangePositionRteIE( element, newRange )
							step--;
						}
						lastRngSel = newRngSel;
					}
					if ( end > begin ) {
						newRange.moveEnd( 'character', moveMinEnd - moveMinBegin );
						lastRngSel = getRangePositionRteIE( element, newRange );
						while ( lastRngSel[ 1 ] > end ) {
							newRange.moveEnd( 'character', -1 );
							var newRngSel = getRangePositionRteIE( element, newRange );
							var step = -2;
							while ( newRngSel[ 1 ] == lastRngSel[ 1 ] ) {
								// fucking stupid IE
								newRange.moveEnd( 'character', step-- );
								newRngSel = getRangePositionRteIE( element, newRange )
							}
							lastRngSel = newRngSel;
						}
						lastRngSel = getRangePositionRteIE( element, newRange );
						while ( lastRngSel[ 1 ] < end ) {
							newRange.moveEnd( 'character', 1 );
							var newRngSel = getRangePositionRteIE( element, newRange );
							var step = 2;
							while ( newRngSel[ 1 ] == lastRngSel[ 1 ] ) {
								// fucking stupid IE
								newRange.moveEnd( 'character', step++ );
								newRngSel = getRangePositionRteIE( element, newRange )
							}
							lastRngSel = newRngSel;
						}
					}
					newRange.select();
					return;
				}

				newRange.move( 'character', moveBegin );
				newRange.moveEnd( 'character', moveEnd - moveBegin );
				try {
					newRange.select();
				}
				catch ( e ) {
					alert( "calling setElementSelection(" + element.id + ", " + begin + ", " + end + ") caused " + e );
					throw e;
				}
				var sel = getElementSelection( element );
				if ( sel[ 1 ] < end && end > 0 ) {
					// selection failed, typically tried to overposition.
					// focus to the end
					newRange.moveToElementText( element );
					newRange.setEndPoint( "StartToEnd", newRange );
					newRange.select();
				}
				return;
			}
			if ( isWebkit ) {
				var range = document.createRange();
				var beginRB = textPosition2NodeOffset( element, begin );
				beginRB.applyTo( range, true );
				var endRB = textPosition2NodeOffset( element, end );
				endRB.applyTo( range, false );
				var sel = window.getSelection();
				sel.removeAllRanges();
				sel.addRange( range );
				return;
			}
		}
		if ( !isIE ) {
			element.selectionStart = begin;
			element.selectionEnd = end;
			return;
		}

		if ( element.createTextRange ) {
			var range = element.createTextRange();
			range.collapse( true );
			range.moveEnd( 'character', moveEnd );
			range.moveStart( 'character', moveBegin );
			range.select();
			return;
		}
		alert( "setElementSelection failed (no methods could be used)" );
	}
	finally {
		dec_debug_tab();
	}
};

function setSelection( fieldName, begin, end ) {
	DEBUG( "called setSelection(" + fieldName + ", " + begin + ", " + end + ")" );
	inc_debug_tab();
	try {
		var element = getNode( fieldName );
		if ( !element ) {
			return false;
		}
		setElementSelection( element, begin, end );
	}
	finally {
		dec_debug_tab();
	}
};

function getCompStyle( node, stylePrp ) {
	if ( node.nodeType == 3 ) {
		// text node do not have separate style definitions
		return getCompStyle( node.parentNode, stylePrp );
	}
	return $( node ).css( stylePrp );
};

/**
 * this method checks for styling applied to the cursor position (specified by execCommand) which are not yet reflected in the DOM structure yet. If there is such a styling, a span will be added with the appropriate styling which would be lost otherwise (unless using the command insertText which is not supported by IE)
 */
function enforceStylingIfNecessary( htmlContent ) {
	DEBUG( "called enforceStylingIfNecessary" );
	if ( !useSmartStylePreservation ) {
		DEBUG( "enforceStylingIfNecessary-0.5" );
		return false;
	}
	if ( document.getSelection ) {
		var selection = document.getSelection();
		var range = selection.getRangeAt( 0 );
		if ( !range.collapsed ) {
			// if the range is not collapsed, any applied styling is already in the HTML code around the selection
			DEBUG( "enforceStylingIfNecessary-1.0" );
			return false;
		}
	}
	else if ( document.selection ) {
		// compatibility mode :/
		if ( document.selection.type.toLowerCase() != "none" ) {
			DEBUG( "enforceStylingIfNecessary-1.5" );
			return false;
		}
	}
	else {
		DEBUG( "enforceStylingIfNecessary-2" );
		DEBUG( "d.s: " + document.selection );
		return false;
	}
	// get enclosing element to query style from
	var parentElement = null;
	if ( document.selection ) {
		parentElement = document.selection.createRange().parentElement();
	}
	else {
		parentElement = document.getSelection().getRangeAt( 0 ).startContainer;
	}

	// collect commands to be fixed
	var stateMap = new Array();

	var w = getCompStyle( parentElement, "font-weight" );
	if ( document.queryCommandState( "Bold" ) != ( w == 'bold' || w == '700' ) ) { // 700 means bold, 400 means normal
		stateMap.push( "bold" );
	}
	if ( document.queryCommandState( "italic" ) != ( 'italic' == getCompStyle( parentElement, "font-style" ).toLowerCase() ) ) {
		stateMap.push( "italic" );
	}
	var textDecoration = " " + getCompStyle( parentElement, "text-decoration" ) + " ";
	if ( document.queryCommandState( "underline" ) != ( textDecoration.indexOf( " underline " ) != -1 ) ) {
		stateMap.push( "underline" );
	}
	if ( document.queryCommandState( "strikeThrough" ) != ( textDecoration.indexOf( " strike-through " ) != -1 ) ) {
		stateMap.push( "strikeThrough" );
	}
	if ( document.queryCommandState( "Superscript" ) != ( $( parentElement ).closest( "sup" ).length > 0 ) ) {
		stateMap.push( "Superscript" );
	}
	if ( document.queryCommandState( "Subscript" ) != ( $( parentElement ).closest( "sub" ).length > 0 ) ) {
		stateMap.push( "Subscript" );
	}
	if ( stateMap.length == 0 ) {
		return false;
	}
	// now insert something and have it selected
	var rngTmp;
	if ( document.selection ) {
		rngTmp = document.selection.createRange();
		rngTmp.text = "xxx";
		if ( rngTmp.text.length == 0 ) {
			rngTmp.moveStart( "character", -3 );
		}
		rngTmp.select();
	}
	else {
		// TODO
		return false; // for now...
	}
	// apply lost commands
	for (var i = 0; i < stateMap.length; i++) {
		document.execCommand( stateMap[ i ], false );
	}
	// remove the added characters
	if ( document.selection ) {
		rngTmp.moveStart( "character", 1 );
		rngTmp.moveEnd( "character", -1 );
		container = rngTmp.parentElement();
		// check whether we are in an enclosing element (like <strong>xxx</strong>) or not (like </strong>xxx<strong>)
		var inserted = false;
		if ( htmlContent ) {
			if ( container.innerText == 'xxx' ) {
				container.innerHTML = htmlContent;
				rngTmp.moveToElementText( container );
				rngTmp.setEndPoint( "StartToEnd", rngTmp );
			}
			else {
				var rngTmp2 = rngTmp.duplicate(); // this will mark the first 'x'
				rngTmp2.moveStart( "character", -1 );
				rngTmp2.moveEnd( "character", -1 );
				rngTmp.moveEnd( "character", 1 ); // we will overwrite the second and thirs 'x'
				rngTmp.pasteHTML( 'x' + htmlContent ); // we need to add the leading 'x' to protect leading spaces
				rngTmp2.moveEnd( "character", 1 ); // remove the added 'x' with the first one
				rngTmp2.text = "";
			}
			inserted = true;
		}
		else {
			rngTmp.text = "";
		}
		rngTmp.select();
		return inserted;
	}
	else {
		// TODO
	}

	return false;
};

function replaceSelection( fieldName, text ) {
	DEBUG( "called replaceSelection(" + fieldName + ", \"" + text + "\")" );
	inc_debug_tab();
	try {
		focusWithoutScrolling( getNode( fieldName ) );
		if ( isWebkit ) {
			document.execCommand( "insertText", false, text );
		}
		else if ( isRte( fieldName ) ) {
			if ( window.getSelection ) {
	            range = window.getSelection().getRangeAt( 0 );
	            range.deleteContents();
	            if (text && text !== "") {
	            	range.insertNode( document.createTextNode( text ) );
	            }
			}
			else {
				if ( enforceStylingIfNecessary( htmlEncode( text, true ) ) ) {
					return;
				}
				if ( !dontUseClipboardForReplaceSelection && window.clipboardData && clipboardData.setData ) {
					var bak = clipboardData.getData( "Text" );
					clipboardData.setData( "Text", text );
					document.selection.createRange().execCommand( "Paste" );
					if ( bak ) {
						clipboardData.setData( "Text", bak );
					}
				}
				else {
					var rangeBak = false;
					if ( text.startsWith( " " ) ) {
						// hack around explorer's stupidity (pasteHTML strips leading spaces)
						text = "X" + text;
						rangeBak = getFieldSelection( fieldName );
					}
					document.selection.createRange().pasteHTML( htmlEncode( text, true ) );
					if ( rangeBak ) { // remove added 'X'
						var newSel = getFieldSelection( fieldName );
						setSelection( fieldName, rangeBak[ 0 ], rangeBak[ 0 ] + 1 );
						document.selection.createRange().pasteHTML( "" );
	
						setSelection( fieldName, newSel[ 0 ] - 1, newSel[ 1 ] - 1 );
					}
				}
			}
		}
		else {
			document.selection.createRange().text = text;
		}
		checkSize(); // update char/word counters
	}
	finally {
		dec_debug_tab();
	}
	return true;
};

function doPaste( fieldName ) {
	if ( !fieldName ) {
		fieldName = getFocusedFieldName();
	}
	if ( isRte( fieldName ) ) {
		rteCommand( fieldName, 'Paste' );
	}
	else {
		replaceSelection( fieldName, window.clipboardData.getData( "Text" ) );
	}
};

var HIDDENS = new Array(); // hidden inputs
var INPUTS = new Array(); // editable inputs containing real data
var MISCINPUTS = new Array(); // editable inputs containing meta-data, for
// example the shred checkbox on the study edit
// page
var TYPES = new Array(); // associative array showing types of each input
// (contains types for INPUTS and MISCINPUTS)
var ACTIVEINPUTS = new Array(); // in partialSubmit mode this array stores
// changed inputs that should be submitted
// (subset of INPUTS)
// Note: MISCINPUTS are always submitted in partialSubmit mode.

function registerMisc( fieldName, type ) {
	if ( !type ) {
		type = "simple";
	}
	TYPES[ fieldName ] = type;
	for (var i = 0; i < MISCINPUTS.length; i++) {
		if ( MISCINPUTS[ i ] == fieldName ) {
			return;
		}
	}
	MISCINPUTS.push( fieldName );
};

function registerHidden( fieldName ) {
	HIDDENS.push( fieldName );
};

function writeHidden( fieldName, value, fieldID ) {
	if ( !fieldID ) {
		fieldID = fieldName;
	}
	for (var i = 0; i < HIDDENS.length; i++) {
		if ( HIDDENS[ i ] == fieldID ) {
			// hidden input already added to the page, do not set ID and don't
			// register it again
			document.writeln( "<input type=hidden name='" + fieldName + "' value='" + value + "'>" );
			return;
		}
	}
	document.writeln( "<input type=hidden id='" + fieldID + "' name='" + fieldName + "' value='" + value + "'>" );
	registerHidden( fieldID );
};

function registerInput( fieldName, type ) {
	// alert("registering input ("+fieldName+", "+type+")");
	if ( !type ) {
		type = "simple";
	}
	TYPES[ fieldName ] = type;
	for (var i = 0; i < INPUTS.length; i++) {
		if ( INPUTS[ i ] == fieldName ) {
			return;
		}
	}
	INPUTS.push( fieldName );
	if ( type != "rte" ) {
		setFocusHandler( fieldName );
	}
	if ( partialSubmit ) {
		// watch/indicate which inputs were edited and submit only those
		addLoadEvent( function() {
			setupWatch( fieldName );
		} );
	}
};

function getInputFieldCount() {
	return INPUTS.length;
};

function getInputFieldName( p ) {
	return INPUTS[ p ];
};

function getFirstEditableField() {
	return INPUTS[ 0 ];
};

function setFocusedField( fieldName ) {
	try {
		getNode( fieldName ).focus();
	}
	catch ( e ) {
		return false;
	}
	if (typeof GS_setCurrentTarget === "function") {
		GS_setCurrentTarget( getNode( fieldName ).id );
	}
	return true;
};

function scrollToField( fieldName ) {
	DEBUG( "called scrollToField(" + fieldName + ")" );
	var node = getNode( fieldName );
	if ( !node )
		return;
	if (document.selection) {
		focusWithoutScrolling( node, true );
		document.selection.createRange().select();
	}
	else {
		node.focus();
	}
	// document.selection.createRange().scrollIntoView();
};

function setScrollPosition( posX, posY ) {
	window.scrollTo( posX, posY );
};

function getScrollPositionY() {
	if ( typeof window.pageYOffset != 'undefined' ) {
		return window.pageYOffset;
	}
	return document.body.scrollTop;
};

function getScrollPositionX() {
	if ( typeof window.pageXOffset != 'undefined' ) {
		return window.pageXOffset;
	}
	return document.body.scrollLeft;
};

function setInputFieldContent( fieldName, value ) {
	DEBUG( "called setInputFieldContent(" + fieldName + ", " + value + ")" );
	var inputType;
	if ( fieldName.endsWith( "_html" ) ) {
		var baseField = fieldName.substring( 0, fieldName.length - 5 );
		inputType = TYPES[ baseField ];
		if ( inputType == "rte" ) {
			returnRTE( baseField ).innerHTML = value;
		}
	}
	inputType = false;
	try {
		inputType = TYPES[ fieldName ];
		if ( inputType == "rte" ) {
			inputType = false;
			fieldName = fieldName + "_text";
		}
	}
	catch ( nocare ) {}
	if ( inputType ) {
		try {
			if ( !eval( "setValue_" + inputType ) ) {
				alert( "no setter method defined for type: " + inputType );
				return;
			}
		}
		catch ( anything ) {
			alert( "no setter method defined for type: " + inputType );
			return;
		}
	}
	try {
		if ( !inputType ) {
			// alert(fieldName+" uses default setter ("+TYPES+")");
			setTagValue( fieldName, value );
		}
		else {
			// alert('eval("setValue_" + '+inputType+' + "('+fieldName+',
			// '+value+')");');
			eval( "setValue_" + inputType + "(fieldName, value)" );
		}
	}
	catch ( anything ) {
		alert( "setter method failed to set field " + fieldName );
		alert( anything );
	}
};

function setInputValues( encoded, utf8 ) {
	DEBUG( "called setInputValues(" + encoded + ")" );
	var parts = encoded.split( "&" );
	for (var i = 0; i < parts.length; i++) {
		var part = parts[ i ];
		p = part.indexOf( "=" );
		if ( p < 1 ) {
			//alert( "setInputValues: bad part \"" + part + "\"" );
			continue;
		}
		if (utf8) {
			setInputFieldContent( decodeURIComponent( part.substring( 0, p ) ), decodeURIComponent( part.substring( p + 1 ) ) );
		}
		else {
			setInputFieldContent( unescape( part.substring( 0, p ).replace(/\+/g, '%20') ), unescape( part.substring( p + 1 ).replace(/\+/g, '%20') ) );
		}
	}
};

function getOldValue( fieldName ) {
	var inputType = false;
	try {
		inputType = TYPES[ fieldName ];
	}
	catch ( nocare ) {}
	if ( inputType ) {
		try {
			var func = eval( "getOldValue_" + inputType );
			return func( fieldName );
		}
		catch ( e ) {}
	}
	try {
		return getNode( fieldName ).origVal;
	}
	catch ( e ) {}
	return "";
};

function getInputFieldContent( fieldName ) {
	var inputType = false;
	try {
		inputType = TYPES[ fieldName ];
	}
	catch ( nocare ) {}
	var res;
	if ( !inputType ) {
		// try simple method
		res = getTagValue( fieldName );
	}
	else {
		var func = eval( "getValue_" + inputType );
		res = func( fieldName );
	}
	DEBUG( "getInputFieldContent(" + fieldName + ") returns " + res );
	return res;
};

function pushFields( res, fields, utf8 ) {
	for (var j = 0; j < fields.length; j++) {
		var field = fields[ j ];
		if ( INPUTS.indexOf( field ) == -1 && HIDDENS.indexOf( field ) == -1 ) {
			continue;
		}
		// alert("processing "+field);
		if ( 'rte' == TYPES[ field ] ) {
			if ( utf8 ) {
				res.push( encodeURIComponent( field ) + "_html=" + encodeURIComponent( getHTMLValue_rte( field ) ) );
			}
			else {
				res.push( escape( field ) + "_html=" + escape( getHTMLValue_rte( field ) ) );
			}
			if ( utf8 ) {
				res.push( encodeURIComponent( field ) + "=" + encodeURIComponent( getTweakedPlainText( field ) ) );
			}
			else {
				res.push( escape( field ) + "=" + escape( getTweakedPlainText( field ) ) );
			}
		}
		else {
			if ( utf8 ) {
				res.push( encodeURIComponent( field ) + "=" + encodeURIComponent( getInputFieldContent( field ) ) );
			}
			else {
				res.push( escape( field ) + "=" + escape( getInputFieldContent( field ) ) );
			}
		}
	}
};

function getAllContent( utf8 ) {
	var parts = new Array();
	// alert(INPUTS);
	if ( partialSubmit ) {
		pushFields( parts, ACTIVEINPUTS, utf8 );
	}
	else {
		pushFields( parts, INPUTS, utf8 );
	}
	pushFields( parts, HIDDENS, utf8 );
	var res = parts.join( "&" );
	DEBUG( "getAllContent() returns " + res );
	return res;
};

function addFields2Form( form, fields ) {
	for (var j = 0; j < fields.length; j++) {
		var field = fields[ j ];

		var obj = document.createElement( "input" );
		obj.type = "hidden";
		obj.name = field;
		obj.value = getInputFieldContent( field );
		form.appendChild( obj );
		if ( 'rte' == TYPES[ field ] ) {
			obj = document.createElement( "input" );
			obj.type = "hidden";
			obj.name = field + "_html";
			obj.value = getHTMLValue_rte( field );
			form.appendChild( obj );
		}
	}
};

function addNeededContent2Form( form ) {
	if ( partialSubmit ) {
		addFields2Form( form, ACTIVEINPUTS );
	}
	else {
		addFields2Form( form, INPUTS );
	}
	addFields2Form( form, MISCINPUTS );
	addFields2Form( form, HIDDENS );
};

function setupWatch_default( fieldName ) {
	var func = function() {
		turnOnSending( fieldName );
	};
	var partNodes = getNodes( fieldName );
	// alert( fieldName + "->" + partNodes );
	for (var i = 0; i < partNodes.length; i++) {
		partNodes[ i ].onchange = func;
		partNodes[ i ].onkeyup = func;
	}
};

function setupWatch( fieldName ) {
	var inputType = false;
	try {
		inputType = TYPES[ fieldName ];
	}
	catch ( nocare ) {}
	try {
		getNode( fieldName ).origVal = getInputFieldContent( fieldName );
		var func = eval( "setupWatch_" + inputType );
		return func( fieldName );
	}
	catch ( e ) {}
	setupWatch_default( fieldName );
};

function getNodes( fieldName ) {
	var inputType = false;
	try {
		inputType = TYPES[ fieldName ];
	}
	catch ( nocare ) {}
	if ( inputType ) {
		try {
			var func = window[ "getNodes_" + inputType ];
			if ( typeof func === 'function' ) {
				return func( fieldName );
			}
		}
		catch ( e ) {}
		;
	}
	return new Array( getNode( fieldName ) );
};

function getNode( fieldName ) {
	var inputType = false;
	try {
		inputType = TYPES[ fieldName ];
	}
	catch ( nocare ) {}
	if ( !inputType ) {
		// try simple method
		return my_getelementbyid( fieldName );
	}
	// try {
	var func = eval( "getNode_" + inputType );
	return func( fieldName );
};

function maintainInput( fieldName ) {
	var inputType = false;
	try {
		inputType = TYPES[ fieldName ];
	}
	catch ( nocare ) {}
	if ( inputType ) {
		try {
			var func = eval( "maintainInput_" + inputType );
			return func( fieldName );
		}
		catch ( nocare ) {}
	}
};

function turnOnSending( fieldName ) {
	for (var i = 0; i < ACTIVEINPUTS.length; i++) {
		if ( ACTIVEINPUTS[ i ] == fieldName ) {
			return;
		}
	}
	if ( getInputFieldContent( fieldName ) == getOldValue( fieldName ) ) {
		return;
	}
	ACTIVEINPUTS.push( fieldName );
	// do coloring
	try {
		var func = eval( "colorSending_" + inputType );
		func( fieldName );
	}
	catch ( e ) {
		var nodes = getNodes( fieldName );
		for (var i = 0; i < nodes.length; i++) {
			nodes[ i ].className = "modifiedInputBG";
		}
	}
};

// --- rte ---

function getValue_rte( fieldName ) {
	return getText( my_getelementbyid( fieldName ) );
};

function getHTMLValue_rte( fieldName ) {
	try {
		var html = returnRTE( fieldName ).innerHTML;
		if ( document.getSelection && html.toLowerCase() == "<br>" ) {
			return ""; // ie11 mode represents empty value as <br> CBT #5025
		}
		html = html.replace( /<strong>/gi, "<b>" );
		html = html.replace( /<\/strong>/gi, "</b>" );
		html = html.replace( /<em>/gi, "<i>" );
		html = html.replace( /<\/em>/gi, "</i>" );
		return html;
	}
	catch ( e ) {
		alert( "getHTMLValue_rte: fieldName " + fieldName + " caused " + e.message );
	}
};

function getNode_rte( fieldName ) {
	return returnRTE( fieldName );
};

// --- PN ---

var nameParts = [ "last", "first", "mi", "pref", "postf" ];

function setValue_PN( fieldName, value ) {
	var parts = value.split( "^" );
	for (var i = 0; i < 5; i++) {
		parts.push( "" ); // non-defined parts should be ""
		setTagValue( "qi_" + fieldName + "_" + nameParts[ i ], parts[ i ] );
	}
};

function getValue_PN( fieldName ) {
	var res = new Array();
	for (var i = 4; i >= 0; i--) {
		partVal = my_getelementbyid( "qi_" + fieldName + "_" + nameParts[ i ] ).value;
		if ( res.length > 0 || partVal.length > 0 ) {
			res.unshift( partVal );
		}
	}
	return res.join( "^" );
};

function getNode_PN( fieldName ) {
	return my_getelementbyid( "qi_" + fieldName + "_last" );
};

function getNodes_PN( fieldName ) {
	var result = new Array();
	for (var i = 4; i >= 0; i--) {
		var node = my_getelementbyid( "qi_" + fieldName + "_" + nameParts[ i ] );
		result.push( node );
	}
	return result;
};
// --- statid ---

var statidMap = new Array();
statidMap[ "CREATED" ] = "50";
statidMap[ "RECORDED" ] = "60";
statidMap[ "TRANSCRIBED" ] = "80";
statidMap[ "APPROVED" ] = "100";

function setValue_statid( fieldName, value ) {
	if ( statidMap[ value ] != undefined ) {
		value = statidMap[ value ];
	}
	my_getelementbyid( fieldName + "_" + value ).checked = true;
};

function getValue_statid( fieldName ) {
	var values = [ "50", "60", "80", "100" ];
	for (var i = 0; i < values.length; i++) {
		var value = values[ i ];
		try {
			if ( my_getelementbyid( fieldName + "_" + value ).checked ) {
				return value;
			}
		}
		catch ( e ) {
			// some parts may be disabled, querying these will throw an exception
		}
	}
	return false;
};

function getNode_statid( fieldName ) {
	return my_getelementbyid( fieldName + "_100" );
};

// --- simple ---

function setValue_simple( fieldName, value ) {
	setTagValue( fieldName, value );
};

function getValue_simple( fieldName ) {
	return getTagValue( fieldName );
};

function getNode_simple( fieldName ) {
	return my_getelementbyid( fieldName );
};
// --- simpleQE ---

function setValue_simpleQE( fieldName, value ) {
	setTagValue( "qe_" + fieldName, value );
};

function getValue_simpleQE( fieldName ) {
	return getTagValue( "qe_" + fieldName );
};

function getNode_simpleQE( fieldName ) {
	return my_getelementbyid( "qe_" + fieldName );
};
// --- select ---

function getValue_select( fieldName ) {
	select = my_getelementbyid( fieldName );
	if ( !select ) {
		select = my_getelementbyid( fieldName + "sel" );
	}
	if ( !select ) {
		alert( "couldn't find an element with the ID\n" + fieldName + " OR\n" + fieldName + "sel" );
	}
	return select.options[ select.selectedIndex ].value;
};

function setValue_select( fieldName, value ) {
	var select = my_getelementbyid( fieldName );
	if ( !select ) {
		select = my_getelementbyid( fieldName + "sel" );
	}
	if ( !select ) {
		alert( "couldn't find an element with the ID\n" + fieldName + " OR\n" + fieldName + "sel" );
	}
	for (var i = 0; i < select.options.length; i++) {
		if ( select.options[ i ].value == value ) {
			select.selectedIndex = i;
			return;
		}
	}
};

function getNode_select( fieldName ) {
	var select = my_getelementbyid( fieldName );
	if ( !select ) {
		select = my_getelementbyid( fieldName + "sel" );
	}
	return select;
};

// --- selectQE ---

function getValue_selectQE( fieldName ) {
	return getValue_select( "qe_" + fieldName );
};

function setValue_selectQE( fieldName, value ) {
	setValue_select( "qe_" + fieldName, value );
};

function getNode_selectQE( fieldName ) {
	return getNode_select( "qe_" + fieldName );
};

// --- selectQS ---

function getValue_selectQS( fieldName ) {
	return getValue_select( "qs_" + fieldName );
};

function setValue_selectQS( fieldName, value ) {
	setValue_select( "qs_" + fieldName, value );
};

function getNode_selectQS( fieldName ) {
	return getNode_select( "qs_" + fieldName );
};

// --- selectWAID --- select with author id

function getValue_selectWAID( fieldName ) {
	return getValue_select( fieldName );
};

function setValue_selectWAID( fieldName, value ) {
	setValue_select( fieldName, value );
	selectWAIDChanged( fieldName );
};

function getNode_selectWAID( fieldName ) {
	return getNode_select( fieldName );
};

function selectWAIDChanged( fieldName ) {
	select = my_getelementbyid( fieldName );
	if ( !select ) {
		select = my_getelementbyid( fieldName + "sel" );
	}
	if ( !select ) {
		alert( "couldn't find an element with the ID\n" + fieldName + " OR\n" + fieldName + "sel" );
	}
	// id=\"" + dataSource.getFormInputName( AUTHOR ) + "_option_" + JSHelper.jsEncode( selAuthId )
	var authID = select.options[ select.selectedIndex ].id.substr( fieldName.length + 8 );
	setValue_simple( fieldName + "_authorID", authID );
	valueChanged();
};

// --- radio --------------

function setValue_radio( fieldName, value ) {
	$("input[name='"+fieldName+"'][value='" + value + "']").prop('checked', true);
};

function getValue_radio( fieldName ) {
	return $("input[name='"+fieldName+"']:checked").val();
};

function getNode_radio( fieldName ) {
	return getNodes_radio( fieldName )[0];
};

function getNodes_radio( fieldName ) {
	return $("input[name='"+fieldName+"']").get();
};

// --- radioQE --------------

function setValue_radioQE( fieldName, value ) {
	setValue_radio( "qe_" + fieldName, value);
}

function getValue_radioQE( fieldName ) {
	return getValue_radio( "qe_" + fieldName );
}

function getNode_radioQE( fieldName ) {
	return getNode_radio( "qe_" + fieldName );
}

function getNodes_radioQE( fieldName ) {
	return getNodes_radio( "qe_" + fieldName );
}

// --- checkboxYN (checkboxInputMacro)--------------

function setValue_checkboxYN( fieldName, value ) {
	setValueSimple(fieldName, value); // set hidden input
	getNode_checkboxYN( fieldName ).checked = ( "yes" == value );
}

function getNode_checkboxYN( fieldName ) {
	return my_getelementbyid( fieldName + "_CB" );
}

// -----------------

var statBackConfirmed = false;

function checkSTAT() {
	if ( statBackConfirmed ) {
		return true;
	}
	var oldVal = my_getelementbyid( "qo_STAT" ).value;
	var currentVal = getValue_select( "qe_STAT" );
	if ( currentVal >= oldVal ) {
		return true;
	}
	if ( confirm( "Are you sure you want to change Status backwards?" ) ) {
		statBackConfirmed = true;
		return true;
	}
	setValue_select( "qe_STAT", oldVal );
	return false;
};

function setupWatch_selectQE( fieldName ) {
	if ( "STAT" != fieldName ) {
		return setupWatch_default( fieldName );
	}
	var func = function() {
		if ( checkSTAT() ) {
			turnOnSending( fieldName );
		}
	};
	var partNodes = getNodes( fieldName );
	// alert( fieldName + "->" + partNodes );
	for (var i = 0; i < partNodes.length; i++) {
		partNodes[ i ].onchange = func;
		partNodes[ i ].onkeyup = func;
	}
};

// --- od ---

function getValue_od( fieldName ) { // operating days
	res = "";
	for (var i = 0; i < 7; i++) {
		if ( my_getelementbyid( "qi_" + fieldName + i ).checked ) {
			res += new String( i + 1 );
		}
	}
	return res;
};

function setValue_od( fieldName, value ) { // operating days
	valueStr = new String( value );
	for (var i = 0; i < 7; i++) {
		my_getelementbyid( "qi_" + fieldName + i ).checked = value.indexOf( i + 1 ) > -1;
	}
};

function getNode_od( fieldName ) {
	return my_getelementbyid( "qi_" + fieldName + "0" );
};

// --- checkbox ---

function getValue_checkbox( fieldName ) {
	var onValue = my_getelementbyid( fieldName ).value;
	if ( onValue == undefined ) {
		onValue = "true";
	}
	return my_getelementbyid( fieldName ).checked ? onValue : false;
};

function setValue_checkbox( fieldName, value ) {
	var onValue = my_getelementbyid( fieldName ).value;
	if ( onValue == undefined ) {
		onValue = "true";
	}
	my_getelementbyid( fieldName ).checked = value == onValue ? true : false;
};

function getNode_checkbox( fieldName ) {
	return my_getelementbyid( fieldName );
};

// --- normality ---

// returns the value of the hidden element of the normality field
function getValue_normality( fieldName ) {
	return getNode_normality( fieldName ).checked ? "NORMAL" : "ABNORMAL";
};

// updates the hidden element and the checkbox of the normality field
function setValue_normality( fieldName, value ) {
	my_getelementbyid( fieldName ).value = value;
	getNode_normality( fieldName ).checked = ( value == "NORMAL" );
};

// returns the checkbox element of the normality field
function getNode_normality( fieldName ) {
	return my_getelementbyid( "ch_" + fieldName );
};

function maintainInput_normality( fieldName ) {
	my_getelementbyid( fieldName ).value = getValue_normality( fieldName );
};

// --- TM ---

function getValue_TM( fieldName ) {
	res = new String( "" );
	ms = getTagValue( fieldName + "_ms", "" ).trim();
	while ( ms.endsWith( "0" ) ) {
		ms = ms.substring( 0, ms.length - 1 );
	}
	if ( ms.length > 0 ) {
		res = "." + ms;
	}
	var parts = [ getTagValue( fieldName + "_sc", "" ).trim(), getTagValue( fieldName + "_mi", "" ).trim(), getTagValue( fieldName + "_hr", "" ).trim() ];
	for (var i = 0; i < parts.length; i++) {
		var part = parts[ i ];
		if ( res.length == 0 && part.length == 0 ) {
			continue;
		}
		while ( part.length < 2 ) {
			part = "0" + part;
		}
		res = part + res;
	}
	return res;
};

function setValue_TM( fieldName, value ) {
	var hour = "";
	var min = "";
	var sec = "";
	var msec = "";

	if ( value.length >= 2 )
		hour = value.substring( 0, 2 );
	if ( value.length >= 4 )
		min = value.substring( 2, 4 );
	if ( value.length >= 6 )
		sec = value.substring( 4, 6 );
	if ( value.length >= 7 )
		msec = value.substring( 6, value.length );

	setTagValue( fieldName + "_hr", hour );
	setTagValue( fieldName + "_mi", min );
	setTagValue( fieldName + "_sc", sec );
	setTagValue( fieldName + "_ms", msec );
};

function getNode_TM( fieldName ) {
	return my_getelementbyid( fieldName + "_hr" );
};

var tmParts = [ "hr", "mi", "sc", "ms" ];

function getNodes_TM( fieldName ) {
	var result = new Array();
	for (var i = tmParts.length - 1; i >= 0; i--) {
		var node = my_getelementbyid( fieldName + "_" + tmParts[ i ] );
		if ( node ) {
			result.push( node );
		}
	}
	return result;
};

// --- DA ---

function getValue_DA( fieldName ) {
	var part;
	var res = new String( "" );
	var parts = [ new String( getTagValue( fieldName + "_dy", "" ) ).trim(), new String( getTagValue( fieldName + "_mo", "" ) ).trim(), new String( getTagValue( fieldName + "_yr", "" ) ).trim() ];
	var lengths = [ 2, 2, 4 ];
	for (var i = 0; i < parts.length; i++) {
		part = parts[ i ];
		if ( res.length == 0 && part.length == 0 ) {
			continue;
		}
		while ( part.length < lengths[ i ] ) {
			part = "0" + part;
		}
		res = part + res;
	}
	return res;
};

function setValue_DA( fieldName, value ) {
	var year = "";
	var month = "";
	var day = "";

	if ( value.length >= 4 )
		year = value.substring( 0, 4 );
	if ( value.length >= 6 )
		month = value.substring( 4, 6 );
	if ( value.length >= 8 )
		day = value.substring( 6, 8 );

	setTagValue( fieldName + "_yr", year );
	setTagValue( fieldName + "_mo", month );
	setTagValue( fieldName + "_dy", day );
};

function getNode_DA( fieldName ) {
	return my_getelementbyid( fieldName + "_yr" );
};

var daParts = [ "yr", "mo", "dy" ];

function getNodes_DA( fieldName ) {
	var result = new Array();
	for (var i = daParts.length - 1; i >= 0; i--) {
		var node = my_getelementbyid( fieldName + "_" + daParts[ i ] );
		if ( node ) {
			result.push( node );
		}
	}
	return result;
};
// --- DATM ---

function getValue_DATM( fieldName ) {

	var da = getValue_DA( fieldName + "_d" );
	var tm = getValue_TM( fieldName + "_t" );

	if ( tm.length > 0 ) {
		return da + "_" + tm;
	}
	return da;
};

function setValue_DATM( fieldName, value ) {
	var da = "";
	var tm = "";
	var parts = value.split( "_" );
	if ( parts.length > 0 ) {
		da = parts[ 0 ];
		if ( parts.length > 1 ) {
			tm = parts[ 1 ];
		}
	}
	setValue_DA( fieldName + "_d", da );
	setValue_TM( fieldName + "_t", tm );
};

function getNode_DATM( fieldName ) {
	return getNode_DA( fieldName + "_d" );
};

function getNodes_DATM( fieldName ) {
	return getNodes_DA( fieldName + "_d" ).concat( getNodes_TM( fieldName + "_t" ) );
};

// --- Dt ---

function getValue_Dt( fieldName ) {
	var da = getValue_DA( fieldName + "_d" );
	da = da.substring( 0, 4 ) + "-" + da.substring( 4, 6 ) + "-" + da.substring( 6, 8 );
	var tm = getValue_TM( fieldName + "_t" );

	if ( tm.length > 0 ) {
		tm = tm.substring( 0, 2 ) + ":" + tm.substring( 2, 4 ) + ":" + tm.substring( 4, 6 );
		return da + " " + tm;
		// "1938-06-09 00:00:00.0"
	}
	return da;
};

function setValue_Dt( fieldName, value ) {
	var da = "";
	var tm = "";
	var parts = value.split( " " );
	if ( parts.length > 0 ) {
		da = parts[ 0 ];
		da = da.replace( /-/g, "" );
		if ( parts.length > 1 ) {
			tm = parts[ 1 ];
			tm = tm.replace( /:/g, "" );
		}
	}
	setValue_DA( fieldName + "_d", da );
	setValue_TM( fieldName + "_t", tm );
};

function getNode_Dt( fieldName ) {
	return getNode_DA( fieldName + "_d" );
};

function getNodes_Dt( fieldName ) {
	return getNodes_DA( fieldName + "_d" ).concat( getNodes_TM( fieldName + "_t" ) );
};

// -----------------------------
// tabbed layout related code follows

var groupIDs = new Array();

function generateTabPanels() {
	for (var i = 0; i < groupIDs.length; i++) {
		generateTabPanel( groupIDs[ i ] );
	}
};

function generateTabPanel( groupID ) {
	if ( !groupID ) {
		groupID = "";
	}
	var tr = my_getelementbyid( "tabGroup_" + groupID );
	if ( !tr ) {
		// no tab panel defined for the group
		return;
	}
	var url = location.href;
	if ( url.toLowerCase().startsWith( "http://" ) ) {
		url = "erad://reportTab/" + url.substr( 7 );
	}
	else if ( url.toLowerCase().startsWith( "https://" ) ) {
		url = "erads://reportTab/" + url.substr( 8 );
	}
	else {
		url = "erad://reportTab/" + url;
	}

	for (var i = 0; i < tabParts[ groupID ].length; i++) {
		var td = document.createElement( "td" );
		td.id = "tab_" + groupID + "_" + i;
		var link = document.createElement( "a" );
		if ( groupID == "" ) {
			link.href = url + "&reportTabPtr=" + i;
		}
		else {
			link.href = "#";
		}
		link.innerHTML = tabLabels[ tabParts[ groupID ][ i ] ];
		link.id = "tab_" + groupID + "_" + i + "_link";
		eval( "link.onclick = function() { selectTab( \"" + groupID + "\", " + i + " ); return false;}" );
		tr.appendChild( td );
		td.appendChild( link );
	}
	selectTab( groupID, 0 );
};

var tabLoadEventRegistered = false;

var tabParts = new Array(); // "x"+groupID->array of tabIDs
var tabLabels = new Array();

function registerTab( tabID, groupID, label ) {
	tabLabels[ tabID ] = label;
	if ( !groupID ) {
		groupID = "";
	}
	if ( !tabLoadEventRegistered ) {
		addLoadEvent( generateTabPanels );
		tabLoadEventRegistered = true;
	}
	var knownGroup = false;
	for (var i = 0; i < groupIDs.length; i++) {
		if ( groupIDs[ i ] == groupID ) {
			knownGroup = true;
		}
	}
	if ( !knownGroup ) {
		groupIDs.push( groupID );
	}
	if ( typeof tabParts[ groupID ] == 'undefined' ) {
		tabParts[ groupID ] = new Array();
	}
	tabParts[ groupID ].push( tabID );
};

function selectTab( groupID, num ) {
	if ( !tabParts[ groupID ] ) {
		return;
	}
	for (var i = 0; i < tabParts[ groupID ].length; i++) {
		var tabID = tabParts[ groupID ][ i ];
		// do not set the style unless we really change it (it might mess up IE's undo stack)
		var disp = i == num ? "" : "none";
		var tabElement = my_getelementbyid( tabID );
		if ( tabElement.style.display != disp ) {
			tabElement.style.display = disp;
		}
		try {
			my_getelementbyid( "tab_" + groupID + "_" + i ).className = ( i == num ? "selectedTab" : "nonSelectedTab" );
			my_getelementbyid( "tab_" + groupID + "_" + i + "_link" ).className = ( i == num ? "selectedTab" : "nonSelectedTab" );
		}
		catch ( e ) {}
	}
};

function getTabCount( groupID ) {
	if ( !groupID ) {
		groupID = "";
	}
	try {
		return tabParts[ groupID ].length;
	}
	catch ( e ) {}
	return -1;
};

function getTabLabel( groupID, tabNum ) {
	if ( !groupID ) {
		groupID = "";
	}
	return tabLabels[ tabParts[ groupID ][ tabNum ] ];
};

function getTabNum( groupID, fieldName ) {
	if ( !groupID ) {
		groupID = "";
	}
	if ( !tabParts[ groupID ] ) {
		return -1;
	}
	var node = getNode( fieldName );
	while ( node ) {
		if ( node.id ) {
			for (var i = 0; i < tabParts[ groupID ].length; i++) {
				if ( node.id == tabParts[ groupID ][ i ] ) {
					return i;
				}
			}
		}
		node = node.parentNode;
	}
	return -1;
};

// -----------------------------

var xmlhttp = false;

function xmlhttpnew() {
	/* @cc_on @ */
	/*
	 * @if (@_jscript_version >= 5) // JScript gives us Conditional compilation, we can cope with old IE versions. // and security blocked creation of the objects. try { xmlhttp = new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) { try { xmlhttp = new ActiveXObject("Microsoft.XMLHTTP"); } catch (E) { xmlhttp = false; } } @end @
	 */
	if ( !xmlhttp && typeof XMLHttpRequest != 'undefined' ) {
		try {
			xmlhttp = new XMLHttpRequest();
		}
		catch ( e ) {
			xmlhttp = false;
		}
	}
	if ( !xmlhttp && window.createRequest ) {
		try {
			xmlhttp = window.createRequest();
		}
		catch ( e ) {
			xmlhttp = false;
		}
	}
	if ( !xmlhttp ) {
		try {
			xmlhttp = new ActiveXObject( "Msxml2.XMLHTTP" );
		}
		catch ( e ) {
			try {
				xmlhttp = new ActiveXObject( "Microsoft.XMLHTTP" );
			}
			catch ( E ) {}
		}
	}
	if ( !xmlhttp ) {
		alert( "Browser does not support javascript HTTP Request !!" );
	}
	return xmlhttp;
};

function callBack( url, reqPars ) {
	xmlhttpdefined = false;
	try {
		if ( xmlhttp ) {
			xmlhttpdefined = true;
		}
	}
	catch ( anything ) {}
	if ( !xmlhttpdefined ) {
		xmlhttp = xmlhttpnew();
	}
	xmlhttp.open( "POST", url, false ); // synchronous call
	xmlhttp.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded;charset=iso-8859-2' );
	xmlhttp.setRequestHeader( "Content-Length", reqPars.length );
	xmlhttp.send( reqPars ); // requestparams
	if ( ( xmlhttp.readyState == 4 || xmlhttp.readyState == "complete" ) && xmlhttp.status == 200 ) {
		return xmlhttp.responseText;
	}
	else {
		alert( url + "?" + reqPars + " returned:\n" + xmlhttp.responseText );
	}
};

function updateOtherFields( fldVal, query ) {
	url = "/scheduler/queryValues.jsp";
	reqPars = query + escape( fldVal );
	response = callBack( url, reqPars );
	if ( !response ) {
		return;
	}
	lines = new String( response ).split( "\n" );
	if ( lines[ 0 ] == "OK" ) {
		for (var j = 1; j < lines.length; j++) {
			line = new String( lines[ j ] );
			p1 = line.indexOf( " " );
			if ( p1 == -1 ) {
				continue; // invalid line
			}
			field = line.substring( 0, p1 );
			value = new String( line.substring( p1 + 1 ) );
			if ( value.length < 1 ) {
				continue; // don't set empty value
			}
			setInputFieldContent( field, value );
		}
	}
	else {
		alert( url + "?" + reqPars + " returned:\n" + xmlhttp.responseText );
	}
};

// type-ahead related stuff comes here

/*
 * function that removes the last character of the text input part of the restrictive TypeAhead macro
 */
function clearBack( fieldID, queryField, configFile ) {
	textField = my_getelementbyid( "qe_" + fieldID );
	if ( textField.value && textField.value.length > 0 ) {
		var cur = new Date().getTime();
		var end = cur + 100;
		while ( cur < end ) {
			cur = new Date().getTime();
		}
		textField.value = textField.value.substring( 0, textField.value.length - 1 );
		updateSelectBox( fieldID, queryField, configFile );
	}
};

/*
 * function that checks whether an attribute in a given attribute list is present and not false
 */
function getAttribute( element, attrib ) {
	for (var ty = 0; ty < element.attributes.length; ty++) {
		if ( element.attributes[ ty ].name == attrib ) {
			return element.attributes[ ty ].value;
		}
	}
	return false;
};

function updateSelectBox( fieldID, queryField, configFile ) {
	var selectField = my_getelementbyid( fieldID + "sel" );
	populateSelectBox( selectField, fieldID, queryField, configFile, getAttribute( selectField, "justselect" ) );
};
/*
 * function that updates the content of a select input generated by TypeAhead macro or SelectInput macro
 */
function populateSelectBox( selectField, fieldID, queryField, configFile, justSelect ) {
	var reqPars = "cQueryMode=";
	if ( configFile ) {
		reqPars += "TACFG&cFile=" + escape( configFile );
	}
	else {
		reqPars += "TADB&cField=" + escape( queryField );
	}
	if ( justSelect ) {
		// simple select field, no limit
		reqPars += "&cQueryLimit=0&cDontSort=true";
	}
	else {
		textField = my_getelementbyid( "qe_" + fieldID );
		reqPars += "&cPrefix=" + escape( textField.value );
		if ( getAttribute( selectField, "iscaseinsensitive" ) ) {
			reqPars += "&cCaseInsensitive=true";
		}
	}
	var url = "/scheduler/queryTA.jsp";
	response = callBack( url, reqPars );
	if ( !response ) {
		return;
	}
	lines = new String( response ).split( "\n" );
	if ( lines[ 0 ] == "OK" || lines[ 0 ] == "LIMITED" || lines[ 0 ] == "FAILED (No record)" ) {
		// remove old value set
		for (var i = selectField.length - 1; i >= 0; i--) {
			selectField.options[ i ] = null;
		}
		if ( lines[ 0 ] == "FAILED (No record)" ) {
			if ( getAttribute( selectField, "isrestrictive" ) ) {
				clearBack( fieldID, queryField, configFile );
			}
			return;
		}
		origVal = getAttribute( selectField, "origval" );
		selIndex = 0;
		for (var j = 1; j < lines.length; j++) {
			option = new Option( lines[ j ], lines[ j ] );
			if ( origVal && origVal == lines[ j ] ) {
				option.selected = true;
				selIndex = j - 1;
			}
			selectField.options[ j - 1 ] = option;
		}
		if ( lines[ 0 ] == "LIMITED" ) {
			lastOpt = new Option( "...", "..." );
			lastOpt.disabled = true;
			selectField.options[ lines.length - 1 ] = lastOpt;
		}
		// this is a workaround for an IE6 bug
		selectField.selectedIndex = selIndex;
	}
	else {
		alert( url + "?" + reqPars + " returned:\n" + xmlhttp.responseText );
	}
};

/*
 * function that alters the selection for select input generated by TypeAhead macro
 */
function moveSelect( selectField, up ) {
	if ( up && selectField.selectedIndex > 0 ) {
		selectField.selectedIndex--;
	}
	if ( !up && selectField.selectedIndex < selectField.length - 1 && !selectField.options[ selectField.selectedIndex + 1 ].disabled ) {
		selectField.selectedIndex++;
	}
};

/*
 * function that synchronizes elements generated by TypeAhead macro
 */
function onTAChange( event, fieldID, queryField, configFile ) {
	textField = my_getelementbyid( "qe_" + fieldID );
	selectField = my_getelementbyid( fieldID + "sel" );

	if ( textField.hasFocus ) {
		// some keys are handled specially
		if ( event ) {
			var unicode = event.charCode ? event.charCode : event.keyCode;
			if ( unicode ) {
				switch (unicode) {
				case 38:
					// 38 = up
					moveSelect( selectField, true );
					return;
				case 39:
					// 39 = right
					textField.value = selectField.options[ selectField.selectedIndex ].value;
					return;
				case 40:
					// 40 = down
					moveSelect( selectField, false );
					return;
				default:
					// alert(unicode);
				}
			}
		}
		// text was modified
		updateSelectBox( fieldID, queryField, configFile );
	}
	else {
		// selection changed
		// some keys are handled specially
		if ( event ) {
			var unicode = event.charCode ? event.charCode : event.keyCode;
			if ( unicode && unicode == 13 ) {
				// 13 = enter
				textField.value = selectField.options[ selectField.selectedIndex ].value;
				textField.focus();
				return;
			}
		}
		// workaround for IE bug: check whether a disabled option was selected
		if ( selectField.options[ selectField.selectedIndex ].disabled ) {
			selectField.selectedIndex = 0;
		}
		else {
			textField.value = selectField.options[ selectField.selectedIndex ].value;
		}
	}
};

/*
 * function that handles focus events for elements generated by TypeAhead macro
 */
function handleTAFocus( fieldID ) {
	textField = my_getelementbyid( "qe_" + fieldID );
	selectField = my_getelementbyid( fieldID + "sel" );
	if ( !( textField.hasFocus || selectField.hasFocus ) ) {
		// hide select
		selectField.style.display = "none";
	}
	else {
		// show select
		selectField.style.display = "";
	}
};

/*
 * function that handles focus gaining events for elements generated by TypeAhead macro
 */
function onTAFocus( element, fieldID, queryField, configFile ) {
	element.hasFocus = true;
	onTAChange( false, fieldID, queryField, configFile );
	handleTAFocus( fieldID );
};

/*
 * function that handles focus losing events for elements generated by TypeAhead macro
 */
function onTABlur( element, fieldID ) {
	element.hasFocus = false;
	setTimeout( "handleTAFocus('" + fieldID + "')", 50 );
};

function checkForNumber( event ) {
	if ( event ) {
		var unicode = event.charCode ? event.charCode : event.keyCode;
		if ( unicode ) {
			// alert( "charcode:" + event.charCode + " keycode:" + event.keyCode );
			// 0-9, arrows left+right backspace del tab
			// no Shift
			return !event.shiftKey && ( ( unicode >= 48 && unicode <= 57 ) || ( unicode >= 96 && unicode <= 105 ) || unicode == 37 || unicode == 39 || unicode == 8 || unicode == 46 || unicode == 9 );
		}
		else {
			return false;
		}
	}
};

function checkForSignedNumber( event ) {
	if ( event ) {
		var unicode = event.charCode ? event.charCode : event.keyCode;
		if ( unicode ) {
			// alert( "charcode:" + event.charCode + " keycode:" + event.keyCode );
			// 0-9, arrows left+right backspace del tab - (189: masik -)
			// no Shift
			return !event.shiftKey && ( ( unicode >= 48 && unicode <= 57 ) || ( unicode >= 96 && unicode <= 105 ) || unicode == 37 || unicode == 39 || unicode == 8 || unicode == 46 || unicode == 9 || unicode == 109 || unicode == 189 );
		}
		else {
			return false;
		}
	}
};

function checkForAmount( event, fieldName ) {
	if ( event ) {
		// var unicode = event.charCode ? event.charCode : event.keyCode;
		var unicode = event.keyCode;
		if ( unicode ) {
			// alert( "charcode:" + event.charCode + " keycode:" + event.keyCode
			// );
			// .
			if ( !event.shiftKey && unicode == 190 ) {
				textField = my_getelementbyid( fieldName );
				if ( !textField ) {
					alert( "TextField is null, fieldName:" + fieldName );
				}
				return textField.value.indexOf( "." ) == -1;
			}
			// 0-9, arrows left+right backspace del tab
			// no Shift
			else
				return !event.shiftKey && ( ( unicode >= 48 && unicode <= 57 ) || ( unicode >= 96 && unicode <= 105 ) || unicode == 37 || unicode == 39 || unicode == 8 || unicode == 46 || unicode == 9 );
		}
		else {
			// alert( "charcode:" + event.charCode + " keycode:" + event.keyCode
			// );
			return false;
		}
	}
};

// functions for collapsableAreaGroups follows

function hide( id ) {
	try {
		my_getelementbyid( id ).style.display = "none";
	}
	catch ( dontcare ) {}
};

function show( id ) {
	try {
		my_getelementbyid( id ).style.display = "";
	}
	catch ( dontcare ) {}
};

function check( something ) {
	try {
		if ( something ) {
			return true;
		}
	}
	catch ( e ) {}
	return false;
};

function refresh( form, focusedElement, refreshOperation, refreshType, otherID ) {
	if ( check( focusedElement ) ) {
		var obj = document.createElement( "input" );
		obj.type = "hidden";
		obj.name = "state_focused_element";
		if ( check( focusedElement.id ) ) {
			obj.value = focusedElement.id;
		}
		else {
			obj.value = focusedElement;
		}
		form.appendChild( obj );
		var obj = document.createElement( "input" );
		obj.type = "hidden";
		obj.name = "refreshingField";
		if ( check( focusedElement.name ) ) {
			obj.value = focusedElement.name;
		}
		else {
			obj.value = focusedElement;
		}
		form.appendChild( obj );
	}
	var obj = document.createElement( "input" );
	obj.type = "hidden";
	obj.name = "refreshType";
	if ( refreshType ) {
		obj.value = refreshType;
	}
	else {
		obj.value = "fieldChange";
	}
	form.appendChild( obj );

	if ( check( otherID ) ) {
		var input = document.getElementsByName( "otherID" );
		if ( input && input.length > 0 ) {
			input[ 0 ].value = otherID;
		}
		else {
			var obj = document.createElement( "input" );
			obj.type = "hidden";
			obj.name = "otherID";
			obj.value = otherID;
			form.appendChild( obj );
		}
	}

	if ( !refreshOperation )
		refreshOperation = 'Refresh';
	doSubmit( form, refreshOperation );
};

var expButton = "/cases/art/expandGroup.gif";
var collButton = "/cases/art/collapseGroup.gif";
var expButtonW = 0;
var expButtonH = 0;
var collButtonW = 0;
var collButtonH = 0;
function setState( propName, propValue ) {
	input = my_getelementbyid( propName );
	while ( input.value != propValue ) {
		input.value = propValue;
	}
};

function showCollapsed( id, dontRemember, collapseLabel, expandLabel ) {
	show( id + "_tr" );
	link = my_getelementbyid( id + "_lnk" );
	link.href = "javascript:collapse('" + id + "', false, '" + collapseLabel + "', '" + expandLabel + "')";
	if ( link.hasChildNodes() ) {
		link.removeChild( link.lastChild );
	}
	getImage2node( link, collButton, collButtonW, collButtonH, collapseLabel );
	if ( !dontRemember ) {
		try {
			setState( "stateCollapsed_" + id, "false" );
		}
		catch ( nocare ) {} // this will fail in the XML editor
	}
};

function collapse( id, dontRemember, collapseLabel, expandLabel ) { 
	hide( id + "_tr" );
	link = my_getelementbyid( id + "_lnk" );
	link.href = "javascript:showCollapsed('" + id + "', false, '" + collapseLabel + "', '" + expandLabel + "')";
	if ( link.hasChildNodes() ) {
		link.removeChild( link.lastChild );
	}
	getImage2node( link, expButton, expButtonW, expButtonH, expandLabel );
	if ( !dontRemember ) {
		try {
			setState( "stateCollapsed_" + id, "true" );
		}
		catch ( nocare ) {} // this will fail in the XML editor
	}
};

// function for ForeignIDSelectorInputMacro

function removeEmptyLine( fieldID ) {
	selectField = my_getelementbyid( "qe_" + fieldID );
	if ( selectField.length > 0 && selectField.options[ 0 ].value.length < 1 ) {
		selectField.options[ 0 ] = null;
	}
};

function adjustCBState( checkbox, id, dorefresh ) {
	var hidden = my_getelementbyid( id );
	hidden.value = checkbox.checked ? 'yes' : 'no';
	if ( dorefresh ) {
		refresh( self.document.saveForm, hidden );
	}
};

function adjustCBStateTrueFalse( checkbox, id, dorefresh ) {
	var hidden = my_getelementbyid( id );
	hidden.value = checkbox.checked ? 'true' : 'false';
	if ( dorefresh ) {
		refresh( self.document.saveForm, hidden );
	}
};

function getDTRepresentative( idBase ) {
	if ( idBase.lastIndexOf( "_t" ) == idBase.length - 2 ) {
		// for DA_TM time parts call with <fieldid>_t, while date parts with
		// <fieldid>_d
		idBase = idBase.substring( 0, idBase.length - 1 ) + "d";
	}
	element = my_getelementbyid( idBase + "_yr" ); // DA[_TM]
	if ( !element ) {
		element = my_getelementbyid( idBase + "_hr" ); // TM
	}
	return element;
};

function setDTAltered( idBase ) {
	var element = getDTRepresentative( idBase );
	while ( element.altered != "true" ) {
		element.altered = "true";
	}
};

function refreshIfAltered( form, input, idBase ) {
	var element = getDTRepresentative( idBase );
	if ( element.altered == "true" ) {
		refresh( form, input );
	}
};

function setDTFocused( form, input, idBase, focused ) {
	var element = getDTRepresentative( idBase );
	DTTimeout = false;
	if ( focused ) {
		focused = "true";
	}
	else {
		focused = "false";
		DTTimeout = setTimeout( function() {
			refreshIfAltered( form, input, idBase );
		}, 100 );
	}
	while ( element.focused != focused ) {
		element.focused = focused;
	}
	if ( !DTTimeout ) {
		if ( element.timeoutevent ) {
			clearTimeout( element.timeoutevent );
		}
	}
	while ( element.timeoutevent != DTTimeout ) {
		element.timeoutevent = DTTimeout;
	}
};

function toggleCB( id ) {
	input = my_getelementbyid( id );
	img = my_getelementbyid( id + "_img" );
	if ( input.value == "true" ) {
		// turn off
		while ( input.value != "false" ) {
			input.value = "false";
		}
		img.src = "/imadmin/art/cross.gif";
	}
	else {
		// turn on
		while ( input.value != "true" ) {
			input.value = "true";
		}
		img.src = "/imadmin/art/check.gif";
	}
};

var partialSubmit = false; // this is used by batch-edit

function loadImages() {
	var images = document.getElementsByTagName( "IMG" );
	try {
		for (var i = 0; i < images.length; i++) {
			var img = images[ i ];
			if ( img.src ) {
				continue;
			}
			if ( img.getAttribute( "pitty" ) ) {
				img.src = img.getAttribute( "pitty" );
			}
		}
	}
	catch ( e ) {}
}

var pageLoaded = false;

addLoadEvent( function() {
	pageLoaded = true;
}, 9 );

function isPageLoaded() {
	return pageLoaded;
};

// ---- StudyElementIterator related stuff follows ----

var seiSizes = new Array();

var seiButtonWrappers = new Array();

function getSeiSize( iteratorID ) {
	if ( typeof seiSizes[ iteratorID ] == 'undefined' ) {
		var n = -1;
		while ( getSeiElement( iteratorID, ++n ) ) {}
		seiSizes[ iteratorID ] = n;
	}
	return seiSizes[ iteratorID ];
};

var seiScrollPositions = new Array();

var verticalSeis = new Array();

function getSeiElement( iteratorID, pos ) {
	return my_getelementbyid( iteratorID + "_element" + pos );
};

function getSeiScrollPos( iteratorID ) {
	var res = 0;
	if ( typeof seiScrollPositions[ iteratorID ] != 'undefined' ) {
		res = seiScrollPositions[ iteratorID ];
	}
	return res;
};

function isSeiFirst( iteratorID ) {
	return getSeiScrollPos( iteratorID ) < 1;
};

function getSeiPanel( iteratorID ) {
	return my_getelementbyid( iteratorID + "_contentPanel" );
};

function isSeiLast( iteratorID ) {
	if ( getSeiSize( iteratorID ) < 1 || getSeiScrollPos( iteratorID ) == getSeiSize( iteratorID ) - 1 ) {
		return true;
	}
	var div = getSeiPanel( iteratorID );
	if ( verticalSeis[ iteratorID ] ) {
		return div.scrollTop + ( div.clientHeight || div.offsetHeight ) >= div.scrollHeight;
	}
	else {
		return div.scrollLeft + ( div.clientWidth || div.offsetWidth ) >= div.scrollWidth;
	}
};

function updateSeiButtons( iteratorID ) {
	var prevButton = my_getelementbyid( iteratorID + "_prevButton" );
	if ( !prevButton ) {
		// buttons are missing
		return;
	}
	if ( prevButton.nodeName.toLowerCase() == 'button' ) {
		if ( !seiButtonWrappers[ iteratorID + "_prevButton" ] ) {
			seiButtonWrappers[ iteratorID + "_prevButton" ] = new ButtonWrapper( prevButton, prevButton.className );
		}
		seiButtonWrappers[ iteratorID + "_prevButton" ].setEnabled( !isSeiFirst( iteratorID ) );
	}
	else if ( isSeiFirst( iteratorID ) ) {
		if ( prevButton.src.indexOf( ".d." ) < 0 ) {
			var p = prevButton.src.indexOf( "." );
			prevButton.src = prevButton.src.substr( 0, p ) + ".d" + prevButton.src.substr( p );
		}
	}
	else {
		if ( prevButton.src.indexOf( ".d." ) > -1 ) {
			prevButton.src = prevButton.src.replace( ".d.", "." );
		}
	}
	var nextButton = my_getelementbyid( iteratorID + "_nextButton" );
	if ( nextButton.nodeName.toLowerCase() == 'button' ) {
		if ( !seiButtonWrappers[ iteratorID + "_nextButton" ] ) {
			seiButtonWrappers[ iteratorID + "_nextButton" ] = new ButtonWrapper( nextButton, nextButton.className );
		}
		seiButtonWrappers[ iteratorID + "_nextButton" ].setEnabled( !isSeiLast( iteratorID ) );
	}
	else if ( isSeiLast( iteratorID ) ) {
		if ( nextButton.src.indexOf( ".d." ) < 0 ) {
			var p = nextButton.src.indexOf( "." );
			nextButton.src = nextButton.src.substr( 0, p ) + ".d" + nextButton.src.substr( p );
		}
	}
	else {
		if ( nextButton.src.indexOf( ".d." ) > -1 ) {
			nextButton.src = nextButton.src.replace( ".d.", "." );
		}
	}
};

var noteSeiID = false;

function initSei( iteratorID, vertical ) {
	if ( vertical ) {
		verticalSeis[ iteratorID ] = true;
		noteSeiID = iteratorID;
	}
	addLoadEvent( function() {
		updateSeiButtons( iteratorID );
	} );
};

function getPadding( iteratorID ) {
	try {
		var div = getSeiPanel( iteratorID );
		var element = getSeiElement( iteratorID, 0 );
		if ( verticalSeis[ iteratorID ] ) {
			return element.offsetTop - div.offsetTop;
		}
		else {
			return element.offsetLeft - div.offsetLeft;
		}
	}
	catch ( e ) {}
	return 0;
};

function stepSei( iteratorID, toPrev ) {
	if ( toPrev && isSeiFirst( iteratorID ) || !toPrev && isSeiLast( iteratorID ) ) {
		updateSeiButtons( iteratorID );
		return;
	}
	var scrollPos = getSeiScrollPos( iteratorID );
	if ( toPrev ) {
		scrollPos--;
	}
	else {
		scrollPos++;
	}
	var div = getSeiPanel( iteratorID );
	var element = getSeiElement( iteratorID, scrollPos );
	if ( verticalSeis[ iteratorID ] ) {
		div.scrollTop = element.offsetTop - ( div.offsetTop + getPadding( iteratorID ) );
	}
	else {
		div.scrollLeft = element.offsetLeft - ( div.offsetLeft + getPadding( iteratorID ) );
	}
	seiScrollPositions[ iteratorID ] = scrollPos;
	updateSeiButtons( iteratorID );
};

function checkUnsavedNotes( tl ) {
	var studyImIframe = imIFrames[ tl.iframeID ];
	for (var i = 0; i < tl.objects.length; i++) {
		var studyCell = tl.objects[ i ];
		var studyFrame = studyImIframe.cache[ studyCell.ID ];
		if ( studyFrame && studyFrame.contentWindow.noteFrameID ) {
			var noteImIframe = studyFrame.contentWindow.imIFrames[ studyFrame.contentWindow.noteFrameID ];
			if ( noteImIframe ) {
				var newNoteFrame = noteImIframe.cache[ studyFrame.contentWindow.getNoteURL( studyCell.styiuid, 'new' ) ];
				if ( newNoteFrame ) {
					var val = new String( newNoteFrame.contentWindow.document.forms[ 0 ].text.value );
					if ( val.trim().length > 0 ) {
						tl.setActual( studyCell.ID );
						noteImIframe.loadFrame( studyFrame.contentWindow.getNoteURL( studyCell.styiuid, 'new' ) );
						return true;
					}
				}
			}
		}
	}
	return false;
};

/**
 * Logs the entry on the server
 * 
 * uses: imPopup.js
 * 
 * @param strLayoutType String the layout type
 * @param strAction String the action name (with prefix)
 * @param arStrFieldNames Array of String - the field names (not simple colids) of the fields to get values from the form and pass as update data
 * @param strInfo The information field's value - passed to the server to parse
 * @param strPlusparams Other params to pass, starting with "&"
 */
function logOnServer( strLayoutType, strAction, arStrFieldNames, strInfo, strPlusparams ) {
	var strEntryName = getTagValue( "cEntryName", "" );

	var params = "cEntryName=" + strEntryName + "&cLayoutType=" + strLayoutType + "&cAction=" + strAction;
	if ( strInfo != "" && strInfo != undefined ) {
		// alert( "info:" + strInfo );

		// parse info, change |colid|fieldname| -> |colid|value|
		var newInfo = "";

		pos = strInfo.indexOf( "|" );
		while ( pos != -1 ) {
			text = strInfo.substring( 0, pos + 1 );
			newInfo += text; // | included
			strInfo = strInfo.substring( pos + 1 );
			pos = strInfo.indexOf( "|" );
			if ( pos != -1 ) {
				colid = strInfo.substring( 0, pos + 1 );
				newInfo += colid; // | included
				strInfo = strInfo.substring( pos + 1 );
				pos = strInfo.indexOf( "|" );
				if ( pos != -1 ) {
					fieldname = strInfo.substring( 0, pos );
					value = getInputFieldContent( fieldname );
					if ( value != undefined ) {
						newInfo += value;
					}
					newInfo += "|";
					strInfo = strInfo.substring( pos + 1 );
					pos = strInfo.indexOf( "|" );
				}
			}
		}
		newInfo += strInfo;

		// alert( "new info:" + newInfo );

		params += "&cInfo=" + newInfo;
	}
	if ( strPlusparams != "" && strPlusparams != undefined ) {
		params += strPlusparams;
	}
	for (var i = 0; i < arStrFieldNames.length; i++) {
		var fieldValue = getInputFieldContent( arStrFieldNames[ i ] );

		// alert( "fieldname:" + arStrFieldNames[ i ] + " value:" + fieldValue );

		if ( fieldValue != undefined ) {
			params += "&qe_" + arStrFieldNames[ i ] + "=" + escape( fieldValue );
		}
	}

	// alert( "params:" + params );

	var objRetval = jsPost( "/cases/makeLog.jsp", params );
	alert( objRetval.text );

};

function escape_utf8( data ) {
	if ( data == '' || data == null ) {
		return '';
	}
	data = data.toString();
	var buffer = '';
	for (var i = 0; i < data.length; i++) {
		var c = data.charCodeAt( i );
		var bs = new Array();
		if ( c >= 0x10000 ) {
			// 4 bytes
			bs[ 0 ] = 0xF0 | ( ( c & 0x1C0000 ) >>> 18 );
			bs[ 1 ] = 0x80 | ( ( c & 0x3F000 ) >>> 12 );
			bs[ 2 ] = 0x80 | ( ( c & 0xFC0 ) >>> 6 );
			bs[ 3 ] = 0x80 | ( c & 0x3F );
		}
		else if ( c >= 0x800 ) {
			// 3 bytes
			bs[ 0 ] = 0xE0 | ( ( c & 0xF000 ) >>> 12 );
			bs[ 1 ] = 0x80 | ( ( c & 0xFC0 ) >>> 6 );
			bs[ 2 ] = 0x80 | ( c & 0x3F );
		}
		else if ( c >= 0x80 ) {
			// 2 bytes
			bs[ 0 ] = 0xC0 | ( ( c & 0x7C0 ) >>> 6 );
			bs[ 1 ] = 0x80 | ( c & 0x3F );
		}
		else {
			// 1 byte
			bs[ 0 ] = c;
		}
		if ( bs.length == 1 ) {
			buffer += escape( String.fromCharCode( bs[ 0 ] ) );
		}
		else {
			for (var j = 0; j < bs.length; j++) {
				var b = bs[ j ];
				var hex = nibble_to_hex( ( b & 0xF0 ) >>> 4 ) + nibble_to_hex( b & 0x0F );
				buffer += '%' + hex;
			}
		}
	}
	return buffer;
};

function nibble_to_hex( nibble ) {
	var chars = '0123456789ABCDEF';
	return chars.charAt( nibble );
};

var multiSelectHandlers = {};

function registerMSH( fieldID, listfile, listColid, separator, dispSeparator, isUnique, selectMaxSize ) {
	multiSelectHandlers[ fieldID ] = new MultiSelectHandler( fieldID, listfile, listColid, separator, dispSeparator, isUnique, selectMaxSize );
};

var mshShaderDiv = null;

function getMshShader() {
	if ( mshShaderDiv == null ) {
		document.body.style.position = "relative";
		mshShaderDiv = document.createElement( "div" );
		mshShaderDiv.style.left = "0px";
		mshShaderDiv.style.top = "0px";
		mshShaderDiv.style.margin = "0px";
		mshShaderDiv.style.position = "absolute";
		mshShaderDiv.style.zIndex = "10";
		mshShaderDiv.style.backgroundColor = "#C0C0C0";
		mshShaderDiv.style.opacity = 0.4;
		mshShaderDiv.style.filter = "alpha(opacity=40)";
	}
	if ( isFirefox ) {
		mshShaderDiv.style.right = "0px";
		mshShaderDiv.style.bottom = "0px";
	}
	else {
		mshShaderDiv.style.width = document.body.scrollWidth + "px";
		mshShaderDiv.style.height = document.body.scrollHeight + "px";
	}
	return mshShaderDiv;
};

var mshPopupDiv = null;

function getMshPopup() {
	if ( mshPopupDiv == null ) {
		mshPopupDiv = new DraggableHoverDiv( true );
		// add buttons
		mshPopupDiv.hoverDiv.appendChild( document.createElement( "br" ) );
		var buttonsDiv = document.createElement( "div" );
		buttonsDiv.style.float = "right";
		buttonsDiv.style.whiteSpace = "nowrap";
		mshPopupDiv.hoverDiv.appendChild( buttonsDiv );
		mshPopupDiv.okButton = createDynamicButton( "OK" );
		var cancelButton = createDynamicButton( "Cancel" );
		addEventListenerTo( cancelButton, "click", function() {
			getMshPopup().hide();
		} );

		buttonsDiv.appendChild( mshPopupDiv.okButton );
		buttonsDiv.appendChild( cancelButton );
	}
	return mshPopupDiv;
};

function MultiSelectHandler( fieldID, listfile, listColid, separator, dispSeparator, isUnique, selectMaxSize ) {

	this.fieldID = fieldID;
	this.hiddenField = my_getelementbyid( fieldID );
	this.displayedField = my_getelementbyid( fieldID + "_mviTxt" );
	this.listFile = listfile;
	this.listColid = listColid;
	this.separator = separator;
	this.isUnique = isUnique;
	this.dispSeparator = dispSeparator;
	this.selectMaxSize = selectMaxSize;

	this.getValues = function( fromHidden ) {
		var srcSeparator = fromHidden ? this.separator : this.dispSeparator;
		var vals = ( fromHidden ? this.hiddenField : this.displayedField ).value.split( srcSeparator );
		var res = new Array();
		var badChar = false;
		if ( srcSeparator == unescape( "%0A" ) ) {
			// remove trailing %0D characters for proper newline separation on windows
			badChar = unescape( "%0D" );
		}
		for (var i = 0; i < vals.length; i++) {
			if ( badChar && vals[ i ].endsWith( badChar ) ) {
				vals[ i ] = vals[ i ].substr( 0, vals[ i ].length - 1 );
			}
			// zero length values are banned as an empty string could mean one empty string value or no values at all
			if ( this.isUnique && res.indexOf( vals[ i ] ) != -1 || vals[ i ].length == 0 ) {
				continue;
			}
			res.push( vals[ i ] );
		}
		return res;
	};

	this.setValues = function( values ) {
		this.displayedField.value = values.join( this.dispSeparator );
		this.hiddenField.value = values.join( this.separator );
	};

	// initially the value is in the hidden field, let's initialise the displayed field.
	this.setValues( this.getValues( true ) );

	this.updateHidden = function() {
		this.setValues( this.getValues( false ) );
	};

	this.showPopup = function( event ) {
		var popup = getMshPopup();
		// generate the content
		while ( popup.contentDiv.hasChildNodes() )
			popup.contentDiv.removeChild( popup.contentDiv.firstChild );
		popup.select = document.createElement( "select" );
		popup.select.multiple = true;
		populateSelectBox( popup.select, this.fieldID, this.listColid, this.listFile, true );
		var sysVals = new Array();
		for (var i = popup.select.options.length - 1; i >= 0; i--) {
			sysVals[ i ] = popup.select.options[ i ].value;
			popup.select.options[ i ] = null;
		}

		var selVals = this.getValues();
		for (var i = 0; i < selVals.length; i++) {
			var option = new Option( selVals[ i ], selVals[ i ] );
			option.selected = true;
			popup.select.options[ popup.select.options.length ] = option;
			var p = sysVals.indexOf( selVals[ i ] );
			if ( p != -1 ) {
				sysVals.splice( p, 1 ); // remove this value, it is already added
			}
		}
		for (var i = 0; i < sysVals.length; i++) {
			var option = new Option( sysVals[ i ], sysVals[ i ] );
			option.selected = false;
			popup.select.options[ popup.select.options.length ] = option;
		}

		popup.select.size = Math.min( this.selectMaxSize, popup.select.options.length );
		popup.contentDiv.appendChild( popup.select );

		popup.position( getEventX( event ), getEventY( event ) );
		popup.fieldID = this.fieldID;
		addEventListenerTo( popup.okButton, "click", function() {
			multiSelectHandlers[ getMshPopup().fieldID ].submitPopup();
		} );
		popup.show();
	};

	this.submitPopup = function() {
		var popup = getMshPopup();
		var values = new Array();
		for (var i = 0; i < popup.select.options.length; i++) {
			if ( popup.select.options[ i ].selected ) {
				values.push( popup.select.options[ i ].value );
			}
		}
		this.setValues( values );
		popup.hide();
	};
};

function addEventListenerTo( element, event, func ) {
	if ( element.addEventListener ) { // all browsers except IE before version 9
		element.addEventListener( event, func, false );
	}
	else {
		if ( element.attachEvent ) { // IE before version 9
			element.attachEvent( "on" + event, func );
		}
	}
};

function getEventX( event ) {
	if ( event.clientX )
		return event.clientX;
	if ( event.screenX )
		return event.screenX;
	return event.pageX;
};

function getEventY( event ) {
	if ( event.clientY )
		return event.clientY;
	if ( event.screenY )
		return event.screenY;
	return event.pageY;
};

var draggedHoverDiv = null;

function hoverOnMouseUp() {
	draggedHoverDiv = null;
};

function hoverOnMouseMove( event ) {
	if ( draggedHoverDiv == null ) {
		return;
	}
	var x = getEventX( event );
	var y = getEventY( event );
	draggedHoverDiv.hoverDiv.style.left = ( x - draggedHoverDiv.deltaX ) + "px";
	draggedHoverDiv.hoverDiv.style.top = ( y - draggedHoverDiv.deltaY ) + "px";
};

addLoadEvent( function() {
	addEventListenerTo( document.body, "mouseup", function( event ) {
		hoverOnMouseUp( event );
	} );
} );

addLoadEvent( function() {
	addEventListenerTo( document.body, "mousemove", function( event ) {
		hoverOnMouseMove( event );
	} );
} );

function DraggableHoverDiv( modal, closable ) {
	this.modal = modal;
	this.closable = closable;
	this.hoverDiv = document.createElement( "div" );
	this.hoverDiv.className = "popup";
	this.hoverDiv.style.zIndex = "20";
	this.grabDiv = document.createElement( "div" );
	this.grabDiv.style.width = "23px";
	this.grabDiv.style.marginBottom = "2px";
	this.grabDiv.style.marginTop = "1px";
	this.grabDiv.style.cursor = "move";
	this.grabDiv.style.backgroundImage = "url(/art/img/MoveCursor.gif)";
	this.grabDiv.style.height = "23px";

	if ( closable ) {
		this.closeBtn = $( '<img/>' );
		this.closeBtn.css( 'cursor', 'pointer' );
		this.closeBtn.css( 'position', 'absolute' );
		this.closeBtn.css( 'top', '1px' );
		this.closeBtn.css( 'right', '1px' );
		this.closeBtn.attr( 'src', '/art/b/cancelButton.gif' );
		this.closeBtn.data( 'parent', this );
		this.closeBtn.click( function() {
			$( this ).data( 'parent' ).hide();
		} );
		this.closeBtn.appendTo( this.hoverDiv );
	}

	this.grabDiv.handler = this;
	this.hoverDiv.appendChild( this.grabDiv );
	this.contentDiv = document.createElement( "div" );
	this.hoverDiv.appendChild( this.contentDiv );
	document.body.appendChild( this.hoverDiv );

	this.deltaX = 0;
	this.deltaY = 0;

	this.onMouseDown = function( event ) {
		draggedHoverDiv = this;
		this.deltaX = getEventX( event ) - calcElementLeft( this.hoverDiv );
		this.deltaY = getEventY( event ) - calcElementTop( this.hoverDiv );
	};

	addEventListenerTo( this.grabDiv, "mousedown", function( event ) {
		if ( event.srcElement ) {
			event.srcElement.handler.onMouseDown( event );
		}
		else {
			this.handler.onMouseDown( event );
		}
	} );

	this.show = function() {
		if ( this.modal ) {
			document.body.appendChild( getMshShader() );
		}
		this.hoverDiv.style.visibility = "visible";
	};

	this.isShown = function() {
		return this.hoverDiv.style.visibility == "visible";
	};

	this.hide = function() {
		if ( this.modal ) {
			document.body.removeChild( getMshShader() );
		}
		this.hoverDiv.style.visibility = "hidden";
	};

	this.position = function( x, y ) {
		var scrollX = ( document.all ) ? document.body.scrollLeft : window.pageXOffset;
		var scrollY = ( document.all ) ? document.body.scrollTop : window.pageYOffset;
		if ( x === undefined ) {
			// called without params, center div on the screen
			x = ( document.body.clientWidth - this.hoverDiv.clientWidth ) / 2;
			y = ( document.body.clientHeight - this.hoverDiv.clientHeight ) / 2;
		}
		var divLeft = x + scrollX;
		var divTop = y + scrollY;
		var divRight = divLeft + this.hoverDiv.clientWidth;
		var divBottom = divTop + this.hoverDiv.clientHeight;
		var winRight = scrollX + document.body.clientWidth - 20; // "-20" is to avoid placing under a scrollbar
		var winBottom = scrollY + document.body.clientHeight - 20; // "-20" is to avoid placing under a scrollbar
		if ( divBottom > winBottom ) {
			divTop = Math.max( scrollY, divTop - divBottom + winBottom );
		}
		if ( divRight > winRight ) {
			divLeft = Math.max( scrollX, divLeft - divRight + winRight );
		}
		this.hoverDiv.style.left = divLeft + "px";
		this.hoverDiv.style.top = divTop + "px";

	};
};

function UndoItem( eventType ) {

	this.inputID = getFocusedFieldName();
	this.selection = getFieldSelection( this.inputID );

	// recognised event types: onChange, onFocus, onEvent, undefined
	this.eventType = eventType;

	if ( 'rte' == TYPES[ this.inputID ] ) {
		this.content = returnRTE( this.inputID ).cloneNode( true );
		this.innerHTML = returnRTE( this.inputID ).innerHTML;
	}
	else {
		this.content = getInputFieldContent( this.inputID );
	}

	this.matches = function( other ) {
		if ( this.innerHTML ) {
			return other.innerHTML && this.innerHTML == other.innerHTML;
		}
		return this.content == other.content;
	};

	this.apply = function() {
		if ( 'rte' == TYPES[ this.inputID ] ) {
			var oldDiv = returnRTE( this.inputID );
			oldDiv.parentNode.insertBefore( this.content, oldDiv );
			oldDiv.parentNode.removeChild( oldDiv );
			// setInputFieldContent( this.inputID + "_html", this.content );
		}
		else {
			setInputFieldContent( this.inputID, this.content );
		}
		setSelection( this.inputID, this.selection[ 0 ], this.selection[ 1 ] );
	};
};

var undoQueue = new Array(); // inputID -> UndoItem[]
var undoQueueLimit = 10;
var lastUndoActionWasMark;

function getUndoQueue( inputID ) {
	if ( !inputID ) {
		return null;
	}
	if ( !undoQueue[ inputID ] ) {
		undoQueue[ inputID ] = new Array();
	}
	return undoQueue[ inputID ];
};

function markUndo() {
	// alert( "markUndo called" );
	markEventUndo();
};

function markEventUndo( eventType, event ) {
	return; // we try to get IE's undo working for now
/*	var undoItem = new UndoItem( eventType );
	var inputQueue = getUndoQueue( undoItem.inputID );
	if ( "onFocus" == eventType && inputQueue.length > 0 ) {
		return;
	}
	if ( "onEvent" == eventType ) {
		// event is a jquery event
		DEBUG( "event received" );
		return;
	}
	if ( inputQueue.length == undoQueueLimit ) {
		inputQueue.shift();
	}
	inputQueue.push( undoItem );
	if ( !eventType ) {
		// for viewer driver speech recognize related function we have this kludge
		lastUndoActionWasMark = true;
	}*/
};

function doUndo() {
	return false; // we try to get IE's undo working for now
/*	var inputQueue = getUndoQueue( getFocusedFieldName() );
	// DEBUG( "called doUndo" );
	if ( lastUndoActionWasMark ) {
		// the last snapshot contains the current state
		inputQueue.pop();
	}
	if ( inputQueue.length > 0 ) {
		lastUndoActionWasMark = false;
		inputQueue.pop().apply();
		if ( inputQueue.length == 0 ) {
			// if the queue is empty, store the current state as starting reference
			markEventUndo( "onFocus" );
		}
		return true;
	}
	return false;*/
};
