// Swipe magic

var swipePos;
var swipeScroll;
var swipeCB;

function animateSwipe() {
	var lp = document.getElementById( 'list_panel' );
	var wl = document.getElementById( 'worklist' );

	swipePos += swipeDir;

	if ( swipePos < 0 ) {
		// fully in;
		wl.style.display = 'none';
		lp.style.top = 0;
		lp.style.position = 'relative';
		document.body.scrollTop = 0;
		if ( swipeCB != undefined )
			swipeCB();
		//		setTimeout('document.body.scrollTop=0',1000);
		return;
	}
	if ( swipePos > 100 ) {
		lp.style.display = 'none';
		if ( swipeCB != undefined )
			swipeCB();
		return;
	}

	// move;
	document.body.scrollTop = swipeScroll;
	lp.style.left = swipePos + "%";
	wl.style.left = ( swipePos - 100 ) + "%";
	setTimeout( animateSwipe, 20 );

};

function swipeIn( cb ) {
	var lp = document.getElementById( 'list_panel' );
	//var wl = document.getElementById( 'worklist' );
	swipeScroll = document.body.scrollTop;
	swipeCB = cb;

	// both will need to be absolute;

	//	wl.style.position='absolute';

	lp.style.position = 'absolute';
	lp.style.top = swipeScroll;
	lp.style.left = "100%";
	lp.style.display = 'block';

	swipePos = 100;
	swipeDir = -10;
	setTimeout( animateSwipe, 50 );
};

function swipeOut( cb ) {
	var lp = document.getElementById( 'list_panel' );
	var wl = document.getElementById( 'worklist' );
	swipeCB = cb;
	swipePos = 0;
	swipeDir = 10;
	setTimeout( animateSwipe, 50 );

	lp.style.top = swipeScroll;
	lp.style.position = 'absolute';
	wl.style.display = 'block';
	document.body.scrollTop = swipeScroll;

	//	document.getElementById('list_panel').style.display='none';
};

// fill out details for selected study 

function showDetails( e, i ) {
	shownRec = e;
	savedBg = e.style.background;
	e.style.background = "#C0C0CC";

	var s = "<TABLE>";
	for ( c in wldata.fields ) {
		s += "<TR><TD class='dt_label'>" + wldata.fields[ c ] + "</TD><TD class='dt_value'>" + wldata.data[ i ][ c ] + "</TD></TR>\n";
	}
	s += "</TABLE>";

	document.getElementById( 'dt_content' ).innerHTML = s;
	document.getElementById( 'dt_header' ).innerHTML = wldata.data[ i ].PANM;

	// add report
	divrep = document.createElement( 'iframe' );
	divrep.style.width = "100%";
	//	divrep.style.right=0;
	//	divrep.style.minHeight="100%";
	//	divrep.style.height="100%";
	divrep.style.overflowX = "auto";
	divrep.onload = function() {
		//		alert('boo');
		var h;
		var doc = this.contentDocument ? this.contentDocument : this;
		h = this.contentDocument ? this.contentDocument.body.offsetHeight : this.body.scrollHeight;
		//		doc.body.onclick=function() { return parent.hideDetails(); } ;
		doc.body.style.cursor = 'pointer';
		//		alert(h+" " + doc.body.innerHTML.substring(0,100));
		doc.body.innerHTML = "<div onclick='return parent.hideDetails();'>" + doc.body.innerHTML + "</div>";
		this.style.height = ( h + 80 );
		this.height = ( h + 80 );
	};
	//	divrep.onclick= function() { return hideDetails(); } ;

	//	divrep.src="/cases/reportview.jsp?cGr="+wldata.data[i].SSUI+"&cPrintFriendly=true";
	//	divrep.src="/cases/reportPartView.jsp?cSrcStudy="+wldata.data[i].SYUI+"&cIndex=0";
	document.getElementById( 'dt_content' ).appendChild( divrep );

	swipeIn( function() {
		divrep.src = "/cases/reportview.jsp?cGr=" + wldata.data[ i ].SSUI + "&cPrintFriendly=true" + mobileTemplateParam;
		//		divrep.src="/cases/reportPartView.jsp?cSrcStudy="+wldata.data[i].SSUI+"&cIndex=0";
		document.body.scrollTop = 0;

	} );

};

var shownRec = null; // div 
var savedBg;
function hideDetails() {
	//	if (shownRec) shownRec.style.background=savedBg;
	swipeOut( function() {
		if ( shownRec )
			shownRec.style.background = savedBg;
	} );
	return false;
};

// create worklist from json data 

function openStudy( uid ) {
	var loc = openUrlBase + uid;//<%= qs==null ? "%3F" : "%26" %>cScrollPos%3D"+document.body.scrollTop;
	if ( openURLTail ) {
		loc += openURLTail;
	}
	document.location = loc;
};

var renderedLines = 0;

function fillWl() {
	var wl = wldata.data;
	var cont = document.getElementById( 'list_container' );
	while ( renderedLines < wl.length ) {
		var i = renderedLines++;
		//for ( i = 0; i < wl.length; i++ ) {
		var a_rec = document.createElement( 'span' );

		a_rec.onclick = function( u ) {
			return function() {
				openStudy( u );
				return false;
			};
		}( wl[ i ].SYUI );
		a_rec.style.cursor = "pointer";

		var div_rec = document.createElement( 'div' );
		div_rec.className = "wl_record";
		div_rec.appendChild( a_rec );

		var div_pat = document.createElement( 'div' );
		div_pat.className = "wl_patient";
		div_pat.innerHTML = wl[ i ].PANM;
		a_rec.appendChild( div_pat );

		var div_mod = document.createElement( 'div' );
		div_mod.className = "wl_mod";
		div_mod.innerHTML = wl[ i ].MODY;
		a_rec.appendChild( div_mod );

		var div_time = document.createElement( 'div' );
		div_time.className = "wl_time";
		div_time.innerHTML = wl[ i ].DATE;
		a_rec.appendChild( div_time );

		var div_descr = document.createElement( 'div' );
		div_descr.className = "wl_desc";
		div_descr.innerHTML = wl[ i ].DSCR;
		a_rec.appendChild( div_descr );

		var div_body = document.createElement( 'div' );
		div_body.className = "wl_body";
		div_body.innerHTML = wl[ i ].BDYP;
		a_rec.appendChild( div_body );

		var div_det = document.createElement( 'div' );
		div_det.className = "wl_detail";
		div_det.innerHTML = "&gt;";
		div_det.onclick = function( elem, index ) {
			return function() {
				showDetails( elem, index );
				return true;
			};
		}( div_rec, i );
		div_rec.appendChild( div_det );
		div_rec.style.cursor = "pointer";

		//		a_rec.appendChild(div_rec);
		cont.appendChild( div_rec );

	}
};

function loadMore() {
	// ajax request from filled filled +10
	var xhReq = new XMLHttpRequest();
	xhReq.open( "get", fillMoreUrlBase + "&incContext=" + escape( wldata.incrementalContext ) + "&count=10", true );
	xhReq.onreadystatechange = function() {
		if ( xhReq.readyState != 4 ) {
			return; // pending
		}
		if ( xhReq.status != 200 ) {
			document.getElementById( 'list_loading' ).innerHTML = "<font color=red>Error loading studies...</font>";
			return;
		}
		var serverResponse = eval( "(" + xhReq.responseText.trim() + ")" );

		if ( serverResponse.error ) {
			document.getElementById( 'list_loading' ).style.display = 'none';
			alert( serverResponse.error );
			return;
		}

		wldata.isComplete = serverResponse.isComplete;
		wldata.incrementalContext = serverResponse.incrementalContext;
		wldata.data.push.apply( wldata.data, serverResponse.data ); // heh, that's cool stuff :)

		fillWl();
		document.getElementById( 'list_loading' ).style.display = 'none';
		if ( !wldata.isComplete ) {
			document.getElementById( 'list_more' ).style.display = 'block';
		}

	};
	document.getElementById( 'list_more' ).style.display = 'none';
	document.getElementById( 'list_loading' ).style.display = 'block';
	xhReq.send( null );

};
