function checkForLocalStudies() {
	var remoteStudies = new Array();
	for ( var i = 0; i < timeLine.objects.length; i++ ) {
		if ( !timeLine.objects[ i ].ID.startsWith( "LOCAL_" ) ) {
			remoteStudies.push( timeLine.objects[ i ].styiuid );
		}
	}
	if ( remoteStudies.length > 0 ) {
		$.getJSON( "/cases/studyManager.jsp?cRefresh=true&timestamp=" + ( new Date() ).getTime() + "&cGr=" + remoteStudies.join( ";" ), function( res ) {
			if ( typeof res == 'string' ) {
				alert( "updating studyManager failed: " + res );
				return;
			}
			if ( res.length > 0 ) {
				var firstCellID = null;
				for ( var i = 0; i < res.length; i++ ) {
					var styiuid = res[ i ];
					for ( var i = 0; i < timeLine.objects.length; i++ ) {
						if ( timeLine.objects[ i ].styiuid == styiuid ) {
							var oldTC = timeLine.objects[ i ];
							var newTC = new IMTimelineCell( 'LOCAL_' + styiuid, styiuid, oldTC.date, oldTC.content, appendURLBase + styiuid );
							if ( firstCellID == null ) {
								firstCellID = newTC.ID;
							}
							newTC.setState( false, 'Study', false, false, false, false, false, false, false );
							timeLine.objects.splice( i, 1 );
							timeLine.addObject( newTC );
							break;
						}
					}
					try {
						window.external.appendStudy( styiuid );
					}
					catch ( e ) {
						alert( "appending study failed: " + e );
					}
				}
				timeLine.setActual( firstCellID );
				timeLine.render();
			}
			setTimeout( "checkForLocalStudies()", 10000 );
		} );
		//alert ("remote studies: "+remoteStudies.length);
	}
};

setTimeout( "checkForLocalStudies()", 10000 );

function getUnloadedStudiesCount() {
	var res = 0;
	for ( var i = 0; i < timeLine.objects.length; i++ ) {
		if ( timeLine.objects[ i ].type != "Opened" && timeLine.objects[ i ].type != "Selected" ) {
			res++;
		}
	}
	return res;
};