#!/bin/sh
#
# doBurn.sh id
#

. $HOME/etc/setenv.sh

[ -f "${CD_VAR}/cdwriter.cfg" ] && . ${CD_VAR}/cdwriter.cfg

[ -z "${WRITER_DEV}" ] && WRITER_DEV="0,0,0"
[ -z "${WRITER_OPTS}" ] && WRITER_OPTS="speed=4 driveropts=burnproof"


ID=$1
workDir="$TMP/mediasession/mediasession_${ID}"

touch "$workDir/burning.in.progress"
sudo cdrecord -v dev=${WRITER_DEV} ${WRITER_OPTS} "$workDir/content/cdimage.iso" > "$workDir/burn.log"
rm -f "$workDir/burning.in.progress" >/dev/null

if [ -d "$workDir" ]; then
	if [ -f "$workDir/autoclean.on.finish" ]; then
		echo Cleaning up CD job $ID
		rm -rf "$workDir"
	fi
fi
